SystemOrganization addCategory: #'SqSave-Base'!
SystemOrganization addCategory: #'SqSave-Tests'!
SystemOrganization addCategory: #'SqSave-Connection'!
SystemOrganization addCategory: #'SqSave-UsageExamples'!
SystemOrganization addCategory: #'SqSave-Base-Structures'!
SystemOrganization addCategory: #'SqSave-Analysis'!
SystemOrganization addCategory: #'SqSave-Query'!

!Time class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:31'!
sqsType
	^#time! !

!Time methodsFor: '*sqsave' stamp: 'wh 8/9/2006 01:01'!
asSqlValueString
	^'''',self asString,''''.! !

!String class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:29'!
sqsType
	^#string! !

!String methodsFor: '*sqsave' stamp: 'lr 7/14/2003 11:34'!
asEscapedSql
	^String streamContents: [ :stream |
		self do: [ :char |
			(#($' $\) includes: char)
				ifTrue: [ stream nextPut: char ].
			stream nextPut: char ] ]! !

!String methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:39'!
asSqSaveDescriptionSelector
	| selector |
	selector := self copy asString.
	self ifNotEmpty: [
		selector at: 1 put: (((self at: 1) asUppercase)).	
	].
	^('sqsDescr',selector) asSymbol.! !

!String methodsFor: '*sqsave' stamp: 'tkow 10/6/2008 11:31'!
asSqSaveDescriptorClassName
	^(self capitalized, 'PersistenceDescriptor') asSymbol! !

!String methodsFor: '*sqsave' stamp: 'tk 7/7/2008 15:19'!
asSqSaveTableName
	| |
	^self decamelized,'s'! !

!String methodsFor: '*sqsave' stamp: 'wh 3/2/2006 11:13'!
asSqlValueString
	^'''',self asEscapedSql,''''.! !

!String methodsFor: '*sqsave' stamp: 'tkow 11/18/2008 18:11'!
camelized
	| result prevChar |
	result := WriteStream on: String new.
	prevChar := $t.
	self do: [:char |
		char ~= $_ ifTrue: [
			result nextPut: ((prevChar = $_) ifTrue: [char asUppercase] ifFalse: [char ]).
		]. 
		prevChar := char.		
	].
	^result contents! !

!String methodsFor: '*sqsave' stamp: 'tk 7/7/2008 15:19'!
decamelized
	| result nextChar |
	result := WriteStream on: String new.
	self withIndexDo: [:char :index |
		nextChar := self at: (index + 1) ifAbsent: [$t].
		(((nextChar isLowercase) and: [char isUppercase]) and:[index > 1]) ifTrue: [
			result nextPutAll: '_'.
		].
		result nextPutAll: char asLowercase asString.
	].
	^result contents! !

!JdmConnection methodsFor: '*sqsave' stamp: 'tkow 10/29/2008 14:11'!
finalize
	[self close] ifError: []! !

!JdmConnection methodsFor: '*sqsave' stamp: 'tk 7/18/2008 16:02'!
socket
	^socket! !

ProtoObject subclass: #SqSProxy
	instanceVariableNames: 'sqsProxiedObject sqsProxyOwner sqsProxiedVariable sqsInitialized'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqSProxy subclass: #SqSCollectionProxy
	instanceVariableNames: 'sqsSimpleValues sqsCollectionMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSCollectionProxy class methodsFor: 'cached-creation' stamp: 'tkow 12/2/2008 14:14'!
for: aCollection ofInstVar: anIvarName in: anObject simpleValues: aBool 
	| |
	^ self basicNew
		sqsProxyOwner: anObject;
		sqsSimpleValues: aBool;
		sqsProxiedObject: aCollection;
		sqsProxiedVariable: anIvarName;
		sqsInitialized: true.! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:38'!
sqSaveClass
	^ sqsProxiedObject class! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:06'!
sqsCollectionMap
	^ sqsCollectionMap! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:13'!
sqsCreateCollectionMap
	| tmpMap |
	sqsProxiedObject ifNotNil: 
		[ tmpMap := OrderedCollection new.
		sqsProxiedObject do: 
			[ :obj | 
			| value |
			value := obj ifNotNil: 
				[ sqsSimpleValues 
					ifTrue: [ obj ]
					ifFalse: [ obj oid ] ].
			tmpMap add: value ] ].
	^ tmpMap! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 17:45'!
sqsGetCollectionChanges
	| counter changes newCollectionMap |
	counter := 0.
	newCollectionMap := self sqsCreateCollectionMap.
	changes := SqSCollectionChanges new.
	sqsCollectionMap ifNil: [ ^ changes ].
	sqsCollectionMap do: 
		[ :oid | 
		| newOid |
		counter := counter + 1.
		counter > newCollectionMap size 
			ifTrue: 
				[ changes deletedObjects add: (OrderedCollection 
						with: oid
						with: counter) ]
			ifFalse: 
				[ newOid := newCollectionMap at: counter.
				newOid ~= oid ifTrue: 
					[ changes movedObjects add: (OrderedCollection 
							with: newOid
							with: counter) ] ] ].
	[ counter < newCollectionMap size ] whileTrue: 
		[ counter := counter + 1.
		changes addedObjects add: (OrderedCollection 
				with: (newCollectionMap at: counter)
				with: counter) ].
	sqsCollectionMap := newCollectionMap.
	^ changes! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:24'!
sqsLoadProxiedObject
	sqsInitialized ifNotNil: [ 
		sqsProxiedObject ifNil: [ 
			sqsProxiedObject := (SqSStorage for: sqsProxyOwner) loadProxiedCollectionFor: sqsProxiedVariable.
			sqsCollectionMap	 := self sqsCreateCollectionMap.
		] 
	]! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:23'!
sqsProxiedObject: anObject 
	super sqsProxiedObject: anObject.
	"only update the map when there is not already one present"
	sqsCollectionMap := self sqsCreateCollectionMap.! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tkow 9/23/2008 17:35'!
sqsSimpleValues: anObject
	sqsSimpleValues := anObject! !

!SqSProxy class methodsFor: 'cached-creation' stamp: 'tkow 12/1/2008 11:42'!
for: aCollection ofInstVar: anIvarName in: anObject 
	^ self basicNew
		sqsProxyOwner: anObject;
		sqsProxiedObject: aCollection;
		sqsProxiedVariable: anIvarName;
		sqsInitialized: true! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 17:45'!
doesNotUnderstand: aMessage 
	"TODO: handling for fancy load strategies here"
	self sqsLoadProxiedObject.
	"TODO: implement some sort of access loggin here"
	^ aMessage sendTo: sqsProxiedObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:41'!
sqSaveClass
	^ sqsProxiedObject class! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:36'!
sqsInitialized: aBool
	sqsInitialized := aBool ! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:43'!
sqsLoadProxiedObject
	"rather dirty, but since we don't proxy integers, we can use them as an indicator'
	this way we only have one place that gets more complicated and the rest remains
	untouched"
	(sqsProxiedObject isNil or: [ sqsProxiedObject isInteger ]) ifTrue: 
		[ sqsProxiedObject := (SqSStorage for: sqsProxyOwner) 
			loadProxiedObjectFor: sqsProxiedVariable
			withOid: sqsProxiedObject ]! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 18:44'!
sqsProxiedObject
	^ sqsProxiedObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:42'!
sqsProxiedObject: anObject 
	sqsProxiedObject := anObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:42'!
sqsProxiedVariable: anObject 
	sqsProxiedVariable := anObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:41'!
sqsProxyOwner: anObject 
	sqsProxyOwner := anObject! !

!Class class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:22'!
sqsType
	^#string! !

!Class methodsFor: '*sqsave' stamp: 'wh 9/5/2006 10:58'!
asSqlValueString
	^'''',self name asString asEscapedSql,''''.! !

!LargePositiveInteger class methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 03:14'!
sqsType
	^#largeInteger! !

!LargePositiveInteger methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 13:24'!
asSqlValueString
	^'''', self asString, ''''! !

TestCase subclass: #SqSTestCase
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqSTestCase subclass: #SqSConnectionManagerTest
	instanceVariableNames: 'connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSConnectionManagerTest methodsFor: 'running' stamp: 'tkow 10/27/2008 17:27'!
setUp
	connections := OrderedCollection new.! !

!SqSConnectionManagerTest methodsFor: 'running' stamp: 'tkow 10/27/2008 17:27'!
tearDown
	SqSConnectionManager getInstance closeAllConnections.! !

!SqSConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 11/18/2008 14:07'!
testAdapterLimitiationToThreads
	| cSpec manager adapter1 adapter2 adapter3 |
	cSpec := self standardConnectionSpecification.
	manager := SqSConnectionManager getInstance.
	adapter1 := manager adapterForConnectionSpecification: cSpec.
	adapter2 := manager adapterForConnectionSpecification: cSpec.
	self assert: adapter1 == adapter2.
	
	[adapter3 := manager adapterForConnectionSpecification: cSpec] fork.

	"kind of dirty...why is there now join, or waitFor for Process?"
	(Delay forMilliseconds: 2000) wait.
	self assert: adapter3 notNil.
	self assert: adapter3 ~= adapter1.
	! !

!SqSConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 11/3/2008 14:14'!
testAddConnectionSpecification
	| testConnection conManager |
	conManager := SqSConnectionManager getInstance.
	conManager connectionSpecificationDictionary: Dictionary new.
	conManager 
		setupConnectionSpecification: self standardConnectionSpecification
		for: self standardCategory.
	self assert: (conManager connectionSpecificationDictionary includesKey: self standardCategory).
	self assert: (conManager connectionSpecificationDictionary at: self standardCategory) class == SqSConnectionSpecification.
	testConnection := conManager adapterForCategory: self standardCategory.
	self assert: testConnection isNil not! !

!SqSConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 11/4/2008 17:55'!
testConnectionCounting
	| conSpec conManager |
	conSpec := self standardConnectionSpecification.
	conSpec maxConnections: 10.
		
	conManager := SqSConnectionManager getInstance.
	conManager setupConnectionSpecification: conSpec for: 'Test-Category'.
	1 to: 10 do: [:i |
		connections add: (conManager getConnectionFor: conSpec).
		self assert: (connections last class = SqSMySqlConnection).
	].
	self should: [conManager getConnectionFor: conSpec] takeMoreThanMilliseconds: 2000.
	conManager releaseConnection: connections removeFirst for: conSpec.
	self should: [conManager getConnectionFor: conSpec] notTakeMoreThanMilliseconds: 2000.
	connections do: [:con |
		conManager releaseConnection: con for: conSpec
	]! !

!SqSConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 11/5/2008 13:07'!
testConnectionFreeing
	| conSpec conManager adapter queue oldQueueSize |
	conSpec := self standardConnectionSpecification.
	
	conManager := SqSConnectionManager getInstance.
	conManager setupConnectionSpecification: conSpec for: 'Test'.
	adapter := conManager adapterForCategory: 'Test'.
	queue := conManager connectionPool at: (conSpec connectionIdentityString) ifAbsentPut: [SharedQueue2 new].
	oldQueueSize := queue size.
	self assert: ((adapter checkTableExistance: 'testtable') class includesBehavior: Boolean).
	(oldQueueSize = 0) ifTrue: [
		self assert: queue size = 1
	] ifFalse: [
		self assert: queue size = oldQueueSize
	]
	! !

SqSTestCase subclass: #SqSConnectionSpecificationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSConnectionSpecificationTest methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 09:43'!
testConnectionIdentityString
	| testConSpec |
	testConSpec := SqSConnectionSpecification new
		database: 'testDb';
		username: 'testUser';
		port: '3306';
		password: 'test';
		hostname: 'localhost';
		driverClass: #SqSMySqlAdapter.
	self assert: testConSpec connectionIdentityString = 'SqSMySqlAdapter#testUser@localhost:3306/testDb'.! !

SqSTestCase subclass: #SqSProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSProxyTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/2/2008 18:46'!
setUp
	self setupTestConnection.! !

!SqSProxyTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/4/2008 17:14'!
testProxiedObjectNotLoadedBeforeAccess
	| testObject testObject1 testResult |
	self clearDatabase.
	testObject := SqSaveTestObject new
		testInteger: 42;
		testString: 'foo';
		yourself.
	testObject1 := SqSaveTestObjectEvenDeeperChild new
		testSubString: 'foo-bar';
		testInteger: 42;
		testSomething: (OrderedCollection with: testObject);
		yourself.
	testObject1 save.
	
	testObject1 := nil.
	SqSStorage flushObjectCache.
	
	testResult := SqSaveTestObjectChild findByTestSubString: 'foo-bar'.
	self assert: testResult notNil.
	self assert: (testResult testSomething class includesBehavior: SqSProxy).
	self assert: (testResult testSomething sqsProxiedObject isNil).
	
	testResult testSomething at: 1.
	
	self assert: (testResult testSomething sqsProxiedObject notNil).
	
	! !

SqSTestCase subclass: #SqSSearchQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSSearchQueryTest methodsFor: 'running' stamp: 'tkow 11/3/2008 14:08'!
setUp
	self setupTestConnection.! !

!SqSSearchQueryTest methodsFor: 'tests' stamp: 'tkow 11/24/2008 14:44'!
testComplexQueries
	| testObject query testObject2 compSql oidField |
	self removeDescriptions.
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler classTableInheritance.
	testObject2 := SqSaveTestObject new
		testInteger: 21.
	testObject := SqSaveTestObject new
		testString: 'test';
		testInteger: 42;
		testBool: true;
		testSomething: testObject2;
		testDate: Date today.
	testObject save.
	query := (SqSQuery new on: SqSaveTestObject) analyze: [:obj | obj testSomething testInteger = 21].
	oidField := (SqSClassInfo for: SqSaveTestObject) configuration tableConfiguration idField.
	
	self assert: query whereBuffer = ('(sq_save_test_objects.test_something_id = sq_save_test_objects_1.', oidField ,') AND sq_save_test_objects_1.test_integer = 21').
	query := (SqSQuery new on: SqSaveTestObject) analyze: [:obj | obj testSomething = testObject2].
	self assert: query whereBuffer = ('sq_save_test_objects.test_something_id = ', testObject2 oid asString).
	query := (SqSQuery new on: SqSaveTestObject) analyze: [:obj | obj testSomething testSomething testSomething = testObject2].
	compSql := '((sq_save_test_objects.test_something_id = sq_save_test_objects_1.',oidField,') AND '.
	compSql := compSql, 'sq_save_test_objects_1.test_something_id = sq_save_test_objects_2.',oidField,') AND '.
	compSql := compSql, 'sq_save_test_objects_2.test_something_id = ',testObject2 oid asString.
	self assert: query whereBuffer = compSql.! !

!SqSSearchQueryTest methodsFor: 'running' stamp: 'tkow 10/21/2008 18:43'!
testFindCorrectColumn
	| queryObject classTable |
	queryObject := SqSQueryObject new.
	classTable := (SqSClassInfo for: SqSaveTestObject) classTable.
	self assert: (queryObject sqsFindColumnFor: #testInteger inTable: classTable) isNil not.
	self assert: (queryObject sqsFindColumnFor: #testSubString inTable: classTable) isNil not.
	self assert: (queryObject sqsFindColumnFor: #testExtremelyDeepSubString inTable: classTable) isNil not.
	
	
	! !

!SqSSearchQueryTest methodsFor: 'tests' stamp: 'tkow 11/24/2008 14:44'!
testSimpleQueries
	| testObject query compSql oidField |
	self removeDescriptions.
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler classTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new
		testString: 'test';
		testInteger: 42;
		testBool: true;
		testSomething: 4.123;
		testDate: Date today;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'subberString'.
	(SqSStorage for: testObject) createClassDescription.
	oidField := (SqSClassInfo for: SqSaveTestObject) configuration tableConfiguration idField.
	query := (SqSQuery new on: SqSaveTestObject) analyze: [:obj | obj testInteger = 5].
	self assert: query whereBuffer = 'sq_save_test_objects.test_integer = 5'.
	query := (SqSQuery new on: SqSaveTestObject) analyze: [:obj | obj oid = 5].
	self assert: query whereBuffer = ('sq_save_test_objects.',oidField,' = 5').
	query := (SqSQuery new on: SqSaveTestObject) analyze: [:obj | obj testDate = Date today].
	self assert: query whereBuffer = ('sq_save_test_objects.test_date = ', Date today asSqlValueString).
	query := (SqSQuery new on: SqSaveTestObject) analyze: [:obj | obj testBool = true].
	self assert: query whereBuffer = 'sq_save_test_objects.test_bool = TRUE'.
	
	query := (SqSQuery new on: SqSaveTestObjectEvenDeeperChild) analyze: [:obj | obj testExtremelyDeepSubString = 'test'].
	self assert: query whereBuffer = 'sq_save_test_object_even_deeper_childs.test_extremely_deep_sub_string = ''test'''.
	
	testObject testExtremelyDeepSubString: (SqSaveTestObject new).
	(SqSStorage for: testObject) createClassDescription.
	
	"this should be the probably most complicated query to process - associated element in a sub-table"
	query := (SqSQuery new on: SqSaveTestObjectEvenDeeperChild) analyze: [:obj | obj testExtremelyDeepSubString testSubString = 'test'].
	compSql := '(sq_save_test_object_even_deeper_childs.test_extremely_deep_sub_string_id = sq_save_test_object_childs_1.',oidField,') AND '.
	compSql := compSql, 'sq_save_test_object_childs_1.test_sub_string = ''test'''.
	self assert: query whereBuffer = compSql.! !

!SqSTestCase methodsFor: 'private' stamp: 'tkow 12/5/2008 14:13'!
clearDatabase
	connection resetDatabase.
	SqSTableStructureHandler clearTableCache.
	SqSStorage flushTableCache.! !

!SqSTestCase methodsFor: 'private' stamp: 'tkow 10/6/2008 17:56'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSTestCase methodsFor: 'private' stamp: 'tkow 10/10/2008 14:36'!
removeDescriptions
	| classes targetClass |
	targetClass := (SqSClassInfo for: SqSaveTestObject) descriptionHandler targetClass.
	classes := Set with: targetClass.
	classes addAll: targetClass allSubclasses.
	
	classes do: [ :curClass |
		(curClass class selectors select: [: selector |
			selector prefixMatchesRegex: ('' asSqSaveDescriptionSelector)
		]) do: [:selector |
			curClass class removeSelector: selector
		]
	].! !

!SqSTestCase methodsFor: 'running' stamp: 'tkow 11/7/2008 17:08'!
setTestObjectInheritanceModeTo: inheritanceMode 
	| code targetClass config |
	config := SqSConfiguration new.
	config tableConfiguration inheritanceMode: inheritanceMode.
	code := SqSClassInfo configurationFunction asString, String crlf, String tab, '^ '.
	code := code, config sqsCodeForObjectCreation.
	
	targetClass := SqSaveTestObject.
	(targetClass organization categories includes: self descriptorMethodCategory) ifTrue: 
		[ targetClass organization addCategory: self descriptorMethodCategory ].
	targetClass class 
		compile: code
		classified: self descriptorMethodCategory! !

!SqSTestCase methodsFor: 'private' stamp: 'tkow 11/3/2008 14:20'!
setupTestConnection
	SqSConnectionManager getInstance 
		setupConnectionSpecification: self standardConnectionSpecification 
		for: self standardCategory.
	connection := SqSConnectionManager getInstance adapterForCategory: self standardCategory.! !

!SqSTestCase methodsFor: 'test-assertions' stamp: 'tkow 10/29/2008 13:40'!
should: aBlock takeMoreThanMilliseconds: delayTime
    | evaluated evaluationProcess result delay testProcess aDuration |

	evaluated := false.
	aDuration := (Duration milliSeconds: delayTime).
	delay := Delay forDuration: aDuration.
	testProcess := Processor activeProcess.
	evaluationProcess := [
		result := aBlock value.
		evaluated := true.
		delay unschedule.
		testProcess resume ] forkNamed: 'Process to evaluate should: notTakeMoreThanMilliseconds:'.

	delay wait.
	evaluated ifTrue: [
		self assert: false description: ('Block evaluation took less than the expected <1p>' expandMacrosWith: aDuration)
	] ifFalse: [
	 	evaluationProcess terminate
	].
    ^result! !

!SqSTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:15'!
standardCategory
	^'SqSave'! !

!SqSTestCase methodsFor: 'private' stamp: 'tkow 11/3/2008 14:20'!
standardConnectionSpecification
	^ SqSConnectionSpecification 
		user: self standardUser
		password:  self standardPassword
		database: self standardDatabase! !

!SqSTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:15'!
standardDatabase
	^'squeak_test'! !

!SqSTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:14'!
standardPassword
	^'test'! !

!SqSTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:14'!
standardUser
	^'thomas'! !

SqSTestCase subclass: #SqSaveBaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveBaseTest methodsFor: 'private' stamp: 'tkow 11/3/2008 14:09'!
setUp
	self setupTestConnection! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 10/10/2008 11:07'!
testGetDirectlyReferencedObjects
	| testObject testObject2 directlyReferencedObjects base |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject testInteger: 4.
	testObject testSomething: testObject2.
	base := SqSStorage for: testObject.
	base descriptionHandler createDescriptions.
	directlyReferencedObjects := base directlyReferencedObjects.
	self assert: directlyReferencedObjects size == 1.
	self assert: directlyReferencedObjects first == testObject2! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 10/10/2008 11:21'!
testGetIndirectlyReferencedObjects
	| testObject testObject2 indirectlyReferencedObjects base |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	base := SqSStorage for: testObject.
	base descriptionHandler createDescriptions.
	indirectlyReferencedObjects := base indirectlyReferencedObjects.
	self assert: indirectlyReferencedObjects size == 1.
	self assert: (indirectlyReferencedObjects first collection) first == testObject2.
	self assert: (indirectlyReferencedObjects first collectionDescription) class = SqSCollectionDescription! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:16'!
testNewRecordAttribute
	| obj obj2 oid |
	self clearDatabase.
	SqSStorage flushObjectCache.
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	self assert: (SqSStorage oidFor: obj) isNil.
	obj save.
	self assert: (SqSStorage oidFor: obj) isNil not.
	oid := SqSStorage oidFor: obj.
	self assert: (SqSStorage 
			cachedObjectOfClass: SqSaveTestObject
			withOid: oid) == obj.
	obj2 := SqSaveTestObject findByTestInteger: 42.
	self assert: (SqSStorage oidFor: obj2) isNil not! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testObjectIdAssignment
	| testObject testObject2 |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: testObject oid == 1.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 4.
	testObject2 save.
	self assert: testObject2 oid == 2! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 11/11/2008 01:58'!
testPersistenceDescriptorCreationOnSave
	| testObject description targetClass |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject
		testDate: Date today;
		testInteger: 42;
		testString: 'calculon';
		testSomething: SqSaveTestObject new.
	testObject save.
	targetClass := ((SqSClassInfo for: SqSaveTestObject) descriptionHandler targetClass).
	self shouldnt: [description := targetClass perform: ('TestInteger' asSqSaveDescriptionSelector)] raise: [Error].
	self assert: description class = SqSColumn.
	self assert: description sqlType = #integer.
	self assert: description columnName = 'test_integer'.
	self assert: description associatedClass isNil.
	self assert: description linkedVariable = 'testInteger'
! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 10/14/2008 16:21'!
testPersistenceDescriptorCreationOnSaveHappensOnlyInTheClassesDefiningTheVariable
	| testObject targetClass1 targetClass2 targetClass3 |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject testSubString: 'test'.
	testObject testExtremelyDeepSubString: 'test'. 
	testObject save.
	targetClass1 := (SqSClassInfo for: SqSaveTestObject) descriptionHandler targetClass.
	targetClass2 := (SqSClassInfo for: SqSaveTestObjectChild) descriptionHandler targetClass.
	targetClass3 := (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild) descriptionHandler targetClass.
	self assert: (targetClass1 class includesSelector: 'testDate' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testInteger' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testString' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testSomething' asSqSaveDescriptionSelector) not.
	self assert: (targetClass2 class includesSelector: 'testSubString' asSqSaveDescriptionSelector).
	self assert: (targetClass3 class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testSubString' asSqSaveDescriptionSelector) not.
	self assert: (targetClass1 class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector) not.
	
	! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/29/2008 16:24'!
testTableCreationOnSave
	| testObject |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	self assert: (SqSStorage for: testObject) tableForClassExists not.
	testObject save.
	self assert: (SqSStorage for: testObject) tableForClassExists! !

SqSTestCase subclass: #SqSaveCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqSaveCollectionTest subclass: #SqSaveCTICollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveCTICollectionTest methodsFor: 'private' stamp: 'tkow 9/18/2008 13:47'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler classTableInheritance.! !

!SqSaveCollectionTest class methodsFor: 'as yet unclassified' stamp: 'tkow 12/1/2008 13:01'!
shouldInheritSelectors
	^ true! !

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tkow 11/3/2008 14:09'!
setUp
	self setupTestConnection.
	self clearDatabase.
	self removeDescriptions! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:14'!
testCollectionAdding
	| testObject2 testObject1 testResult testObject3 testResult2 t2Oid t3Oid |
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.
	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject1 save.
	t2Oid := testObject2 oid.
	testObject1 := nil.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething class includesBehavior: SqSProxy).
	self assert: (testResult testSomething at: 1) oid = t2Oid.
	testObject3 := SqSaveTestObject new
		testInteger: 84;
		yourself.
	testResult testSomething add: testObject3.
	testResult save.
	t3Oid := testObject3 oid.
	self assert: (testObject3 oid notNil).
	self assert: (testResult testSomething at: 2) = testObject3.
	testResult := nil.
	SqSStorage flushObjectCache.
	testResult2 := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult2 isNil not.
	self assert: testResult2 testSomething isCollection.
	self assert: (testResult2 testSomething class includesBehavior: SqSProxy).
	self assert: (testResult2 testSomething at: 1) oid = t2Oid.
	self 
		shouldnt: [ testResult2 testSomething at: 2 ]
		raise: Error.
	self assert: (testResult2 testSomething at: 2) oid = t3Oid.! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:13'!
testCollectionAddingSimpleObjects
	| testObject1 testResult testResult2 collection |
	collection := OrderedCollection 
		with: 21
		with: 42
		with: 84.
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: collection;
		yourself.
	testObject1 save.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1) = 21.
	testResult testSomething add: 168.
	testResult save.
	testResult := nil.
	SqSStorage flushObjectCache.
	testResult2 := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult2 isNil not.
	self assert: testResult2 testSomething isCollection.
	self assert: (testResult2 testSomething at: 1) = 21.
	self 
		shouldnt: [ testResult2 testSomething at: 4 ]
		raise: Error.
	self assert: (testResult2 testSomething at: 4) = 168! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 12/5/2008 14:15'!
testCollectionIsProxyAfterSaving
	| testObject2 testObject1 |
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.

	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject1 save.

	self assert: (testObject1 testSomething class includesBehavior: SqSProxy).! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:15'!
testCollectionRemoving
	| testObject2 testObject1 testResult testObject3 |
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject3 := SqSaveTestObject new
		testInteger: 42;
		yourself.
	testObject1 testSomething add: testObject3.
	testObject1 save.
	testObject1 testSomething removeAt: 2.
	testObject1 save.
	testObject1 := nil.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1) = testObject2.
	self 
		should: [ testResult testSomething at: 2 ]
		raise: Error! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:14'!
testCollectionShuffling
	| testObject2 testObject1 testResult testObject3 testResult2 t2Oid t3Oid |
	testObject2 := SqSaveTestObject new testInteger: 42.
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2).
	testObject3 := SqSaveTestObject new testInteger: 42.
	testObject1 testSomething add: testObject3.
	testObject1 save.
	t2Oid := testObject2 oid.
	t3Oid := testObject3 oid.
	testObject1 := nil.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult notNil.
	self assert: testResult testSomething notNil.
	testResult testSomething: testResult testSomething reversed.
	testResult save.
	testResult := nil.
	SqSStorage flushObjectCache.
	testResult2 := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult2 testSomething isCollection.
	self assert: (testResult2 testSomething at: 1) oid = t3Oid.
	self assert: (testResult2 testSomething at: 2) oid = t2Oid.! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:14'!
testCollectionWithSimpleValues
	| testCollection testObject testResult |
	testCollection := Set 
		with: 42
		with: 21
		with: 84.
	testObject := SqSaveTestObject new
		testInteger: 42;
		testString: 'fortyTwo';
		testSomething: testCollection.
	testObject save.
	testObject := nil.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething includes: 21).
	self assert: (testResult testSomething includes: 42).
	self assert: (testResult testSomething includes: 84)! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 11/10/2008 16:41'!
testDescriptionCreation
	| testObject testObject2 description referenceColumn ownerColumn base targetClass |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	base := SqSStorage for: testObject.
	base descriptionHandler createDescriptions.
	targetClass := (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild) descriptionHandler targetClass.
	self 
		shouldnt: 
			[ description := targetClass perform: ('testSomething' asSqSaveDescriptionSelector)  ]
		raise: Error.
	self assert: description isNil not.
	self assert: description describesCollection.
	self assert: description joinTableName = 'sq_save_test_objects_test_something'.
	referenceColumn := description referenceColumn.
	self assert: referenceColumn columnName = 'value'.
	self assert: description referenceTableName = 'sq_save_test_objects'.
	ownerColumn := description ownerColumn.
	self assert: ownerColumn columnName = 'sq_save_test_object_id'! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 10/14/2008 16:34'!
testDictionaryCreation
	| testObject1 testObject2 testResult testDictionary |
	testObject1 := SqSaveTestObjectEvenDeeperChild new
		testString: 'test1';
		testSomething: Dictionary new.
	testObject2 := SqSaveTestObjectChild new
		testString: 'test2'.
	testObject1 testSomething at: #test put: testObject2.
	testObject1 save.
	
	testObject1 := nil.
	testResult := SqSaveTestObject findByTestString: 'test1'.
	self assert: testResult isNil not.
	testDictionary := testResult testSomething.
	self assert: testDictionary isDictionary.
	self assert: (testDictionary at: #test) = testObject2.
! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 12/5/2008 14:15'!
testLazyCollectionCreation
	| testObject2 testObject1 testResult |

	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.
	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		yourself.
	testObject1 save.
	testObject1 testSomething: (OrderedCollection with: testObject2).
	testObject1 save.
	testObject1 := nil.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult testSomething notNil.
	self assert: (testResult testSomething at: 1) = testObject2! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:15'!
testNilObjectsInCollections
	| testObject2 testObject1 testResult testObject3 |
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject3 := SqSaveTestObject new
		testInteger: 42;
		yourself.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: testObject3.
	testObject1 testSomething add: nil.
	testObject1 save.
	testObject1 := nil.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1) = testObject2.
	self 
		shouldnt: [ testResult testSomething at: 4 ]
		raise: Error.
	self assert: testResult testSomething size = 5.
	self assert: (testResult testSomething at: 2) isNil! !

SqSaveCollectionTest subclass: #SqSaveSTICollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveSTICollectionTest methodsFor: 'private' stamp: 'tkow 9/18/2008 13:48'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler singleTableInheritance.! !

SqSTestCase subclass: #SqSaveColumnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveColumnTest methodsFor: 'tests' stamp: 'tkow 10/6/2008 11:09'!
testCreationCode
	| column column2 |
	column := SqSColumn new.
	column columnName: 'testColumn'.
	column sqlType: #integer.
	column2 := Compiler evaluate: column creationCode.
	self assert: column2 class = SqSColumn.
	self assert: column2 sqlType = #integer.
	self assert: column2 columnName = 'testColumn'! !

!SqSaveColumnTest methodsFor: 'tests' stamp: 'tkow 10/21/2008 17:30'!
testCustomEquals
	| column1 column2 |
	column1 := SqSColumn new.
	column1 columnName: 'testColumn'.
	column1 sqlType: #integer.
	column2 := SqSColumn new.
	column2 columnName: 'testColumn'.
	column2 sqlType: #integer.
	self assert: column1 = column2.
	! !

SqSTestCase subclass: #SqSaveDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 11/11/2008 01:59'!
testCollectionCheck
	"a collection with simple values"
	| collection descriptionHandler |
	collection := OrderedCollection 
		with: 1
		with: 2
		with: 3.
	descriptionHandler := SqSDescriptionHandler new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection) not.

	"a collection with simple values and nil"
	collection add: nil.
	descriptionHandler := SqSDescriptionHandler new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection) not.

	"a collection with values from completely different classes"
	collection add: 'test'.
	self 
		should: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.

	"a collection with complex values"
	collection := OrderedCollection 
		with: SqSaveTestObject new
		with: SqSaveTestObjectChild new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection).

	"a collection with complex values and nil values"
	collection add: nil.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection).

	"a collection with complex values and simple values"
	collection add: 42.
	self 
		should: [ descriptionHandler isComplexCollection: collection ]
		raise: Error! !

!SqSaveDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 11/11/2008 02:00'!
testDictionaryKeyRecognition
	| dictionary handler |
	dictionary := Dictionary new.
	dictionary 
		at: #test
		put: #test.
	dictionary 
		at: 'test2'
		put: #test2.
	handler := SqSDescriptionHandler new.
	self assert: (handler indexClassOfDictionary: dictionary) = ByteSymbol.
	dictionary := Dictionary new.
	dictionary 
		at: 432
		put: #test.
	dictionary 
		at: 41235
		put: #test2.
	handler := SqSDescriptionHandler new.
	self 
		shouldnt: [ handler indexClassOfDictionary: dictionary ]
		raise: Error.
	self assert: (handler indexClassOfDictionary: dictionary) = SmallInteger.
	dictionary := Dictionary new.
	dictionary 
		at: 432
		put: #test.
	dictionary 
		at: #test
		put: #test2.
	handler := SqSDescriptionHandler new.
	self 
		should: [ handler indexClassOfDictionary: dictionary ]
		raise: Error! !

!SqSaveDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 11/11/2008 02:00'!
testSqlTypeRecognition
	| handler |
	handler := SqSDescriptionHandler new.
	self assert: (handler sqlTypeForObject: 42) = #integer.
	self assert: (handler sqlTypeForObject: SqSaveTestObject new) = #integer.
	self assert: (handler sqlTypeForObject: true) = #boolean! !

SqSTestCase subclass: #SqSaveDictionaryExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveDictionaryExtensionTests methodsFor: 'tests' stamp: 'tk 8/15/2008 14:49'!
testValueJoin
	| dict1 dict2 result |
	dict1 := Dictionary new.
	dict1 at: #test1 put: (OrderedCollection with: 42).
	dict1 at: #test2 put: 42.
	dict1 at: #test3 put: (OrderedCollection with: 84).
	
	dict2 := Dictionary new.
	dict2 at: #test1 put: (OrderedCollection with: 21).
	dict2 at: #test2 put: 21.
	
	result := dict1 valueJoin: dict2.
	self assert: ((result at: #test1) isCollection).
	self assert: ((result at: #test1) includes: (42)).
	self assert: ((result at: #test1) includes: (21)).

	self assert: ((result at: #test2) isCollection).
	self assert: ((result at: #test2) includes: (42)).
	self assert: ((result at: #test2) includes: (21)).

	self assert: ((result at: #test3) isCollection).
	self assert: ((result at: #test3) includes: (84)).
	! !

SqSTestCase subclass: #SqSaveDriverTest
	instanceVariableNames: 'adapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveDriverTest methodsFor: 'running' stamp: 'tkow 10/7/2008 15:42'!
setUp
	adapter := SqSMySqlAdapter new! !

!SqSaveDriverTest methodsFor: 'tests' stamp: 'tkow 10/7/2008 16:14'!
testQueryToCreateColumn
	| column sql referenceSql |
	SqSClassInfo clearInfoCache.
	column := SqSColumn new
		columnName: 'test_column';
		sqlType: #integer;
		canBeNull: false;
		foreignKey: (SqSForeignKeyDescription new
			referencedColumns: (OrderedCollection with: 'test_reference');
			referencedTable: 'test_table';
			deleteActions: #(#CASCADE)
		).
	sql := adapter queryToCreateColumn: column.
	referenceSql := 'test_column INTEGER NOT NULL, FOREIGN KEY (test_column) REFERENCES test_table(test_reference) ON DELETE CASCADE'.
	self assert: (sql = referenceSql)! !

!SqSaveDriverTest methodsFor: 'tests' stamp: 'tkow 11/10/2008 12:31'!
testTableCreation
	| testObject table sql referenceSql classInfo |
	self removeDescriptions.
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler singleTableInheritance.
	testObject := SqSaveTestObjectChild new
		testInteger: 42;
		testSomething: 4.12;
		testString: 'test';
		testDate: Date today;
		testSubString: 'subString'.
	(SqSStorage for: testObject) createClassDescription.
	classInfo := (SqSClassInfo for: SqSaveTestObject).
	table := classInfo classTable.
	sql := adapter queryToCreateTable: table.
	referenceSql := 'CREATE TABLE sq_save_test_objects ('.
	referenceSql := referenceSql, ((table columns collect: [:column |
		adapter queryToCreateColumn: column
	]) join: ', ').
	referenceSql := referenceSql, ', PRIMARY KEY (', classInfo configuration tableConfiguration idField,')) ENGINE=INNODB'.
	self assert: sql = referenceSql! !

SqSTestCase subclass: #SqSaveInheritanceSensitiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqSaveInheritanceSensitiveTest subclass: #SqSaveClassTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 9/30/2008 16:19'!
setUp
	| |
	super setUp.
	self setTestObjectInheritanceModeTo: (SqSTableStructureHandler classTableInheritance)! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 11/10/2008 15:28'!
testCascadingDelete
	| dbConnection result testObject resultDicts oid query oidField |
	testObject := SqSaveTestObjectEvenDeeperChild new
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	SqSStorage for: testObject.
	oid := testObject oid.
	testObject destroy.
	dbConnection := SqSConnectionManager getInstance adapterForCategory: 'SqSave'.

	oidField := (SqSClassInfo for: SqSaveTestObjectChild) configuration tableConfiguration idField.
	query := 'SELECT * FROM ' , SqSaveTestObjectChild name asSqSaveTableName.
	query := query , ' WHERE ' , oidField , ' = ' , oid asString.
	result := dbConnection executeQuery: query andDropConnection: false.
	resultDicts := dbConnection connection rowDictionariesForResultSet: result.
	dbConnection freeConnection.
	
	self assert: resultDicts isEmpty.

	query := 'SELECT * FROM ' , SqSaveTestObjectEvenDeeperChild name asSqSaveTableName.
	query := query , ' WHERE ' , oidField , ' = ' , oid asString.
	result := dbConnection executeQuery: query.
	resultDicts := OrderedCollection new.
	[ result next ] whileTrue: [ resultDicts add: result currentRowAsDictionary ].
	self assert: resultDicts isEmpty.
! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 10/9/2008 16:09'!
testGetClassTableColumns
	self assert: (SqSClassInfo for: SqSaveTestObject) classTableColumns size = 5.
	self assert: (SqSClassInfo for: SqSaveTestObjectChild) classTableColumns size = 1.
	self assert: (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild) classTableColumns size = 1! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/30/2008 15:56'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler classTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.5243;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: (SqSStorage for: SqSaveTestObject new) tableForClassExists.
	self assert: (SqSStorage for: SqSaveTestObjectChild new) tableForClassExists.
	self assert: (SqSStorage for: SqSaveTestObjectEvenDeeperChild new) tableForClassExists! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/30/2008 14:53'!
testTableNames
	self assert: (SqSClassInfo for: SqSaveTestObject) tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: (SqSClassInfo for: SqSaveTestObjectChild ) tableName = SqSaveTestObjectChild name asSqSaveTableName.
	self assert: (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild ) tableName = SqSaveTestObjectEvenDeeperChild name asSqSaveTableName! !

!SqSaveClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 11/3/2008 14:49'!
testTableObjectChildren
	| testObject table1 table2 table3 |
	testObject := SqSaveTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: (SqSaveTestObject new);
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqSStorage for: testObject) createClassDescription.
	
	table1 := (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild) classTable.
	table2 := (SqSClassInfo for: SqSaveTestObjectChild) classTable.
	table3 := (SqSClassInfo for: SqSaveTestObject) classTable.
	
	self assert: table1 allChildTables isEmpty.
	self assert: table2 allChildTables size = 1.
	self assert: table2 allChildTables includes: table1.
	self assert: table3 allChildTables size = 2.
	self assert: table3 allChildTables includes: table1.
	
! !

!SqSaveClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 10/9/2008 15:21'!
testTableObjectCreation
	| testObject table parent |
	testObject := SqSaveTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: (SqSaveTestObject new);
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqSStorage for: testObject) createClassDescription.
	table := (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild) classTable.
	self assert: table tableName = SqSaveTestObjectEvenDeeperChild name asSqSaveTableName.
	self assert: table children isEmpty.
	self assert: table columns size = 2.
	self assert: table parent isNil not.
	parent := table parent.
	self assert: parent tableName = SqSaveTestObjectChild name asSqSaveTableName.
! !

!SqSaveInheritanceSensitiveTest class methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 13:08'!
shouldInheritSelectors
	^true! !

!SqSaveInheritanceSensitiveTest methodsFor: 'running' stamp: 'tkow 11/3/2008 14:00'!
setUp
	self setupTestConnection.
	self clearDatabase.
	self removeDescriptions! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:15'!
testCircularReferenceHandling
	| testObject1 testObject2 testResult1 testResult2 |
	
	self clearDatabase.
	testObject1 := SqSaveTestObject new
		testInteger: 42.
	
	testObject2 := SqSaveTestObject new
		testInteger: 21;
		testSomething: testObject1.
		
	testObject1 testSomething: testObject2.
	
	"why 3000? because when logging is on, this can take a while..."
	self should: [testObject1 save] notTakeMoreThanMilliseconds: 3000.
	
	testObject1 := nil.
	testObject2 := nil.
	SqSStorage flushObjectCache.
	
	testResult1 := SqSaveTestObject findByTestInteger: 42.
	testResult2 := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult1 oid isNil not.
	self assert: testResult2 oid isNil not.
	self assert: (testResult2 testSomething oid = testResult1 oid).
	self assert: (testResult1 testSomething oid = testResult2 oid).
	! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/5/2008 13:16'!
testComplexCollectionStorage
	| testObject testObject2 testResult |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject
		testSomething: (OrderedCollection with: testObject2).
	testObject testInteger: 42.
	testObject save.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testObject = testResult.
	"we still are ahold of the object, thus no proxy will be created"
	self assert: testResult testSomething first = testObject2! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/5/2008 13:17'!
testCorrectObjectCreation
	| testObject1 testObject2 result |
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	testObject1 := nil.
	SqSStorage flushObjectCache.
	result := SqSaveTestObject findByTestInteger: 42.
	self assert: result class = SqSaveTestObject.
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save.
	testObject2 := nil.
	SqSStorage flushObjectCache.	
	result := SqSaveTestObject findByTestInteger: 21.
	self assert: result class = SqSaveTestObjectChild! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/5/2008 13:17'!
testDestroyObjects
	| testObject searchResult newSearchResult |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	SqSStorage flushObjectCache.
	searchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (searchResult isNil not).
	searchResult destroy.
	SqSStorage flushObjectCache.	
	newSearchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (newSearchResult isNil).! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 9/30/2008 14:52'!
testGetPersistedInstanceVariables
	| ivars1 ivars2 ivars3 |
	ivars1 := (SqSClassInfo for: SqSaveTestObject ) persistedInstVars.
	ivars2 := (SqSClassInfo for: SqSaveTestObjectChild ) persistedInstVars.
	ivars3 := (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild ) persistedInstVars.
	self assert: ivars1 size = 5.
	self assert: ivars2 size = 6.
	self assert: ivars3 size = 7.
	self assert: (ivars3 includes: 'testUnstoredVariable') not! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/5/2008 13:18'!
testNamingBasedSearch
	| testObject searchResult1 searchResult2 searchResult3 searchResult0 |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	SqSStorage flushObjectCache.
	searchResult0 := SqSaveTestObject 
		findByTestInteger: 5
		andTestDate: Date today.
	SqSStorage flushObjectCache.
	searchResult1 := SqSaveTestObject findByTestInteger: 5.
	searchResult2 := SqSaveTestObject 
		findByTestDate: Date today
		andTestString: 'test'.
	SqSStorage flushObjectCache.	
	searchResult3 := SqSaveTestObject findByTestString: 'test'.
	self assert: searchResult0 isNil not.
	self assert: searchResult0 testInteger = 5.
	self assert: searchResult0 testDate = Date today.
	self assert: searchResult0 testString = 'test'.
	self assert: testObject = searchResult1.
	self assert: testObject = searchResult2.
	self assert: testObject = searchResult3! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:16'!
testObjectCompleteness
	| testObject testResult |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject
		testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testSubString: 'twentyOne';
		testExtremelyDeepSubString: 'elevenAndAHalf';
		testBool: true.
	testObject save.
	testObject := nil.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testInteger = 42.
	self assert: testResult testString = 'fortyTwo'.
	self assert: testResult testDate = Date today.
	self assert: testResult testSomething = 3.
	self assert: testResult testSubString = 'twentyOne'.
	self assert: testResult testExtremelyDeepSubString = 'elevenAndAHalf'.
	self assert: testResult testBool = true! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 9/29/2008 16:24'!
testSaveRelatedObjectAlongWithObject
	| testObject testObject2 result base |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 6.
	testObject2 testString: 'test2'.
	testObject testSomething: testObject2.
	base := SqSStorage for: testObject2.
	self assert: base newRecord.
	testObject save.
	self assert: base newRecord not.
	self assert: base oid isNil not.
	result := SqSaveTestObject findByTestInteger: 6.
	self assert: result == testObject2! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:16'!
testSearchRestrictionToClasses
	| testObject testResult oldOid testResult2 |
	testObject := SqSaveTestObject new.
	testObject
		testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testBool: true.
	testObject save.
	oldOid := testObject oid.
	testObject := nil.
	SqSStorage flushObjectCache.
	testResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: testResult isNil.

	testResult2 := SqSaveTestObject findByTestInteger: 42.
	self assert: testResult2 notNil.
	self assert: testResult2 oid = oldOid.! !

!SqSaveInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/4/2008 17:16'!
testUpdate
	| testObject testResult |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 3.14;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'deepSubString'.
	testObject save.
		
	testObject testString: 'newTest'.
	testObject save.
	
	testObject := nil.
	SqSStorage flushObjectCache.
	
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: (testResult testString = 'newTest').! !

SqSaveInheritanceSensitiveTest subclass: #SqSaveSingleTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveSingleTableInheritanceTest methodsFor: 'running' stamp: 'tkow 9/30/2008 16:20'!
setUp
	| |
	super setUp.
	self setTestObjectInheritanceModeTo: (SqSTableStructureHandler singleTableInheritance)! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 11/4/2008 17:53'!
testGetClassTableColumns
	self assert: (SqSClassInfo for: SqSaveTestObject ) classTableColumns size = 5.
	self assert: (SqSClassInfo for: SqSaveTestObjectChild ) classTableColumns size = 1.
	self assert: (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild ) classTableColumns size = 1! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/30/2008 14:54'!
testSaveSubclassWithSingleTableInheritance
	| testObject base |
	base := SqSClassInfo for: SqSaveTestObjectChild.
	self assert: base tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: base tableForClassExists not.
	testObject := SqSaveTestObjectChild new.
	testObject testSubString: 'Subtest'.
	testObject save.
	self assert: base tableForClassExists! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/30/2008 15:56'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.524;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: (SqSStorage for: testObject) tableForClassExists! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 11/3/2008 13:51'!
testTableObjectChildren
	| testObject table1 table2 table3 |
	testObject := SqSaveTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: (SqSaveTestObject new);
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqSStorage for: testObject) createClassDescription.
	
	table1 := (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild) classTable.
	table2 := (SqSClassInfo for: SqSaveTestObjectChild) classTable.
	table3 := (SqSClassInfo for: SqSaveTestObject) classTable.
	
	self assert: table1 allChildTables isEmpty.
	self assert: table2 allChildTables isEmpty.
	self assert: table3 allChildTables isEmpty.! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 11/5/2008 13:05'!
testTableObjectCreation
	| testObject table |
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler singleTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: (SqSaveTestObject new);
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqSStorage for: testObject) createClassDescription.
	table := (SqSClassInfo for: SqSaveTestObjectEvenDeeperChild) classTable.
	self assert: table children isEmpty.
	self assert: table tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: table columns size = 9.
	self assert: table parent isNil.
	! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 11/10/2008 15:43'!
testTypeParameter
	| testObject1 testObject2 dbConnection result resultDicts typeField |
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	dbConnection := SqSConnectionManager getInstance adapterForCategory: (self standardCategory).
	result := dbConnection executeQuery: ('SELECT * FROM ' , SqSaveTestObject name asSqSaveTableName , ' WHERE test_integer = 42') andDropConnection: false.
	resultDicts := dbConnection connection rowDictionariesForResultSet: result.
	dbConnection freeConnection.
	typeField := (SqSClassInfo for: SqSaveTestObject) configuration tableConfiguration typeField.
	resultDicts do: [:resultDict |
		self assert: (resultDict at: typeField) = SqSaveTestObject name asString.	
	].
	
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save! !

SqSTestCase subclass: #SqSaveStringExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tkow 11/10/2008 16:42'!
testAsSqSaveDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tkow 10/6/2008 11:22'!
testAsSqSaveDescriptorClassName
	'SqSaveTestObject' asSqSaveDescriptorClassName = #SqSaveTestObjectPersistenceDescriptor.
	'sqSaveTestObjectEvenDeeperChild' asSqSaveDescriptorClassName = #SqSaveTestObjectEvenDeeperChildPersistenceDescriptor.! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/24/2008 15:33'!
testAsSqSaveTableName
	| testString |
	testString := 'TKSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'tk_save_test_objects').
	testString := 'SqSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'sq_save_test_objects').
	testString := 'SqSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'sqsave_test_objects').
	testString := 'TKSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'tksave_test_objects').
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/14/2008 17:45'!
testCollectionJoin
	self assert: ((#('hallo' 'welt') join: '-') = 'hallo-welt').
	self assert: ((#('hallo' 'welt') join: '') = 'hallowelt').
	self assert: ((#('hallo' 'welt') join: nil) = 'hallowelt')! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/7/2008 16:48'!
testDecamelized
	self assert: 'sq_save_type_field' decamelized = 'sq_save_type_field'.
	self assert: 'SqSaveTypeField' decamelized = 'sq_save_type_field'.! !

SqSTestCase subclass: #SqTableChangesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqTableChangesTest methodsFor: 'tests' stamp: 'tkow 10/16/2008 08:03'!
testCorrectClassChoosing
	| sampleObject |
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler singleTableInheritance.
	sampleObject := SqSStorage for: SqSaveTestObject new.
	self assert: (SqSTableStructureHandler forObject: sampleObject) class = SqSSingleTableInheritanceHandler.
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler classTableInheritance.
	sampleObject := SqSStorage for: SqSaveTestObject new.
	self assert: (SqSTableStructureHandler forObject: sampleObject) class = SqSClassTableInheritanceHandler! !

!SqTableChangesTest methodsFor: 'tests' stamp: 'tkow 10/9/2008 14:42'!
testFindAlteredColumns
	| oldColumn newColumn oldTable newTable tableChanges |
	oldColumn := SqSColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqSColumn new
		linkedVariable: 'test_var';
		sqlType: #string;
		columnName: 'test_column_1'.
	
	oldTable := SqSTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqSTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
		
	tableChanges := (SqSTableChanges oldTable: oldTable newTable: newTable) calculateChanges.
		
	self assert: (tableChanges alteredColumns) isEmpty not.
	self assert: tableChanges alteredColumns anyOne = newColumn		
		! !

!SqTableChangesTest methodsFor: 'tests' stamp: 'tkow 10/9/2008 14:49'!
testFindChangedTableName
	| oldTable newTable changes |
	oldTable := SqSTable new
		tableName: 'testTable1'.
	newTable := SqSTable new
		tableName: 'testTable2'.
		
	changes := SqSTableChanges oldTable: oldTable newTable: newTable.
	self assert: changes newTableName isNil not.
	self assert: changes newTableName = 'testTable2'.		! !

!SqTableChangesTest methodsFor: 'tests' stamp: 'tkow 10/9/2008 14:41'!
testFindRemovedAndAddedColumns
	| oldColumn newColumn oldTable newTable tableChanges |
	oldColumn := SqSColumn new
		linkedVariable: 'test_var_1';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqSColumn new
		linkedVariable: 'test_var_2';
		sqlType: #integer;
		columnName: 'test_column_1'.
	
	oldTable := SqSTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqSTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
		
	tableChanges := (SqSTableChanges oldTable: oldTable newTable: newTable) calculateChanges.
	self assert: (tableChanges removedColumns) isEmpty not.
	self assert: (tableChanges removedColumns) anyOne = oldColumn.
	self assert: (tableChanges addedColumns) isEmpty not.
	self assert: (tableChanges addedColumns) anyOne = newColumn.		
		! !

!SqTableChangesTest methodsFor: 'tests' stamp: 'tkow 10/9/2008 11:58'!
testFindRenamedColumns
	| oldColumn newColumn changed oldTable newTable tableChanges |
	oldColumn := SqSColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqSColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_2'.
	
	oldTable := SqSTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqSTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
		
	tableChanges := (SqSTableChanges oldTable: oldTable newTable: newTable) calculateChanges.
		
	self assert: (tableChanges renamedColumns) isEmpty not.
	changed := (tableChanges renamedColumns) anyOne.
	self assert: changed first = oldColumn.
	self assert: changed last = newColumn.
		
		! !

SqSTestCase subclass: #SqTableStructureHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqTableStructureHandlerTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:20'!
setUp
	self setupTestConnection.
	self clearDatabase.! !

!SqTableStructureHandlerTest methodsFor: 'tests' stamp: 'tkow 12/6/2008 16:51'!
testCacheFillingWithLazyCollections
	| testObject tableCache toCache tocCache toedcCache classIndex joinIndex joinTables testStorage testObject2 changes joinTable |
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler classTableInheritance.
	
	classIndex := SqSTableCache new classIndex.
	joinIndex := SqSTableCache new joinTableIndex.
	
	testObject := SqSaveTestObjectEvenDeeperChild new
		testSubString: 'test';
		testExtremelyDeepSubString: 'test2';
		testInteger: 42;
		yourself.
		
	testObject2 := SqSaveTestObject new
		testInteger: 21;
		yourself.
	
	testStorage := SqSStorage for: testObject.
	testStorage save.
	
	tableCache := testStorage tableStructureHandler tableCache.
		
	toCache := tableCache tableCache at: SqSaveTestObject name ifAbsent: [nil].
	tocCache := tableCache tableCache at: SqSaveTestObjectChild name ifAbsent: [nil].
	toedcCache := tableCache tableCache at: SqSaveTestObjectEvenDeeperChild name ifAbsent: [nil].
	self assert: ((toCache notNil and: [tocCache notNil]) and: [toedcCache notNil]).
	
	self shouldnt: [toCache at: (classIndex)] raise: Error.
	self shouldnt: [tocCache at: (classIndex)] raise: Error.
	self shouldnt: [toedcCache at: (classIndex)] raise: Error.
	self should: [joinTables := toCache at: (joinIndex)] raise: Error.
	
	testObject testSomething: (OrderedCollection with: testObject2).
	testStorage createClassDescription.
	changes := testStorage tableStructureHandler getTableChanges.
	"one empty changes object for all subclasses"
	self assert: changes size = 3.
	
	"more interesting now are the join tables. one should be inserted in the cache right now"
	joinTables := toCache at: (joinIndex) ifAbsent: [nil].
	self assert: joinTables notNil.
	self assert: joinTables size = 1.
	joinTable := joinTables anyOne value.
	self assert: joinTable tableName = 'sq_save_test_objects_test_something'.! !

!SqTableStructureHandlerTest methodsFor: 'tests' stamp: 'tkow 11/10/2008 16:06'!
testColumnValueDictionaryCreation
	| testObject storage columnValueDict |
	self setTestObjectInheritanceModeTo: SqSTableStructureHandler singleTableInheritance.
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new
		testBool: true;
		testInteger: 42;
		testSomething: 4.12;
		testDate: Date today;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'subberString';
		testString: 'string'.
	storage := SqSStorage for: testObject.
	storage createClassDescription.
	columnValueDict := storage tableStructureHandler columnValueDictionaryFor: (storage classInfo classTable).
	self assert: (columnValueDict includesKey: storage classInfo configuration tableConfiguration idField).
	self assert: (columnValueDict includesKey: 'test_bool').
	self assert: ((columnValueDict at: 'test_bool') = true asSqlValueString).
	self assert: (columnValueDict includesKey: 'test_integer').
	self assert: ((columnValueDict at: 'test_integer') = 42 asSqlValueString).
	self assert: (columnValueDict includesKey: 'test_something').
	self assert: ((columnValueDict at: 'test_something') = 4.12 asSqlValueString).
	self assert: (columnValueDict includesKey: 'test_date').
	self assert: ((columnValueDict at: 'test_date') = Date today asSqlValueString).
	self assert: (columnValueDict includesKey: 'test_sub_string').
	self assert: ((columnValueDict at: 'test_sub_string') = 'subString' asSqlValueString).
	self assert: (columnValueDict includesKey: 'test_extremely_deep_sub_string').
	self assert: ((columnValueDict at: 'test_extremely_deep_sub_string') = 'subberString' asSqlValueString).
	! !

!DateAndTime class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:25'!
sqsType
	^#dateAndTime! !

!DateAndTime methodsFor: '*sqsave' stamp: 'wh 3/2/2006 15:27'!
asSqlValueString
	^'''', self asString,''''. ! !

!Symbol class methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 01:53'!
sqsType
	^#string! !

!Symbol methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 01:53'!
asSqlValueString
	^'''', self asString ,''''! !

!Object methodsFor: '*sqsave' stamp: 'tkow 9/29/2008 16:24'!
destroy
	(SqSStorage for: self) destroy! !

!Object methodsFor: '*sqsave' stamp: 'tkow 9/29/2008 16:24'!
oid
	^ SqSStorage oidFor: self! !

!Object methodsFor: '*sqsave' stamp: 'tkow 9/29/2008 16:24'!
save
	(SqSStorage for: self) save! !

!Object methodsFor: '*sqsave' stamp: 'tkow 10/29/2008 13:16'!
save: anSqsDbAdapter
	| storage |
	storage := (SqSStorage for: self).
	storage sqSaveDbAdapter: anSqsDbAdapter.
	storage save.! !

!Object methodsFor: '*sqsave' stamp: 'tk 8/26/2008 16:43'!
sqSaveClass
	^self class! !

!Object methodsFor: '*sqsave' stamp: 'tkow 11/7/2008 17:03'!
sqsCodeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String crlf, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream 
				nextPutAll: (String cr, String tab);
				nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;
			]
		].
	aStream nextPutAll: (String cr, String tab, ' yourself)').
	^aStream contents! !

Object subclass: #SqSClassInfo
	instanceVariableNames: 'currentClass tableStructureHandler descriptionHandler tableName classTable configuration'
	classVariableNames: 'InfoCache'
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSClassInfo class methodsFor: 'standard-values' stamp: 'tkow 10/6/2008 18:30'!
clearInfoCache
	InfoCache := nil.! !

!SqSClassInfo class methodsFor: 'standard-values' stamp: 'tkow 11/7/2008 13:45'!
configurationFunction
	^#sqsConfiguration! !

!SqSClassInfo class methodsFor: 'standard-values' stamp: 'tkow 11/7/2008 13:46'!
descriptionHandlerFunction
	^ #sqsDescriptionHandler! !

!SqSClassInfo class methodsFor: 'access to cache' stamp: 'tkow 11/7/2008 16:03'!
for: aClass
	| newInstance |
	InfoCache ifNil: [InfoCache := Dictionary new].
	newInstance := InfoCache at: aClass name ifAbsentPut: [
		(self new) currentClass: aClass; yourself
	].
	self prepareNewInstance: newInstance.	
	^ newInstance
! !

!SqSClassInfo class methodsFor: 'access to cache' stamp: 'tkow 11/7/2008 16:05'!
prepareNewInstance: newInstance	
	(newInstance configuration mode = SqSConfiguration developmentMode) ifTrue: [
		newInstance tableName: nil.
		newInstance tableStructureHandler: nil.
		newInstance descriptionHandler: nil.
		newInstance configuration: nil.
	
		newInstance cachedClassTable ifNotNil: [
			(newInstance cachedClassTable structure ~= newInstance inheritanceMode) ifTrue: [
				newInstance cachedClassTable: nil
			]
		].
	].
	^ newInstance

! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 15:19'!
baseClass
	| klass |
	klass := self currentClass.
	[ klass superclass = Object or: [ klass superclass = SqSSearch ] ] whileFalse: [ klass := klass superclass ].
	^ klass! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:57'!
cachedClassTable
	^ classTable
! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:57'!
cachedClassTable: anSqSTable
	classTable := anSqSTable
! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:27'!
classTable
	^ self tableStructureHandler classTable
! !

!SqSClassInfo methodsFor: 'table-information' stamp: 'tkow 10/6/2008 18:09'!
classTableColumns
	^self descriptionHandler classTableColumns! !

!SqSClassInfo methodsFor: 'variable-information' stamp: 'tkow 11/7/2008 16:16'!
columnNameForInstVar: ivn
	^ ivn decamelized! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:27'!
configuration
	configuration ifNil: [
		(self currentClass respondsTo: self class configurationFunction) ifTrue: [
			configuration := self currentClass perform: self class configurationFunction.
		] ifFalse: [
			"'No configuration specified for the current class'"
			configuration := SqSConfiguration new.
		]
	].
	^configuration! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:41'!
configuration: anObject
	configuration := anObject! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 15:19'!
currentClass
	^ currentClass! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 15:19'!
currentClass: anObject
	currentClass := anObject! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:48'!
descriptionHandler
	descriptionHandler ifNil: [
		descriptionHandler := self descriptionHandlerClass forClassInfo: self.	
	].
	^descriptionHandler! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 9/30/2008 11:51'!
descriptionHandler: anObject
	descriptionHandler := anObject! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:49'!
descriptionHandlerClass
	^ self configuration descriptionHandlerClass! !

!SqSClassInfo methodsFor: 'iterating' stamp: 'tkow 9/30/2008 15:13'!
doForAllSuperclasses: aBlock
	| curClass baseClass |
	"this is a convenience method to perform some block
	for all of the current class' superclasses up until the base class"
	curClass := self currentClass.
	baseClass := self baseClass.
	[curClass = baseClass superclass] whileFalse: [
		aBlock value: curClass.
		curClass := curClass superclass.
	].! !

!SqSClassInfo methodsFor: 'persistence-information' stamp: 'tkow 11/7/2008 16:27'!
inheritanceMode
	^self configuration tableConfiguration inheritanceMode! !

!SqSClassInfo methodsFor: 'variable-information' stamp: 'tkow 9/30/2008 14:17'!
persistedInstVars
	| |
	^self descriptionHandler persistedInstanceVariables
	! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:14'!
sqSaveDbAdapter
	^ self configuration connectionSpec ifNil: [
		SqSConnectionManager getInstance adapterForClass: self currentClass	
	] ifNotNil: [
		SqSConnectionManager getInstance adapterForConnectionSpecification: self configuration connectionSpec
	]
	! !

!SqSClassInfo methodsFor: 'object-persistence' stamp: 'tkow 10/9/2008 18:46'!
tableForClassExists
	| cache tableExists |
	cache := SqSStorage tableCacheForConnection: self sqSaveDbAdapter connectionIdentityString.
	tableExists := cache 
		at: self tableName
		ifAbsent: [ self sqSaveDbAdapter checkTableExistance: self tableName ].
	cache 
		at: self tableName
		put: tableExists.
	^ tableExists! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:08'!
tableName
	| |
	tableName ifNil: [
		tableName := self configuration tableConfiguration tableName ifNil: [
			self tableStructureHandler tableName
		].
	].
	^ tableName! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 9/30/2008 15:05'!
tableName: aString
	| |
	tableName := aString! !

!SqSClassInfo methodsFor: 'table-information' stamp: 'tkow 9/29/2008 15:14'!
tableNameForClass: aClass
	"only use me for classes you are sure of using the same description handler 
	 than the one the current sqsObject is using"
	^self descriptionHandler tableNameForClass: aClass
	! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 10/6/2008 18:24'!
tableStructureHandler
	tableStructureHandler ifNil: [
		tableStructureHandler := SqSTableStructureHandler forClassInfo: self
	].
	^ tableStructureHandler! !

!SqSClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:15'!
tableStructureHandler: anObject
	tableStructureHandler := anObject! !

!SqSClassInfo methodsFor: 'variable-information' stamp: 'tkow 9/29/2008 15:15'!
unpersistedInstVars
	| |
	^self descriptionHandler unpersistedInstVars
	! !

Object subclass: #SqSCollectionChanges
	instanceVariableNames: 'addedObjects deletedObjects movedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
addedObjects
	^ addedObjects! !

!SqSCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
addedObjects: anObject
	addedObjects := anObject! !

!SqSCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
deletedObjects
	^ deletedObjects! !

!SqSCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
deletedObjects: anObject
	deletedObjects := anObject! !

!SqSCollectionChanges methodsFor: 'initialization' stamp: 'tkow 11/7/2008 15:23'!
initialize
	super initialize.
	addedObjects := OrderedCollection new.
	deletedObjects := OrderedCollection new.
	movedObjects := OrderedCollection new.! !

!SqSCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
movedObjects
	^ movedObjects! !

!SqSCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
movedObjects: anObject
	movedObjects := anObject! !

Object subclass: #SqSCollectionConfiguration
	instanceVariableNames: 'valueField orderedCollections orderField nilValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:22'!
standardForOrderedCollections
	^ true! !

!SqSCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/10/2008 09:40'!
standardNilValue
	^ 0! !

!SqSCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:22'!
standardOrderField
	^'sqs_order_number'! !

!SqSCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:21'!
standardValueField
	^'value'! !

!SqSCollectionConfiguration methodsFor: 'initialize-release' stamp: 'tkow 11/10/2008 09:41'!
initialize
	super initialize.
	self orderField: self class standardOrderField.
	self orderedCollections: self class standardForOrderedCollections.
	self valueField: self class standardValueField.
	self nilValue: self class standardNilValue.! !

!SqSCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/10/2008 09:41'!
nilValue
	^ nilValue! !

!SqSCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/10/2008 09:41'!
nilValue: anObject
	nilValue := anObject! !

!SqSCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderField
	^ orderField! !

!SqSCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderField: anObject
	orderField := anObject! !

!SqSCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderedCollections
	^ orderedCollections! !

!SqSCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderedCollections: anObject
	orderedCollections := anObject! !

!SqSCollectionConfiguration methodsFor: 'as yet unclassified' stamp: 'tkow 11/7/2008 17:01'!
storeOn: aStream
	aStream nextPutAll: self sqsCodeForObjectCreation! !

!SqSCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
valueField
	^ valueField! !

!SqSCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
valueField: anObject
	valueField := anObject! !

Object subclass: #SqSCollectionInformation
	instanceVariableNames: 'collection collectionDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collection
	^ collection! !

!SqSCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collection: anObject
	collection := anObject! !

!SqSCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collectionDescription
	^ collectionDescription! !

!SqSCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collectionDescription: anObject
	collectionDescription := anObject! !

Object subclass: #SqSConfiguration
	instanceVariableNames: 'connectionSpec descriptionHandlerClass collectionConfiguration tableConfiguration mode useInstVarAccessors objectCaching'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSConfiguration commentStamp: 'tkow 12/4/2008 16:02' prior: 0!
A SqSConfiguration is the main class for the configuration of SqueakSave. It defines some fundamental options by itself and links to the other configuration classes for detailed configuration of merely all aspects of the mapper. Instances of this class should be created on the class side of the class they are valid for, and will be used for all subclasses, also.

Instance Variables
	collectionConfiguration:		SqSCollectionconfiguration
	connectionSpec:		SqSConnectionSpecification
	descriptionHandlerClass:		Symbol
	mode:		Symbol
	objectCaching:		Symbol
	tableConfiguration:		SqSTableConfiguration
	useInstVarAccessors:		Boolean

collectionConfiguration
	- xxxxx

connectionSpec
	- xxxxx

descriptionHandlerClass
	- xxxxx

mode
	- xxxxx

objectCaching
	- xxxxx

tableConfiguration
	- xxxxx

useInstVarAccessors
	- xxxxx
!

!SqSConfiguration class methodsFor: 'modes' stamp: 'tkow 11/7/2008 16:04'!
developmentMode
	^#development! !

!SqSConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/4/2008 15:51'!
globalCaching
	^ #global! !

!SqSConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/4/2008 15:51'!
localCaching
	^ #local! !

!SqSConfiguration class methodsFor: 'modes' stamp: 'tkow 11/7/2008 15:31'!
productionMode
	^#production! !

!SqSConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/4/2008 15:51'!
standardCachingMode
	^ self globalCaching! !

!SqSConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:35'!
standardCollectionConfiguration
	^ SqSCollectionConfiguration new! !

!SqSConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 16:20'!
standardForInstVarAccess
	^ true! !

!SqSConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/11/2008 01:43'!
standardHandlerClass
	^ SqSStandardExternDescriptionHandler ! !

!SqSConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 17:20'!
standardTableConfiguration
	^ SqSTableConfiguration activeRecordStyle "SqSTableConfiguration new"! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
collectionConfiguration
	^ collectionConfiguration! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
collectionConfiguration: anObject
	collectionConfiguration := anObject! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
connectionSpec
	^ connectionSpec! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
connectionSpec: anObject
	connectionSpec := anObject! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
descriptionHandlerClass
	^ descriptionHandlerClass! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
descriptionHandlerClass: anObject
	descriptionHandlerClass := anObject! !

!SqSConfiguration methodsFor: 'initialization' stamp: 'tkow 12/4/2008 15:50'!
initialize
	super initialize.
	self descriptionHandlerClass: self class standardHandlerClass.
	self collectionConfiguration: self class standardCollectionConfiguration.
	self mode: self class developmentMode.
	self tableConfiguration: self class standardTableConfiguration.
	self useInstVarAccessors: self class standardForInstVarAccess.
	self objectCaching: self class standardCachingMode.
	! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 14:11'!
mode
	^ mode! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 14:11'!
mode: anObject
	mode := anObject! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 12/4/2008 15:50'!
objectCaching
	^ objectCaching! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 12/4/2008 15:50'!
objectCaching: anObject
	objectCaching := anObject! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 14:10'!
tableConfiguration
	^ tableConfiguration! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 14:10'!
tableConfiguration: anObject
	tableConfiguration := anObject! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:19'!
useInstVarAccessors
	^ useInstVarAccessors! !

!SqSConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:19'!
useInstVarAccessors: anObject
	useInstVarAccessors := anObject! !

Object subclass: #SqSConnection
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqSConnection commentStamp: 'tkow 10/27/2008 14:41' prior: 0!
A SqSConnection is merely an interface for all the different connection classes used by
the different database server clients. In contrast to the database adapters they are only ment to control
the connections via a common interface even from without the controllers, so that mixed up postgresql,
mysql or other connections can be handled by the same connection manager 

Instance Variables
	connection:		anObject, instance of i.e. JdmConnection

connection
	- xxxxx
!

!SqSConnection class methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 15:28'!
withConnection: aConnection
	^self new
		connection: aConnection;
		yourself
	! !

!SqSConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:36'!
close
	self subclassResponsibility! !

!SqSConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:41'!
connection
	^ connection! !

!SqSConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:41'!
connection: anObject
	connection := anObject! !

!SqSConnection methodsFor: 'connection-control' stamp: 'tkow 10/29/2008 13:25'!
executeQuery: anSqlQuery
	self subclassResponsibility! !

!SqSConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 17:04'!
init
	self subclassResponsibility! !

!SqSConnection methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 14:37'!
isAlive
	self subclassResponsibility.! !

!SqSConnection methodsFor: 'connection-control' stamp: 'tkow 10/29/2008 13:49'!
nextRowFromResult: result
	self subclassResponsibility! !

!SqSConnection methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 17:05'!
reconnect
	self isAlive ifTrue: [
		self close.	
	].
	self init.! !

!SqSConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 15:29'!
rowDictionariesForResultSet: result
	^self subclassResponsibility! !

SqSConnection subclass: #SqSMySqlConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqSMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 14:42'!
close
	connection close! !

!SqSMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/29/2008 13:32'!
executeQuery: anSqlQuery
	^ (connection createStatement) executeQuery: (anSqlQuery)! !

!SqSMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 17:05'!
init
	connection initialize2! !

!SqSMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 17:14'!
isAlive
	^(connection socket notNil) and: [connection socket isConnected]! !

!SqSMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/29/2008 14:04'!
nextRowFromResult: result
	^ result next ifTrue: [
		result currentRowAsDictionary 
	] ifFalse: [
		nil
	]! !

!SqSMySqlConnection methodsFor: 'converting' stamp: 'tkow 10/29/2008 13:47'!
rowDictionariesForResultSet: result 
	| resultDicts |
	resultDicts := OrderedCollection new.
	"store all data rows in our own structure - this way we can issue new commands upon object creation"
	[ result next ] whileTrue: [ 
		resultDicts add: result currentRowAsDictionary 
	].
	^resultDicts! !

Object subclass: #SqSConnectionManager
	instanceVariableNames: 'connectionPool connectionSpecificationDictionary monitor connectionCount adapterPool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

SqSConnectionManager class
	instanceVariableNames: 'ConnectionManager ManagerPool'!

SqSConnectionManager class
	instanceVariableNames: 'ConnectionManager ManagerPool'!

!SqSConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 17:39'!
getInstance
	ConnectionManager ifNil: [
		ConnectionManager := self new.	
	].
	^ConnectionManager! !

!SqSConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 11:50'!
getInstanceFor: aSymbol
	^(ManagerPool ifNil: [
		Dictionary new	
	]) at: aSymbol ifAbsentPut: [self new]! !

!SqSConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 11:50'!
reset
	ManagerPool := Dictionary new.
	ConnectionManager := nil.! !

!SqSConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:43'!
testCategory
	^'SqSave'! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/4/2008 16:18'!
adapterForCategory: aCategoryName 
	| cSpec |
	cSpec := self connectionSpecificationDictionary 
		at: aCategoryName
		ifAbsent: [self noConnectionSpecFoundErrorFor: aCategoryName ].
	^ self adapterForConnectionSpecification: cSpec! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/29/2008 14:15'!
adapterForClass: aClass
	| stringsToTry cSpec currentString |
	stringsToTry := OrderedCollection with: aClass name.
	stringsToTry addAll: (aClass category asString subStrings: '-').
	cSpec := nil.
	[stringsToTry notEmpty and: [cSpec isNil]] whileTrue: [
		currentString := stringsToTry removeFirst.
		cSpec := self connectionSpecificationDictionary at: currentString ifAbsent: [nil]
	].
	cSpec ifNil: [
		self noConnectionSpecFoundErrorFor: aClass name
	] ifNotNil: [
		^self adapterForConnectionSpecification: cSpec
	]
	! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 11/25/2008 13:04'!
adapterForConnectionSpecification: cSpec
	| adapterClass adapter |
	adapterClass := Smalltalk 
		at: cSpec driverClass 
		ifAbsent: [self unknownClassError: cSpec driverClass].
	adapter := self adapterPool at: Processor activeProcess ifAbsentPut: [
		adapterClass withConnectionSpecification: cSpec.	
	].
	(adapter class ~= adapterClass) ifTrue: [
		adapter := adapterClass withConnectionSpecification: cSpec.
		self adapterPool at: Processor activeProcess put: adapter.	
	].
	
	"just to be sure that we don't use the wrong connection spec'"
	adapter connectionSpecification: cSpec.
	^ adapter! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/27/2008 10:30'!
adapterForName: aString
	| cSpec |
	cSpec := self connectionSpecificationDictionary 
		at: aString
		ifAbsent: [self noConnectionSpecFoundErrorFor: aString ].
	^self adapterForConnectionSpecification: cSpec! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:56'!
adapterPool
	^ adapterPool! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:56'!
adapterPool: anObject
	adapterPool := anObject! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 11/3/2008 14:20'!
closeAllConnections
	"this will close all connection lying around somewhere in the pool
	and additionally clear the pool and the connection count"
	| con |
	self connectionPool valuesDo: [:conQueue |
		con := conQueue	nextOrNil.
		[con notNil] whileTrue: [
			con close.
			con := conQueue nextOrNil.
		]
	].
	connectionCount := Dictionary new.
	connectionPool := Dictionary new.! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool
	^ connectionPool! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool: anObject
	connectionPool := anObject! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary
	^ connectionSpecificationDictionary! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary: anObject
	connectionSpecificationDictionary := anObject! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/29/2008 13:39'!
getConnectionFor: anSqsConSpec	
	| queue conCount connection cidStr |
	cidStr := anSqsConSpec connectionIdentityString.
	monitor critical: [
		conCount := connectionCount at: cidStr ifAbsentPut: 0.
		queue := connectionPool at: cidStr ifAbsentPut: [SharedQueue2 new].	
	].
	connection := queue nextOrNil.
	monitor critical: [
		(connection isNil and: [conCount < anSqsConSpec maxConnections]) ifTrue: [
			queue nextPut: ((Smalltalk at: anSqsConSpec driverClass) newConnectionFor: anSqsConSpec).
			connectionCount at: cidStr put: (conCount + 1).
			connection := queue next
		].
	].
	connection ifNil: [
		connection := queue next	
	].
	^connection
	
	! !

!SqSConnectionManager methodsFor: 'initialization' stamp: 'tkow 11/18/2008 11:36'!
initialize
	connectionSpecificationDictionary := Dictionary new.
	connectionPool := Dictionary new.
	monitor := Monitor new.
	connectionCount := Dictionary new.
	adapterPool := WeakIdentityKeyDictionary new.! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/27/2008 10:27'!
noConnectionSpecFoundErrorFor: aString
	self error: ('No connection Specification found for ', aString)! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/29/2008 13:10'!
releaseConnection: aConnection for: anSqsConSpec	
	| queue |
	queue := connectionPool
				at: anSqsConSpec connectionIdentityString 
				ifAbsent: [self error: 'How did you get that connection anyway?'].	
	queue nextPut: aConnection
	! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 11/3/2008 14:19'!
resetConnections
	SqSConnection allInstances do: [:sqsCon |
		sqsCon reconnect.	
	].! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/27/2008 10:06'!
setupConnectionSpecification: aConnectionSpecification for: aString
	"setUp the connection specification for a class or category. so basically without setting up a 
	connection specification for a class or category, the nice and easy #save will not work"
	self connectionSpecificationDictionary at: aString asString put: aConnectionSpecification.
	! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/27/2008 10:33'!
unknownClassError: className
	self error: 'The driver class: ', className, ' is unknown in this image'.! !

Object subclass: #SqSConnectionSpecification
	instanceVariableNames: 'username password database port hostname driverClass maxConnections connectionIdentityString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 09:54'!
standardQueueSize
	^20! !

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 9/29/2008 14:07'!
user: aUsername password: aPassword database: aDatabaseName 
	"just for the lazy people like me - creates a mysql connection..."
	^ self new
		username: aUsername;
		password: aPassword;
		port: 3306;
		database: aDatabaseName;
		driverClass: #SqSMySqlAdapter;
		hostname: 'localhost'! !

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: 'localhost'.! !

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName hostname: aHostname driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:45'!
connectionIdentityString
	connectionIdentityString ifNil: [
		connectionIdentityString := (self driverClass asString),'#',(self username),'@',(self hostname),':',(self port asString),'/',(self database)
	].
	^connectionIdentityString
	! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database
	^ database! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database: anObject
	database := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass
	^ driverClass! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass: anObject
	driverClass := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname
	^ hostname! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname: anObject
	hostname := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 09:55'!
maxConnections
	^maxConnections ifNil: [self class standardQueueSize]! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 09:53'!
maxConnections: anObject
	maxConnections := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password
	^ password! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password: anObject
	password := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port
	^ port! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port: anObject
	port := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username
	^ username! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username: anObject
	username := anObject! !

Object subclass: #SqSDbAdapter
	instanceVariableNames: 'connection connectionSpecification isInTransaction usesConnectionPool objectCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqSDbAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:55'!
defaultColumn
	^'Default'! !

!SqSDbAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:55'!
extraColumn
	^'Extra'! !

!SqSDbAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
fieldNameColumn
	^'Field'! !

!SqSDbAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:54'!
keyColumn
	^'Key'! !

!SqSDbAdapter class methodsFor: 'instance creation' stamp: 'tkow 10/27/2008 15:08'!
newConnectionFor: anSqsConSpec
	"this method is meant to create new instances of the designated connection class
	for the database client of the corresponding flavour - so for a Mysql adapter this should return
	an SqSMySqlConnection holding a JdmConnection. For PostgreSql an SqSPostgreSqlConnection holding
	the postgreSql connection delivered with the postgre client"
	self subclassResponsibility! !

!SqSDbAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
nullColumn
	^'Null'! !

!SqSDbAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
typeColumn
	^'Type'! !

!SqSDbAdapter class methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:34'!
withConnectionSpecification: anSqsConSpec
	^self new
		connectionSpecification: anSqsConSpec;
		yourself! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:42'!
addColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAddColumn: column).	
		]
	"]"
	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 9/16/2008 22:38'!
addEntries: addedIds inJoinTable: aDescription forOwnerId: oid
	addedIds do: [:ids |
		| sql |
		sql	:= self queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid.
		self executeQuery: sql.
	]	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/30/2008 15:25'!
allTableNames
	| result resultDicts tableNames |
	result := self executeQuery: 'SHOW TABLES' andDropConnection: false.
	resultDicts := self connection rowDictionariesForResultSet: result.
	self freeConnection.
	tableNames := OrderedCollection new.
	resultDicts
		do: [:dict | dict
				valuesDo: [:tableName | tableNames add: tableName]].
	^ tableNames! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:47'!
alterColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAlterColumn: column).	
		]
	"]"
	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 14:02'!
assembleObjectFrom: splitRows forSearch: anSqsQuery
	| targetClass targetObject currentValues oid tableConf |
	anSqsQuery valueTables withIndexDo: [:aliasedTable :index |
		currentValues := splitRows at: index.
		tableConf := (SqSClassInfo for: aliasedTable queryClass) configuration tableConfiguration.
		oid := currentValues at: tableConf idField.
		targetClass := self objectClassForRow: currentValues ofAliasedTable: aliasedTable withConfiguration: tableConf.
		targetClass ifNil: [^ nil].
		
		targetObject := self cachedObjectOf: targetClass withOid: oid.
		targetObject ifNil: [
			targetObject := self 
				newObjectWithOid: oid
				ofClass: targetClass 
				fromRow: currentValues 
				ofTable: aliasedTable.
		]
	].
	^ targetObject! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:32'!
boolean
	^'BOOLEAN'.! !

!SqSDbAdapter methodsFor: 'object-caching' stamp: 'tkow 9/29/2008 16:24'!
cacheObject: anObject withOid: oid 
	SqSStorage 
		cacheObject: anObject
		withOid: oid! !

!SqSDbAdapter methodsFor: 'object-caching' stamp: 'tkow 9/29/2008 16:24'!
cachedObjectOf: targetClass withOid: oid 
	^ SqSStorage 
		cachedObjectOfClass: targetClass
		withOid: oid! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/30/2008 15:25'!
checkTableExistance: aTableName 
	| result resultDicts tableExists |
	result := self executeQuery: 'SHOW TABLES' andDropConnection: false.
	resultDicts := self connection rowDictionariesForResultSet: result.
	self freeConnection.
	tableExists := resultDicts anySatisfy: [:dict | dict values includes: aTableName].
	^ tableExists! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/29/2008 14:21'!
commitTransaction	
	self executeQuery:(self queryForCommit).
! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 12/5/2008 13:38'!
completeWhereStatementFor: anSqsQuery
	| sql aliasedTable |
	sql := ' WHERE (', anSqsQuery whereBuffer, ')'.
	aliasedTable := anSqsQuery valueTables first.
	
	anSqsQuery ignoreTypeField ifFalse: [
		sql := sql, ' AND ('.
		sql := sql, ((aliasedTable queryClass withAllSubclasses collect: [:aClass |
			(aliasedTable aliasedName), '.', (aliasedTable originalTable typeColumn columnName),	' = ', aClass name asSqlValueString
		]) join: ' OR ').	
		sql := sql, ')'.
	].
	^ sql! !

!SqSDbAdapter methodsFor: 'connection-control' stamp: 'tkow 10/30/2008 15:05'!
connection
	^connection! !

!SqSDbAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connection: anObject
	connection := anObject! !

!SqSDbAdapter methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 10:37'!
connectionIdentityString
	^self connectionSpecification connectionIdentityString! !

!SqSDbAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connectionSpecification
	^ connectionSpecification! !

!SqSDbAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connectionSpecification: anObject
	connectionSpecification := anObject! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 12/1/2008 14:44'!
createObjectsFrom: rowDictionaries forSearch: anSqsQuery
	
	| objects prefixIndexes splitRows splitColName ix |
	objects := OrderedCollection new.
	prefixIndexes := Dictionary new.
	anSqsQuery valueTables withIndexDo: [:aliasedTable :index |
		aliasedTable allAliasedNames do: [ :aliasedName |
			prefixIndexes at: aliasedName put: index	
		]
	].

	rowDictionaries do: [:rowDict |
		splitRows := OrderedCollection new.
		1 to: anSqsQuery valueTables size do: [:i | splitRows add: Dictionary new].
		rowDict associationsDo: [:column |
			splitColName := column key subStrings: '.'.
			ix := prefixIndexes at: (splitColName first) ifAbsent: [self error: 'oopsie'].
			(splitRows at: ix)	 at: splitColName last put: column value.
		].
		objects add: (self assembleObjectFrom: splitRows forSearch: anSqsQuery).
	].
	^objects! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/7/2008 17:28'!
createTable: anSqSTable
	| query |
	query := self queryToCreateTable: anSqSTable.
	self executeQuery: query.
	(SqSStorage tableCacheForConnection: self connectionIdentityString) 
		at: anSqSTable tableName
		put: true
	! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
date
	^'DATE'.! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
dateAndTime
	^'DATETIME'.
	! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
decimalIntegerSize: m scale: d
	^'DECIMAL('m asString,',',d asString,')'.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 9/16/2008 21:32'!
deleteEntriesFromJoinTable: collectionDescription forObjectId: oid 
	| sql |
	sql := self 
		queryToRemoveEntriesFromJoinTable: collectionDescription
		forObjectId: oid.
	self executeQuery: sql! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
double
	^'DOUBLE'.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/30/2008 15:29'!
executeQuery: anSqlQuery
	| |
	^self executeQuery: anSqlQuery andDropConnection: true! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 11:19'!
executeQuery: anSqlQuery andDropConnection: aBool
	| result |
	self log: anSqlQuery.
	self getConnectionIfNecessary.
	result := [self connection executeQuery: (anSqlQuery)] ifError: [ :err |
		self freeConnection.
		self error: err
	].
	aBool ifTrue: [self freeConnection].
	^ result
	! !

!SqSDbAdapter methodsFor: 'data-preparation' stamp: 'tkow 11/10/2008 15:57'!
explicitColumnsOfTable: anSqSQueryTable 
	| sql classTable aliasName childQueryTable aliasedColumns |
	classTable := anSqSQueryTable originalTable.
	aliasName := anSqSQueryTable aliasedName.
	aliasedColumns := OrderedCollection new.
	classTable columns do: [ :column | 
		((column = classTable oidColumn) and: [classTable parent notNil]) ifFalse: [
			aliasedColumns add: (classTable tableName , '.' , column columnName , ' AS ''' , aliasName , '.' , column columnName , '''' )
		] 
	].
	sql := (aliasedColumns join: ', ').
	classTable children do: 
		[ :childTable | 
		childQueryTable := SqSQueryTable 
			table: childTable
			alias: anSqSQueryTable aliasSuffix
			field: nil.
		sql := sql , ', ' , (self explicitColumnsOfTable: childQueryTable) ].
	^ sql! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
float
	^'FLOAT'.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 15:17'!
freeConnection
	(isInTransaction not and: [usesConnectionPool]) ifTrue: [
		connection ifNotNil: [
			SqSConnectionManager getInstance releaseConnection: connection for: connectionSpecification.
			connection := nil.	
		].
	]! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 9/16/2008 15:09'!
getCollectionDescribedBy: descr forObject: anObject 
	^ descr simpleValues 
		ifTrue: 
			[ self 
				getSimpleCollectionDescribedBy: descr
				forObject: anObject ]
		ifFalse: 
			[ self 
				getComplexCollectionDescribedBy: descr
				forObject: anObject ]! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 13:37'!
getComplexCollectionDescribedBy: descr forObject: anObject 
	| collectionConf referenceClassInfo referenceConf query classTable queryTable joinTable joinQueryTable refIdField childQueryTable childLink |

	collectionConf := anObject configuration collectionConfiguration.
	referenceClassInfo := (SqSClassInfo for: (Smalltalk at: descr referencedClass)).
	referenceConf := referenceClassInfo configuration tableConfiguration.
	
	query := SqSQuery on: (referenceClassInfo currentClass).
	query whereBuffer: ( descr joinTableName,'.', descr ownerColumn columnName, ' = ', anObject oid asSqlValueString).
	query orderBy: (collectionConf orderField).
	
	classTable := anObject classInfo classTable baseTable.
	queryTable := SqSQueryTable table: (classTable) alias: '' field: '' class: anObject classInfo baseClass.
	
	joinTable := SqSTable new.
	joinTable tableName: descr joinTableName.
	
	joinQueryTable := SqSQueryTable table: joinTable alias: ''  field: ''  class: nil.

	refIdField := referenceConf idField.
	
	joinQueryTable tableLinks add: (SqSTableLink 
		table: queryTable 
		fromField: collectionConf valueField 
		toField:  refIdField
		direction: 'LEFT OUTER'
	).

	classTable allChildTables do: [:childTable | 
		childQueryTable := SqSQueryTable table: childTable alias: '' field: nil.
		childLink := SqSTableLink table: childQueryTable fromField: refIdField toField: refIdField direction: 'LEFT OUTER'.
		queryTable tableLinks add: childLink.
	].

	query valueTables add: queryTable.
	query queryTables add: joinQueryTable.
	query ignoreTypeField: true.
	^ self performSearch: query! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 11/5/2008 16:24'!
getConnectionIfNecessary
	(connection isNil and: [usesConnectionPool]) ifTrue: [
		connection := SqSConnectionManager getInstance getConnectionFor: connectionSpecification.	
		connection isAlive ifFalse: [connection reconnect].	
	]! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/30/2008 15:27'!
getSimpleCollectionDescribedBy: descr forObject: anObject 
	| sql resultDicts results value result |
	sql := self 
		queryToGetSimpleValuesForCollection: descr
		ofObjectId: anObject oid.
	result := self executeQuery: sql andDropConnection: false. 
	resultDicts := self connection rowDictionariesForResultSet: result.
	self freeConnection.
	results := OrderedCollection new.
	resultDicts do: 
		[ :resultRow | 
		value := resultRow 
			at: descr referenceColumn columnName
			ifAbsent: [ nil ].
		results add: value ].
	^ results! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:15'!
inTransactionDo: aBlock
	self inTransactionDo: aBlock onError: [self rollback].! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 15:16'!
inTransactionDo: aBlock onError: anErrorBlock
	isInTransaction := true.
	self startTransaction.
	[aBlock value] ifError: [:err |
		self freeConnection.
		anErrorBlock value.
	].
	self commitTransaction.
	isInTransaction := false.
	self freeConnection.
	! !

!SqSDbAdapter methodsFor: 'initialization' stamp: 'tkow 11/18/2008 11:45'!
initialize
	super initialize.
	isInTransaction := false.
	usesConnectionPool := true.! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
integer
	^'INTEGER'.! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'tkow 9/24/2008 16:18'!
largeInteger
	^'TEXT'.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/9/2008 17:35'!
lastOidFromTable: aTableName
	self subclassResponsibility! !

!SqSDbAdapter methodsFor: 'logging' stamp: 'tk 7/29/2008 11:57'!
log: aString
	"TODO: viable solution for logging - Transcript is just weigh to slow"
	Transcript show: '+++++++++++++++++++';
		show: String cr;
		show: aString;
		show: String cr.! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
mediumInteger
	^'MEDIUMINT'.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 9/16/2008 22:37'!
moveEntries: movedIds inJoinTable: aDescription forOwnerId: oid
	| sql |
	movedIds do: [:ids |
		sql := self queryToUpdateEntries: ids inJoinTable: aDescription forOwnerId: oid.
		self executeQuery: (sql).
	]
	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 14:01'!
newObjectWithOid: oid ofClass: targetClass fromRow: currentValues ofTable: aliasedTable
	| newObject storageHelper |
	
	newObject := targetClass basicNew.
	self cacheObject: newObject withOid: oid.
	storageHelper := SqSStorage for: newObject.
	aliasedTable originalTable allColumns do: [:col |
		storageHelper 
			setInstVarNamed: col linkedVariable 
			withValue: (currentValues at: col columnName).
	].
	storageHelper indirectlyReferencedObjects do: [ :collectionDescr |
		storageHelper
			setInstVarNamed: collectionDescr collectionDescription linkedVariable
			withValue: nil 
	].
	^ newObject	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 13:56'!
objectClassForRow: currentValues ofAliasedTable: aliasedTable withConfiguration: tableConf
	| targetClassName |
	targetClassName := currentValues at: tableConf typeField ifAbsent: [self error: 'no type field found'].
	targetClassName ifNil:[
		^ nil	
	] ifNotNil: [
		^ Smalltalk at: targetClassName asSymbol ifAbsent: [aliasedTable queryClass].
	]
	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/14/2008 13:14'!
performSearch: anSqsQuery
	| |
	^self performSearch: anSqsQuery withLimit: nil
	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 10/30/2008 15:27'!
performSearch: anSqsQuery withLimit: limit
	| sql results rowDictionaries |
	sql := self queryForSearch: anSqsQuery withLimit: limit.
	results := self executeQuery: sql andDropConnection: false.
	rowDictionaries := self connection rowDictionariesForResultSet: results.
	self freeConnection.
	^self createObjectsFrom: rowDictionaries forSearch: anSqsQuery.
	! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/27/2008 13:51'!
queryAliasedTableInFromClause: aliasedTable

	| sql joinTables joinConditions |
	sql := aliasedTable originalTable tableName, ' AS ', aliasedTable aliasedName.
	
	joinTables := OrderedCollection new.
	joinConditions := OrderedCollection new.
	
	"join them consequitvely - when performance issues arise, change the join order"
	aliasedTable tableLinks do: [:tableLink |
		
		sql := sql, ' ', tableLink joinDirection, ' JOIN '.
		sql := sql, '(',(self queryAliasedTableInFromClause: tableLink toTable), ') ON ('.
		
		sql := sql, ((tableLink fromFields collectWithIndex: [:field :index |
			aliasedTable aliasedName,'.', field ,' = ', tableLink toTable aliasedName, '.', (tableLink toFields at: index).
		]) join: ' AND ').
		sql := sql, ')'
	].
	^ sql ! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'wh 8/10/2006 17:05'!
queryForCommit
	^'COMMIT'.! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tk 7/10/2008 17:15'!
queryForForeignKeyConstraint: aForeignKeyDescription ofColumn: aColumnName
	| sql |
	sql := 'FOREIGN KEY (',aColumnName,') REFERENCES '.
	sql := sql, aForeignKeyDescription referencedTable,'(', aForeignKeyDescription referencedColumns first,') '.
	aForeignKeyDescription deleteActions ifNotEmpty: [sql := sql, 'ON DELETE'].
	aForeignKeyDescription deleteActions do: [:action | sql := sql, ' ',action].
	aForeignKeyDescription updateActions ifNotEmpty: [sql := sql, 'ON UPDATE'].
	aForeignKeyDescription updateActions do: [:action | sql := sql, ' ',action].
	^sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'wh 8/11/2006 09:23'!
queryForRollback
	^'ROLLBACK'.! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/27/2008 12:47'!
queryForSearch: anSqsQuery withLimit: limit
	| sql |
	sql := 'SELECT '.
	anSqsQuery valueTables do: [:aliasedTable |
		sql := sql, (self explicitColumnsOfTable: aliasedTable)
	].
	sql := sql,' FROM '.

	sql := sql, ((anSqsQuery queryTables collect: [:aliasedTable |
		(self queryAliasedTableInFromClause: aliasedTable)
	]) join: ', ').

	sql := sql, (self completeWhereStatementFor: anSqsQuery).
	
	anSqsQuery orderBy ifNotNil: [
		sql := sql, ' ORDER BY ', anSqsQuery orderBy
	].
	
	limit ifNotNil: [
		sql := sql, ' LIMIT ', limit asString
	].
	^sql
	! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'wh 8/13/2006 12:41'!
queryForStartTransaction
	^'START TRANSACTION'.! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:54'!
queryToAddColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' ADD COLUMN '.
	sql := sql, aColumn columnName, ' ', (self perform: aColumn sqlType).
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 14:47'!
queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid
	| sql |
	"orderNumber := movedIds at: 2.
	newObjectId := movedIds at: 1."	
	
	sql := 'INSERT INTO ', aDescription joinTableName, '('.
	sql := sql, aDescription ownerColumn columnName, ', ', aDescription referenceColumn columnName. 
	aDescription maintainOrder ifTrue: [
		sql := sql, ', ', aDescription configuration orderField
	].
	sql := sql, ') VALUES (', oid asString, ','.
	sql := sql, (((ids at:1) ifNil: [aDescription configuration nilValue] ifNotNil: [ids at: 1]) asSqlValueString),', '.
	sql := sql, ((ids at: 2) asSqlValueString), ')'.
	^sql
	! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:54'!
queryToAlterColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' MODIFY '.
	sql := sql, aColumn columnName, ' ', (self perform: aColumn sqlType).
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/3/2008 18:42'!
queryToCreateColumn: column
	| sql |
	sql := column columnName, ' ',(self perform: column sqlType).
	column canBeNull ifFalse: [
		sql := sql, ' NOT NULL'.
	].
	column autoIncrement ifTrue: [
		sql := sql, ' AUTO_INCREMENT '
	].
	column foreignKey ifNotNil: [
		sql := sql, ', ', (self queryForForeignKeyConstraint: column foreignKey ofColumn: column columnName)
	].
	^sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/3/2008 18:36'!
queryToCreateTable: anSqSTable
	| sql primaryKeyColumns |
	sql := 'CREATE TABLE ' , anSqSTable tableName , ' ('.

	sql := sql, ((anSqSTable columns collect: [:column |
		self queryToCreateColumn: column
	]) join: ', ').

	primaryKeyColumns := (anSqSTable columns select: [ :column | column isPrimaryKey ]) collect: [ :column | column columnName ].
	sql := sql , ', PRIMARY KEY (' , (primaryKeyColumns join: ', ') , ')'.
	sql := sql , ')'.
	^ sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 14:45'!
queryToGetSimpleValuesForCollection: descr ofObjectId: oid
	| sql |
	sql := 'SELECT * FROM ', descr joinTableName.
	sql := sql, ' WHERE ', descr ownerColumn columnName,' = ', oid asSqlValueString.
	descr maintainOrder ifTrue: [
		sql := sql, ' ORDER BY ', descr configuration orderField
	].
	^sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 9/29/2008 14:46'!
queryToInsertColumns: columnDict inTable: aTableName
	| sql keys values |
	sql := 'INSERT INTO ', aTableName,' ('.
	keys := ''.
	values := ''.
	columnDict associationsDo: [:assoc |
		keys := keys, assoc key, ', '.
		values := values, assoc value asString, ', '.	
	].
	sql := sql, (keys allButLast: 2), ') VALUES (', (values allButLast: 2), ')'.
	^sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:46'!
queryToRemoveColumn: aColumn
	^'ALTER TABLE ',aColumn tableName,' DROP COLUMN ', aColumn columnName.! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 9/16/2008 21:26'!
queryToRemoveEntriesFromJoinTable: collectionDescr forObjectId: oid
	| sql |
	sql := 'DELETE FROM ', collectionDescr joinTableName, ' WHERE '.
	sql := sql, collectionDescr ownerColumn columnName, ' = ', oid asSqlValueString.
	^sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tk 8/29/2008 15:31'!
queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid
	| sql |
	sql := 'DELETE FROM ', aDescription joinTableName, ' WHERE '.
	sql := sql, columnName, ' IN (', (ids join: ','), ') AND '.
	sql := sql, aDescription ownerColumn columnName, ' = ', oid asString.
	^sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 15:28'!
queryToRemoveObjectWithId: oid fromTable: aTable
	
	^'DELETE FROM ', aTable tableName,' WHERE ',aTable oidColumn columnName,' = ',oid asString.! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:55'!
queryToRenameColumns: columnsCollection
	| oldColumn sql newColumn |
	oldColumn := columnsCollection first.
	newColumn := columnsCollection at: 2.
	sql := 'ALTER TABLE ', oldColumn tableName, ' CHANGE '.
	sql := sql, oldColumn columnName, ' ', newColumn columnName, ' ', (self perform: newColumn sqlType).
	^sql 
	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 14:05'!
queryToRenameTable: oldName to: newName
	^ 'ALTER TABLE ',oldName, ' RENAME TO ', newName
! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 14:28'!
queryToUpdateEntries: movedIds inJoinTable: aDescription forOwnerId: oid 
	"orderNumber := movedIds at: 2.
	newObjectId := movedIds at: 1."
	| sql |
	sql := 'UPDATE ' , aDescription joinTableName , '	SET '.
	sql := sql , aDescription referenceColumn columnName , ' = '
				, (((movedIds at: 1)
						ifNil: [aDescription configuration nilValue]
						ifNotNil: [movedIds at: 1]) asSqlValueString).
	sql := sql , ' WHERE ' , aDescription ownerColumn columnName , ' = ' , oid asString.
	sql := sql , ' AND ' , aDescription configuration orderField , ' = ' , (movedIds at: 2) asString.
	^ sql! !

!SqSDbAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 14:34'!
queryToUpdateFields: columnDict ofObjectWithId: oid inTable: aTable
	| sql |
	sql := 'UPDATE ' , aTable tableName , ' SET '.
	columnDict associationsDo: [:assoc | sql := sql , assoc key , ' = ' , assoc value asString , ', '].
	sql := (sql allButLast: 2) 	, ' WHERE ', aTable oidColumn columnName ,' = ' , oid asString.
	^sql! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:45'!
removeColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToRemoveColumn: column).	
		]
	"]"
	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 14:45'!
removeEntries: deletedIds fromJoinTable: aDescription forOwnerId: oid
	| sql ids columnName |
	aDescription maintainOrder ifTrue: [
		ids := deletedIds collect: [: dids | dids last].
		columnName := aDescription configuration orderField.
	] ifFalse: [
		ids := deletedIds collect: [: dids | dids first].
		columnName := aDescription referenceColumn columnName
	].
	sql := self queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid.
	self executeQuery: sql.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 13:58'!
removeObjectWithId: oid fromTable: aSqSTable
	| sql |
	" this method has to be overwritten if the database can not guarantee that the entries
	in all available class table are removed when one object is being removed"
	sql := self queryToRemoveObjectWithId: oid fromTable: aSqSTable baseTable.
	self executeQuery: (sql).! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:41'!
renameColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:columnPair |
			self executeQuery: (self queryToRenameColumns: columnPair).	
		]
	"]"
	! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 14:04'!
renameTable: oldName to: newName
	| sql |
	sql := self queryToRenameTable: oldName to: newName.
	self executeQuery: sql.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 9/29/2008 16:24'!
resetDatabase
	| tables |
	tables := self allTableNames.
	tables ifNotEmpty: 
		[ "the second one is for tables that are somehow linked to others by foreign key constraints"
		[ self executeQuery: 'DROP TABLE IF EXISTS ' , (tables join: ', ') ] 
			on: Error
			do: [ self executeQuery: 'DROP TABLE IF EXISTS ' , (tables join: ', ') ] ].
	SqSStorage flushTableCacheForConnection: self connectionIdentityString! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tk 7/18/2008 16:22'!
rollback
	"self localCache do:[:object | object rollback ].
	self rollbackDbTransaction."
	"self executeQuery: 'ROLLBACK'"! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'wh 8/11/2006 09:24'!
rollbackDbTransaction
	self executeQuery:(self queryForRollback) .! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 11/18/2008 14:52'!
showFieldsOfTable: aTableName
	| result resultDicts |
	result := self executeQuery: ('SHOW FIELDS FROM ', aTableName)  andDropConnection: false.
	resultDicts := self connection rowDictionariesForResultSet: result.
	self freeConnection.
	^ resultDicts! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
smallInteger
	^'SMALLINT'! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:18'!
startTransaction
	self executeQuery:(self queryForStartTransaction).! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tk 7/14/2008 15:42'!
storeColumns: columnDict inTable: aTableName
	self storeColumns: columnDict inTable: aTableName  andReturnOId: false.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 9/29/2008 14:46'!
storeColumns: columnDict inTable: aTableName andReturnOId: aBool
	"columnDict is a Dictionary where a SqSaveColumnDescription points to the stored value"
	| sql |
	sql := self queryToInsertColumns: columnDict inTable: aTableName.
	self executeQuery: (sql).
	aBool ifTrue: [
		^self lastOidFromTable: aTableName	
	].! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
string
	^self stringWithLength: 254.
	! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 23:21'!
stringWithLength: m
	^'VARCHAR(',m asString,')'.! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
text
	^'TEXT'.! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
time
	^'TIME'.! !

!SqSDbAdapter methodsFor: 'column types' stamp: 'wh 8/16/2006 22:18'!
unsignedInteger
	"The SQL standard does not support unsigned Integer 
		imagine my suprise "
	^'INTEGER '.! !

!SqSDbAdapter methodsFor: 'database operations' stamp: 'tkow 11/10/2008 13:57'!
updateFields: columnDict ofObjectWithId: oid inTable: aTable
	| sql |
	sql := self queryToUpdateFields: columnDict ofObjectWithId: oid inTable: aTable. 
	self executeQuery: sql! !

!SqSDbAdapter methodsFor: 'accessing' stamp: 'tkow 10/30/2008 15:10'!
usesConnectionPool
	^ usesConnectionPool! !

!SqSDbAdapter methodsFor: 'accessing' stamp: 'tkow 10/30/2008 15:10'!
usesConnectionPool: anObject
	usesConnectionPool := anObject! !

SqSDbAdapter subclass: #SqSMySqlAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqSMySqlAdapter class methodsFor: 'instance creation' stamp: 'tkow 10/27/2008 15:27'!
newConnectionFor: anSqsConSpec
	| spec connection |
	Socket initializeNetwork.
	spec := (JdmConnectionSpec new initialize
		user: anSqsConSpec username;
		password: anSqsConSpec password;
		host: (NetNameResolver addressForName: anSqsConSpec hostname);
		database: anSqsConSpec database;
		port: anSqsConSpec port).
	connection := JdmConnection on: spec.
	^SqSMySqlConnection withConnection: connection! !

!SqSMySqlAdapter methodsFor: 'connection-control' stamp: 'tkow 10/9/2008 17:27'!
closeConnection
	self connection close! !

!SqSMySqlAdapter methodsFor: 'connection-control' stamp: 'tk 7/18/2008 15:53'!
connectionIsAlive
	^self connection socket isConnected! !

!SqSMySqlAdapter methodsFor: 'accessing' stamp: 'tk 9/2/2008 14:29'!
driverClass
	^JdmConnection! !

!SqSMySqlAdapter methodsFor: 'database operations' stamp: 'tk 7/21/2008 14:55'!
lastOidFromTable: aTable
	 | oid |
	"MySQL will only retrun the last ID. Postgres needs the table part"  
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSMySqlAdapter methodsFor: 'sql statements' stamp: 'tkow 9/19/2008 13:47'!
queryToCreateJoinTable: tableDescription
	^ (super queryToCreateJoinTable: tableDescription) , ' ENGINE=INNODB'.! !

!SqSMySqlAdapter methodsFor: 'sql statements' stamp: 'tkow 10/7/2008 16:25'!
queryToCreateTable: anSqSTable
	^ (super queryToCreateTable: anSqSTable) , ' ENGINE=INNODB'.! !

Object subclass: #SqSDescriptionHandler
	instanceVariableNames: 'currentObject classInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSDescriptionHandler commentStamp: 'tk 5/22/2008 10:47' prior: 0!
A TKSaveDescriptionHandler is an abstract base class for the description handlers of the TKSave framework.
It defines methods that subclasses have to implement in order to be able to create, update, delete and read the descriptions of TKSaveBase subclasses.
It is therefore ment to provide a clean abstraction for the problem of describing the way objects are being stored within the database.

Instance Variables
	sampleObject:		anObject that determines how the descriptors will loke like
			
sampleObject
	- xxxxx!

!SqSDescriptionHandler class methodsFor: 'cached-creation' stamp: 'test 10/6/2008 18:30'!
forClassInfo: aClassInfo
	^ (self new)
		classInfo: aClassInfo;
		yourself! !

!SqSDescriptionHandler class methodsFor: 'cached-creation' stamp: 'tkow 9/30/2008 11:33'!
forObject: aSampleObject 
	^ (self new) 
		currentObject: aSampleObject;
		classInfo: (aSampleObject classInfo);
		yourself! !

!SqSDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 11/11/2008 01:57'!
sqlTypeFunction
	^#sqsType! !

!SqSDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/15/2008 14:40'!
sqlValueStringFunction
	^#asSqlValueString! !

!SqSDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/18/2008 16:12'!
standardSqlType
	^#integer! !

!SqSDescriptionHandler methodsFor: 'object-transformation' stamp: 'tkow 12/4/2008 16:19'!
adaptObject: anObject toSpecificationOfInstVar: ivarName 
	| description |
	description := self sqSaveDescriptionForInstVar: ivarName.
	^ description 
		ifNil: [ nil ]
		ifNotNil: 
			[ description associatedClass 
				ifNil: 
					[ description describesCollection 
						ifTrue: 
							[ SqSStorage 
								createCollectionProxyFor: ivarName
								with: anObject
								in: self currentObject storedObject
								description: description ]
						ifFalse: 
							[ self 
								transformAmbigiousObject: anObject
								accordingToDescription: description ] ]
				ifNotNil: 
					[ SqSStorage 
						createProxyFor: ivarName
						with: anObject
						in: self currentObject storedObject ] ]! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 18:01'!
classInfo
	^ classInfo! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 18:01'!
classInfo: anObject
	classInfo := anObject! !

!SqSDescriptionHandler methodsFor: 'table-information' stamp: 'tkow 11/10/2008 14:57'!
classTableColumns
	| variables columnDescription columns |
	variables := self classInfo currentClass instVarNames difference: (self unpersistedInstVarsOf: self classInfo currentClass).
	columns := OrderedCollection new.
	variables do: [ :var | 
		columnDescription := self sqSaveDescriptionForInstVar: var.
		columnDescription ifNil: [
			columns add: (SqSColumn new
					columnName: var decamelized;
					tableName: self classInfo tableName;
					sqlType: self class standardSqlType;
					linkedVariable: var;
					yourself) 
		] ifNotNil: [ 
			columnDescription describesCollection ifFalse: [ 
				columns add: columnDescription 
			]
		]
	].
	^ columns! !

!SqSDescriptionHandler methodsFor: 'variable-information' stamp: 'tkow 9/3/2008 18:13'!
columnNameForInstVar: ivarName
	^ivarName decamelized! !

!SqSDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 9/12/2008 10:53'!
compileMethodCode: code intoClass: aClass
	(aClass organization categories includes: self descriptorMethodCategory)
		ifTrue: [aClass organization addCategory: self descriptorMethodCategory].
	aClass class compile: code classified: self descriptorMethodCategory! !

!SqSDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 10/10/2008 11:07'!
createDescriptions
	"overwrite me to enable automatic creation of descriptions"
	! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject
	^ currentObject! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject: anObject 
	currentObject := anObject! !

!SqSDescriptionHandler methodsFor: 'private' stamp: 'tk 5/22/2008 10:52'!
descriptorMethodCategory
	^'auto-generated-description'! !

!SqSDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/23/2008 17:14'!
directlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self persistedInstanceVariables do: [:ivn | 
		descr := self sqSaveDescriptionForInstVar: ivn.
		descr ifNotNil: [
			descr associatedClass ifNotNil: [
				ivarValue := self getIvarValue: ivn.
				ivarValue ifNotNil: [
					referencedObjects add: ivarValue
				]
			]
		]
	].
	^ referencedObjects! !

!SqSDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/30/2008 14:11'!
getIvarValue: ivn 
	| |
	^ self useInstVarAccessors 
		ifTrue: [ self currentObject storedObject perform: ivn asSymbol ]
		ifFalse: [ self currentObject storedObject instVarNamed: ivn asSymbol ] 
! !

!SqSDescriptionHandler methodsFor: 'printing' stamp: 'tk 6/19/2008 14:17'!
indent: noOfTabs
	| indent |
	indent := String cr.
	0 to: noOfTabs do: [ :i |
		indent := indent, String tab.
	].
	^indent! !

!SqSDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/9/2008 18:10'!
indexClassOfDictionary: aDictionary 
	| indexBaseType |
	indexBaseType := nil.
	aDictionary
		keysDo: [:key | 
			(key class respondsTo: self class sqlTypeFunction)
				ifFalse: [self error: 'only simple types allowed as dictionary keys (use id or something...)'].
			indexBaseType
				ifNil: [indexBaseType := key class perform: self class sqlTypeFunction]
				ifNotNil: [(key class perform: self class sqlTypeFunction)
							= indexBaseType
						ifFalse: [self error: 'mixed keys? not so good for storing this in a database']]].
	^ aDictionary keys anyOne class! !

!SqSDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 12/1/2008 16:19'!
indirectlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self persistedInstanceVariables 
		do: [:ivn | 
			descr := self sqSaveDescriptionForInstVar: ivn.
			descr ifNotNil: [
				descr describesCollection ifTrue: [
					ivarValue := self getIvarValue: ivn.
					referencedObjects add: (
						SqSCollectionInformation new
							collection: ivarValue;
							collectionDescription: descr;
							yourself
					)
				]
			]
	].
	^ referencedObjects! !

!SqSDescriptionHandler methodsFor: 'testing' stamp: 'tkow 12/4/2008 16:21'!
isComplexCollection: aCollection 
	"this check tries to find out whether a collection includes 'simple' objects. This is necessary, because collections with simple value don't point to another table but 	instead contain the values themselves. Addtionally there is a check to find out whether all values of a collection are somehow related to one-another,
	because only such values can be stored in a reasonable manner. Return value is true or false and tells us whether this collection holds complex objects or not"
	| sampleValue complexCollection isDict |
	sampleValue := nil.
	complexCollection := true.
	isDict := aCollection isDictionary.
	aCollection
		do: [:element | 
			| currentValue | 
			currentValue := isDict
						ifTrue: [element value]
						ifFalse: [element].
			currentValue
				ifNotNil: [sampleValue
						ifNil: [sampleValue := currentValue].
					complexCollection := (currentValue respondsTo: self class sqlValueStringFunction) not.
					((currentValue class includesBehavior: sampleValue class)
							or: [sampleValue class inheritsFrom: currentValue class])
						ifFalse: [self error: 'SqueakSave currently only supports collections with values that belong to the same base class (other than object...)']]].
	^ complexCollection! !

!SqSDescriptionHandler methodsFor: 'testing' stamp: 'tkow 9/23/2008 17:31'!
isComplexObject: anObject
	"determines whether an object is of a primitive type that can be stored
	directly in a database column, or if an additional table is required"
	| |
	^(anObject class respondsTo: self class sqlTypeFunction) not.! !

!SqSDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/30/2008 14:20'!
persistedInstanceVariables
	| persistedVars |
	persistedVars := Set new.
	self classInfo doForAllSuperclasses: [ :aClass |
		persistedVars addAll: aClass instVarNames.
		persistedVars := persistedVars difference: (self unpersistedInstVarsOf: aClass).
	].
	^ persistedVars! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/23/2008 17:05'!
sqSaveDescriptionForInstVar: ivarName
	^self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'testing' stamp: 'tkow 9/18/2008 17:00'!
sqlTypeForObject: anObject 
	| |
	"determines the sql type for an object - this will always return at least 
	INTEGER since every object should be storeable somehow"
	^(anObject class respondsTo: self class sqlTypeFunction) ifTrue: [
		anObject class perform: (self class sqlTypeFunction)		
	] ifFalse: [
		self class standardSqlType
	]
			
! !

!SqSDescriptionHandler methodsFor: 'object-transformation' stamp: 'tkow 9/24/2008 16:35'!
transformAmbigiousObject: anObject	accordingToDescription: description
	"this method tries to regenerate large positive integers, 
	 Since they can't be stored directly to (my)sql tables, text is used.
	 unfoetunately this also would mean that we set a byteArray where 
	 a LargePositiveInteger is expected"
	| desiredClass |
	desiredClass := Smalltalk at: description objectClass.
	^((desiredClass includesBehavior: LargePositiveInteger) and: [(anObject class includesBehavior: LargePositiveInteger) not]) ifTrue: [
		^anObject asString asInteger
	] ifFalse: [
		((desiredClass includesBehavior: Boolean) and: [(anObject class includesBehavior: Boolean) not]) ifTrue: [
			(anObject = 0) ifTrue: [false] ifFalse: [true]
		] ifFalse: [
			anObject
		]
	]	! !

!SqSDescriptionHandler methodsFor: 'variable-information' stamp: 'tkow 9/30/2008 14:25'!
unpersistedInstVars
	| unpersistedVars |
	"gather the unpersisted instance variables of all classes within the inheritance chain"
	unpersistedVars := Set new.
	self classInfo doForAllSuperclasses: [ :currentClass |
		unpersistedVars addAll: (self unpersistedInstVarsOf: currentClass).
	].
	^unpersistedVars
	! !

!SqSDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/3/2008 18:23'!
unpersistedInstVarsOf: klass
	self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'configuration' stamp: 'tkow 11/7/2008 16:27'!
useAdvancedCollections
	^ self classInfo configuration collectionConfiguration orderedCollections! !

!SqSDescriptionHandler methodsFor: 'configuration' stamp: 'tkow 11/7/2008 16:22'!
useInstVarAccessors
	^ self classInfo configuration useInstVarAccessors! !

SqSDescriptionHandler subclass: #SqSStandardDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSStandardDescriptionHandler commentStamp: 'tk 6/19/2008 15:22' prior: 0!
A TKSaveMagritteDescriptionHandler is  .

Instance Variables
!

!SqSStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 15:54'!
inheritanceModeFunction
	^#tableInheritance! !

!SqSStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 16:12'!
tableNameFunction
	^#sqSaveTableName! !

!SqSStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 16:13'!
unpersistedInstVarsFunction
	^#sqSaveUnpersistedInstVars! !

!SqSStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 16:14'!
useInstVarAccessorsFunction
	^#useInstVarAccessors! !

!SqSStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 10/9/2008 10:27'!
collectionDescriptionFor: ivn inClass: aClass basedOn: aCollection 
	"only create descriptors for non-empty collections"
	^ aCollection isEmpty 
		ifTrue: [ nil ]
		ifFalse: 
			[ self 
				persistenceDescriptionForCollection: aCollection
				withLabel: ivn
				complexValues: (self isComplexCollection: aCollection) ]! !

!SqSStandardDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 10/13/2008 18:44'!
columnDescriptionForObject: anObject ofInstVar: instVarName linkedTo: aClass 
	| column sqlType |
	column := SqSColumn new.
	sqlType := self sqlTypeForObject: anObject.
	column
		columnName: instVarName decamelized;
		objectClass: anObject class name asSymbol;
		linkedVariable: instVarName;
		sqlType: sqlType.
	aClass ifNotNil: [ 
		column associatedClass: aClass.
		column columnName: (instVarName decamelized , '_id')
	].
	^ column! !

!SqSStandardDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 10/10/2008 11:07'!
createDescriptions
	| anObject targetClass |
	self persistedInstanceVariables do: 
		[ :ivn | 
		anObject := self getIvarValue: ivn.
		targetClass := self targetClassForDescriptorOfInstVar: ivn.
		anObject ifNotNil: 
			[ (targetClass respondsTo: ivn asSqSaveDescriptionSelector) 
				ifTrue: 
					[ self 
						updatePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ]
				ifFalse: 
					[ self 
						writePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ] ] ]! !

!SqSStandardDescriptionHandler methodsFor: 'private' stamp: 'tk 8/31/2008 15:17'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 11/11/2008 13:39'!
ownerColumnForCurrentObject
	^ SqSColumn new
		sqlType: (Integer perform: self class sqlTypeFunction);
		columnName: self classInfo baseClass name decamelized , '_id';
		foreignKey: (SqSForeignKeyDescription new
				referencedColumns: (OrderedCollection with: self classInfo configuration tableConfiguration idField);
				referencedTable: self classInfo tableName;
				deleteActions: #(#CASCADE ));
		linkedVariable: #SQSOWNER;
		canBeNull: false! !

!SqSStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 11/21/2008 21:54'!
persistenceDescriptionForCollection: aCollection withLabel: ivn complexValues: aBool 
	| ownerColumn collectionSample referenceColumn referenceTableName indexType |
	ownerColumn := self ownerColumnForCurrentObject.
	
	collectionSample := nil.
	aCollection do: [ :element | collectionSample ifNil: [ collectionSample := element ] ].
	collectionSample := SqSStorage for: collectionSample.
	
	referenceColumn := self 
		referenceColumnDescriptionNamed: ivn
		for: collectionSample
		simpleValues: aBool not.
		
	referenceTableName := aBool 
		ifTrue: [ self tableNameForClass: collectionSample baseClass ]
		ifFalse: [ nil ].
	
	indexType := (aCollection isDictionary 
		ifTrue: [ self indexClassOfDictionary: aCollection ]
		ifFalse: [ Integer ]) perform: (self class sqlTypeFunction).
	
	^ SqSCollectionDescription new
		referenceTableName: referenceTableName;
		referenceColumn: referenceColumn;
		collectionClass: aCollection sqSaveClass;
		indexType: indexType;
		referencedClass: collectionSample baseClass name;
		simpleValues: aBool not;
		configuration: self classInfo configuration collectionConfiguration;
		ownerColumn: ownerColumn;
		linkedVariable: ivn;
		joinTableName: self currentObject baseClass name asSqSaveTableName , '_' , ivn decamelized! !

!SqSStandardDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 10/10/2008 13:42'!
persistenceDescriptionForObject: anObject withLabel: aLabel storedInTableNamed: tableName 
	| linkedClass |
	linkedClass := (self isComplexObject: anObject) 
		ifTrue: [ anObject class name asSymbol ]
		ifFalse: [ nil ].
	^ self 
		columnDescriptionForObject: anObject
		ofInstVar: aLabel
		linkedTo: linkedClass! !

!SqSStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 10/9/2008 10:29'!
persistenceDescriptorFor: ivn inClass: aClass basedOn: anObject 
	"ensure that for all collections (except for strings) we create different descriptors"
	^ (anObject isCollection and: [ anObject isString not ]) 
		ifTrue: 
			[ self 
				collectionDescriptionFor: ivn
				inClass: aClass
				basedOn: anObject ]
		ifFalse: 
			[ self 
				persistenceDescriptionForObject: anObject
				withLabel: ivn
				storedInTableNamed: (self tableNameForClass: aClass) ]! !

!SqSStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 11/11/2008 13:39'!
referenceColumnDescriptionNamed: ivn for: collectionSample simpleValues: aBool 
	| referenceColumn sqlType |
	sqlType := self sqlTypeForObject: collectionSample storedObject.
	referenceColumn := SqSColumn new
		sqlType: sqlType;
		columnName: self classInfo configuration collectionConfiguration valueField;
		canBeNull: false;
		linkedVariable: #SQSREF.
	"create the foreign key relationship only if complex collections should be
	used or if our collection elements are no simple values but complex ones"
	(self useAdvancedCollections or: [ aBool ]) ifFalse: [ 
		referenceColumn foreignKey: (SqSForeignKeyDescription new
			referencedColumns: (OrderedCollection with: collectionSample configuration tableConfiguration idField);
			referencedTable: (self tableNameForClass: collectionSample baseClass);
			deleteActions: #(#CASCADE )) 
	].
	^ referenceColumn! !

!SqSStandardDescriptionHandler methodsFor: 'accessing' stamp: 'test 11/11/2008 01:54'!
sqSaveDescriptionForInstVar: ivarName
	^(self targetClass respondsTo: ivarName asSqSaveDescriptionSelector) ifTrue: [ 
		self targetClass perform: ivarName asSqSaveDescriptionSelector 
	] ifFalse: [
		nil	
	]! !

!SqSStandardDescriptionHandler methodsFor: 'table-information' stamp: 'tkow 11/10/2008 10:46'!
tableNameForClass: aClass
	^ (SqSClassInfo for: aClass) tableName! !

!SqSStandardDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 13:06'!
targetClass
	^self subclassResponsibility
	! !

!SqSStandardDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/10/2008 13:40'!
targetClassForDescriptorOfInstVar: ivn
	| targetClass baseClass |
	targetClass := self classInfo currentClass.
	baseClass := self currentObject baseClass.
	[ targetClass ~= baseClass superclass ] whileTrue: 
		[ (targetClass instVarNames includes: ivn) ifTrue: [ ^ targetClass ].
		targetClass := targetClass superclass ].
	self error: 'instance variable named ' , ivn , ' could not be found in the class hierarchy of ' , self currentObject class name

! !

!SqSStandardDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/10/2008 16:13'!
unpersistedInstVarsOf: aClass
	^(aClass respondsTo: self class unpersistedInstVarsFunction) ifTrue: [
		(aClass perform: self class unpersistedInstVarsFunction)
	] ifFalse: [
		#()
	].! !

!SqSStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 9/30/2008 15:36'!
updatePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| previousClass oldDescription |
	oldDescription := aClass perform: ivn asSqSaveDescriptionSelector.
	"for the brave ones, we leave everything as is"
	oldDescription manuallyMaintained ifFalse: [
		oldDescription describesCollection ifFalse: [
			previousClass := Smalltalk at: oldDescription objectClass asSymbol.
			"if we have a subclass of our previous class, we're fine - otherwhise, we have to alter the table and the description"
			((anObject class inheritsFrom: previousClass) or: [anObject sqSaveClass = previousClass]) ifFalse: [
				self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
				"TODO: this is the place where we should ask the user if the change is ok???"
			]
		] ifTrue: [
			self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
		]
	].	
	! !

!SqSStandardDescriptionHandler methodsFor: 'configuration' stamp: 'tkow 9/12/2008 18:37'!
useInstVarAccessors
	^(self targetClass respondsTo: (self class useInstVarAccessorsFunction)) ifTrue: [
		self targetClass perform: (self class useInstVarAccessorsFunction)
	] ifFalse: [
		false
	]! !

!SqSStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 10/9/2008 10:29'!
writePersistenceDescriptorFor: ivn basedOn: anObject inClass: targetClass 
	| description code |
	description := self 
		persistenceDescriptorFor: ivn
		inClass: targetClass
		basedOn: anObject.
	description ifNotNil: 
		[ code := ivn asSqSaveDescriptionSelector , String cr.
		code := code , '^' , description creationCode.
		self 
			compileMethodCode: code
			intoClass: targetClass ]! !

SqSStandardDescriptionHandler subclass: #SqSStandardExternDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSStandardExternDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/10/2008 14:15'!
createExternalDescriptorClassNamed: targetName
	"this function creates all required descriptor classes up to the base class"
	| classes targetCategory currentSuperclass |
	
	classes := OrderedCollection new.
	self classInfo doForAllSuperclasses: [:aClass |
		classes add: aClass.	
	].
	targetCategory := self classInfo currentClass category asString.
	currentSuperclass := Object.
	classes reverseDo: [:aClass |
		| descrClassName |
		descrClassName := aClass name asSqSaveDescriptorClassName.
		currentSuperclass := Smalltalk at: (descrClassName) ifAbsent: [
			currentSuperclass subclass: descrClassName
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: targetCategory
		]
	].
	^Smalltalk at: targetName! !

!SqSStandardExternDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 14:02'!
targetClass
	| targetName |
	targetName := self classInfo currentClass name asSqSaveDescriptorClassName.
	^self createExternalDescriptorClassNamed: targetName.
	! !

!SqSStandardExternDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/10/2008 14:03'!
targetClassForDescriptorOfInstVar: ivn
	| targetName |
	targetName := (super targetClassForDescriptorOfInstVar: ivn) name asSqSaveDescriptorClassName.
	^self createExternalDescriptorClassNamed: targetName.! !

SqSStandardDescriptionHandler subclass: #SqSStandardInternDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSStandardInternDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 13:07'!
targetClass
	^self classInfo currentClass! !

Object subclass: #SqSLoadStrategy
	instanceVariableNames: 'eagerLoaded loadDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

!SqSLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
depth: anInteger
	^self new
		loadDepth: anInteger! !

!SqSLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
eager
	^self new
		loadDepth: 1! !

!SqSLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
eagerVariables: aDictionary
	^self new
		eagerLoaded: aDictionary! !

!SqSLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
eagerLoaded
	^ eagerLoaded! !

!SqSLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
eagerLoaded: anObject
	eagerLoaded := anObject! !

!SqSLoadStrategy methodsFor: 'initialization' stamp: 'tkow 11/5/2008 17:01'!
initialize
	eagerLoaded := Dictionary new.
! !

!SqSLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
loadDepth
	^ loadDepth! !

!SqSLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
loadDepth: anObject
	loadDepth := anObject! !

Object subclass: #SqSMigration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

Object subclass: #SqSObjectCache
	instanceVariableNames: 'objectCache objectIdCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSObjectCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/4/2008 17:06'!
cacheObject: anObject withOid: oid
	(self objectCacheFor: anObject class) at: oid put: anObject.
	(self objectIdCacheFor: anObject class) at: anObject put: oid.
	! !

!SqSObjectCache methodsFor: 'object-caching' stamp: 'tkow 12/4/2008 17:02'!
cachedObjectOfClass: aClass withOid: oid 
	| object |
	object := (self objectCacheFor: aClass)
		at: oid
		ifAbsent: [nil].
	"this re-caching becomes necessary sometimes, to keep both caches in sync 
	even when only one of the caches has been cleared"
	object ifNotNil: [
		(self objectIdCacheFor: object class) at: object ifAbsentPut: [oid]
	].
	^ object! !

!SqSObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:07'!
clear
	objectCache := Dictionary new.
	objectIdCache := Dictionary new.! !

!SqSObjectCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/4/2008 17:05'!
initialize
	super initialize.
	objectCache := Dictionary new.
	objectIdCache := Dictionary new.! !

!SqSObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:04'!
objectCacheFor: aClass
	^ objectCache 
		at: aClass name 
		ifAbsentPut: [WeakValueDictionary new]! !

!SqSObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:04'!
objectIdCacheFor: aClass
	^ objectIdCache
		at: aClass name 
		ifAbsentPut: [WeakIdentityKeyDictionary new]! !

!SqSObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:26'!
oidFor: anObject
	| classCache |
	classCache := objectIdCache at: anObject class name ifAbsent: [^nil].
	^ classCache at: anObject ifAbsent: [nil]! !

Object subclass: #SqSPersistenceDescription
	instanceVariableNames: 'associatedClass manuallyMaintained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

SqSPersistenceDescription subclass: #SqSCollectionDescription
	instanceVariableNames: 'collectionClass joinTableName ownerColumn referenceColumn referenceTableName configuration simpleValues indexType referencedClass linkedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass
	^ collectionClass! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass: anObject
	collectionClass := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/10/2008 10:20'!
configuration
	^ configuration! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/10/2008 10:20'!
configuration: anObject
	configuration := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 7/23/2008 15:13'!
describesCollection
	^true! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/18/2008 16:10'!
indexType
	^ indexType! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/18/2008 16:10'!
indexType: anObject
	indexType := anObject! !

!SqSCollectionDescription methodsFor: 'initialization' stamp: 'tkow 11/10/2008 10:21'!
initialize
	super initialize.
	self simpleValues: false.! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
joinTableName
	^ joinTableName! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
joinTableName: anObject
	joinTableName := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/21/2008 21:54'!
linkedVariable
	^ linkedVariable! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/21/2008 21:54'!
linkedVariable: anObject
	linkedVariable := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/10/2008 11:14'!
maintainOrder
	^self configuration orderedCollections! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder: anObject 
	maintainOrder := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn
	^ ownerColumn! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn: anObject
	ownerColumn := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn
	^ referenceColumn! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn: anObject
	referenceColumn := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName
	^ referenceTableName! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName: anObject
	referenceTableName := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/24/2008 15:48'!
referencedClass
	^ referencedClass! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/24/2008 15:48'!
referencedClass: anObject
	referencedClass := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/15/2008 14:05'!
simpleValues
	^ simpleValues! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/15/2008 14:05'!
simpleValues: anObject
	simpleValues := anObject! !

SqSPersistenceDescription subclass: #SqSColumn
	instanceVariableNames: 'columnName sqlType objectClass tableName foreignKey canBeNull isPrimaryKey autoIncrement linkedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSColumn methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:12'!
= anotherColumn
	^ (self columnName = anotherColumn columnName) and: [self tableName = anotherColumn tableName]! !

!SqSColumn methodsFor: 'accessing' stamp: 'tkow 10/7/2008 14:41'!
autoIncrement
	^ autoIncrement! !

!SqSColumn methodsFor: 'accessing' stamp: 'tkow 10/7/2008 14:41'!
autoIncrement: anObject
	autoIncrement := anObject! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull
	^ canBeNull! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull: anObject
	canBeNull := anObject! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName
	^ columnName! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName: anObject
	columnName := anObject! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:58'!
foreignKey
	^ foreignKey! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:16'!
foreignKey: anObject
	foreignKey := anObject.
	"being a foreign key, the column can not be null"
	self canBeNull: false.! !

!SqSColumn methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:07'!
hash
	^(self columnName hash + self sqlType hash + self tableName hash)! !

!SqSColumn methodsFor: 'initialization' stamp: 'tkow 11/3/2008 18:43'!
initialize
	super initialize.
	self canBeNull: true.
	self isPrimaryKey: false.
	self autoIncrement: false.! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey
	^ isPrimaryKey! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey: anObject
	isPrimaryKey := anObject! !

!SqSColumn methodsFor: 'accessing' stamp: 'tkow 10/9/2008 10:33'!
linkedVariable
	^ linkedVariable! !

!SqSColumn methodsFor: 'accessing' stamp: 'tkow 10/9/2008 10:33'!
linkedVariable: anObject
	linkedVariable := anObject! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass
	^ objectClass! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass: anObject
	objectClass := anObject! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType
	^ sqlType! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType: anObject
	sqlType := anObject! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName
	^ tableName! !

!SqSColumn methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName: anObject
	tableName := anObject! !

SqSPersistenceDescription subclass: #SqSForeignKeyDescription
	instanceVariableNames: 'referencedColumns referencedTable updateActions deleteActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions
	^ deleteActions! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions: anObject
	deleteActions := anObject! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:31'!
initialize
	super initialize.
	self updateActions: #().
	self deleteActions: #().! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns
	^ referencedColumns! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns: anObject
	referencedColumns := anObject! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable
	^ referencedTable! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable: anObject
	referencedTable := anObject! !

!SqSForeignKeyDescription methodsFor: 'printing' stamp: 'tk 7/22/2008 13:54'!
storeOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;;
				nextPutAll: (String cr, String tab, String tab)
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions
	^ updateActions! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions: anObject
	updateActions := anObject! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass
	^ associatedClass! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass: anObject
	associatedClass := anObject! !

!SqSPersistenceDescription methodsFor: 'printing' stamp: 'tkow 11/7/2008 16:57'!
creationCode
	| |
	^ self  sqsCodeForObjectCreation
	! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 7/23/2008 15:12'!
describesCollection
	^false! !

!SqSPersistenceDescription methodsFor: 'initialization' stamp: 'tk 8/15/2008 16:37'!
initialize
	super initialize.
	self manuallyMaintained: false.! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained
	^ manuallyMaintained! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained: anObject
	manuallyMaintained := anObject! !

!SqSPersistenceDescription methodsFor: 'printing' stamp: 'tk 8/5/2008 18:58'!
storeOn: aStream
	aStream nextPutAll: self creationCode! !

SqSPersistenceDescription subclass: #SqSTable
	instanceVariableNames: 'tableName parent children columns structure oidColumn typeColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSTable class methodsFor: 'as yet unclassified' stamp: 'tkow 11/10/2008 14:32'!
objectIdLink
	^ #SQSOID! !

!SqSTable class methodsFor: 'as yet unclassified' stamp: 'tkow 11/10/2008 14:32'!
typeLink
	^ #SQSTYPE! !

!SqSTable methodsFor: 'special columns' stamp: 'tkow 11/10/2008 15:13'!
addLightOidColumnNamed: aString linkedTo: refTableName
	| aColumn |
	aColumn := SqSColumn new
		columnName: aString;
		sqlType: #unsignedInteger;
		canBeNull: false;
		isPrimaryKey: true;
		linkedVariable: self class objectIdLink;
		foreignKey: (SqSForeignKeyDescription new
				referencedColumns: (OrderedCollection with: aString);
				deleteActions: #(#CASCADE );
				referencedTable: refTableName).
	self columns add: aColumn.
	self oidColumn: aColumn.
	! !

!SqSTable methodsFor: 'special columns' stamp: 'tkow 11/10/2008 14:50'!
addOidColumnNamed: aString
	| newColumn |
	newColumn := SqSColumn new
		columnName: aString;
		sqlType: #unsignedInteger;
		canBeNull: false;
		isPrimaryKey: true;
		autoIncrement: true;
		tableName: self tableName;
		linkedVariable: self class objectIdLink.
	self columns add: newColumn.
	self oidColumn: newColumn.! !

!SqSTable methodsFor: 'special columns' stamp: 'tkow 11/10/2008 14:50'!
addTypeColumnNamed: aString
	| aColumn |
	aColumn := SqSColumn new
		columnName: aString;
		sqlType: #string;
		canBeNull: false;
		isPrimaryKey: false;
		objectClass: #Symbol;
		tableName: self tableName;
		linkedVariable: self class typeLink.
	self columns add: aColumn.
	self typeColumn: aColumn! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 13:45'!
allChildTables
	| allChildren |
	allChildren := OrderedCollection withAll: self children.
	self children do: [:childTable |
		allChildren addAll: childTable allChildTables
	].
	^allChildren! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 12/4/2008 17:45'!
allColumns
	| allColumns |
	allColumns := self columns.
	self children do: [:childTable |
		allColumns addAll: childTable allColumns
	].
	^ allColumns! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/9/2008 16:22'!
baseTable
	^self parent ifNil: [
		self
	] ifNotNil: [
		self parent baseTable
	]! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
children
	^ children! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
children: anObject
	children := anObject! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
columns
	^ columns! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
columns: anObject
	columns := anObject! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 18:39'!
initialize
	super initialize.
	self children: Set new.
	self columns: OrderedCollection new.! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
oidColumn
	^ oidColumn! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
oidColumn: anObject
	oidColumn := anObject! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
parent
	^ parent! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:48'!
parent: anObject
	parent := anObject.
	parent children add: self.
	! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
structure
	^ structure! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
structure: anObject
	structure := anObject! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
tableName
	^ tableName! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
tableName: anObject
	tableName := anObject! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
typeColumn
	^ typeColumn! !

!SqSTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
typeColumn: anObject
	typeColumn := anObject! !

Object subclass: #SqSQuery
	instanceVariableNames: 'queryClass whereBuffer valueTables queryTables queryLevel previousQueryObject currentQueryObject loadStrategy orderBy ignoreTypeField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSQuery class methodsFor: 'as yet unclassified' stamp: 'tkow 10/13/2008 18:09'!
classForType: aType
	| curClass newClass |
	curClass := aType.
	[curClass ~= Object] whileTrue: [
		newClass := self classesForTypes at: curClass ifAbsent: [nil].
		newClass ifNil: [
			curClass := curClass superclass.	
		] ifNotNil: [
			^newClass
		]
	].
	^SqSQueryObject.! !

!SqSQuery class methodsFor: 'as yet unclassified' stamp: 'tkow 10/13/2008 18:06'!
classesForTypes
	^ Dictionary new
		at: Object
			put: SqSQueryObject;
		at: Boolean
			put: SqSQueryBoolean;
		at: Date
			put: SqSQueryDate;
		at: DateAndTime
			put: SqSQueryDateTime;
		at: Number
			put: SqSQueryNumber;
		at: String
			put: SqSQueryString;
		yourself! !

!SqSQuery class methodsFor: 'initialize-release' stamp: 'tkow 10/14/2008 11:05'!
on: aClass
	^(self new
		on: aClass;
		yourself)! !

!SqSQuery class methodsFor: 'initialize-release' stamp: 'tkow 11/5/2008 17:04'!
on: aClass withStrategy: anSqsLoadStrategy
	^(self new
		on: aClass;
		loadStrategy: anSqsLoadStrategy;
		yourself)! !

!SqSQuery methodsFor: 'initialize-release' stamp: 'tkow 11/3/2008 16:13'!
aliasSuffixForTableName: tableName ofClass: aClass 
	| timesTaken |
	timesTaken := self queryLevel 
		at: aClass name
		ifAbsent: [ 0 ].
	^ timesTaken = 0 
		ifTrue: [ '' ]
		ifFalse: [ '_' , timesTaken asString ]! !

!SqSQuery methodsFor: 'enumerating' stamp: 'tkow 11/5/2008 17:46'!
analyze: aBlock
	| qo result |
	qo := (self class classForType: Object) new 
		query: self;
		depictedClass: self queryClass.
	result := aBlock value: qo.
	self whereBuffer: result whereBuffer.
	self findValueTables.
! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 11:00'!
currentQueryObject
	^ currentQueryObject! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 11:00'!
currentQueryObject: anObject
	currentQueryObject := anObject! !

!SqSQuery methodsFor: 'initialize-release' stamp: 'tkow 11/27/2008 12:47'!
findValueTables
	| baseTable queryBaseTable childQueryTable classInfo idField childLink |
	classInfo := SqSClassInfo for: self queryClass.
	baseTable :=  classInfo classTable baseTable.
	queryBaseTable := SqSQueryTable table: baseTable alias: '' field: nil class: self queryClass.
	
	"we need the base table in the values (i.e. the SELECT ...) as well as in the query part (FROM ...)"
	"for eager loading, those tables would be added to the values as seperate tables and to the queries
	by linking them to the queryBaseTable via an SqSTableLink"
	self valueTables add: queryBaseTable.
	idField := classInfo configuration tableConfiguration idField.
	
	"the links to the child tables are merly a shortcut that simplifies the adapter handling of this stuff
	This way we can simply take all links a table has, and throw it into one giant join statement"
	baseTable allChildTables do: [:childTable | 
		childQueryTable := SqSQueryTable table: childTable alias: '' field: nil.
		childLink := SqSTableLink table: childQueryTable fromField: idField toField: idField direction: 'LEFT OUTER'.
		queryBaseTable tableLinks add: childLink.
	].
	self queryTables add: queryBaseTable.
	! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 12/5/2008 13:35'!
ignoreTypeField
	^ ignoreTypeField! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 12/5/2008 13:35'!
ignoreTypeField: anObject
	ignoreTypeField := anObject! !

!SqSQuery methodsFor: 'initialization' stamp: 'tkow 12/5/2008 13:35'!
initialize
	super initialize.
	self whereBuffer: ''.
	self valueTables: OrderedCollection new.
	self queryTables: OrderedCollection new.
	self queryLevel: Dictionary new.
	self ignoreTypeField: false.! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:04'!
loadStrategy
	^ loadStrategy! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:04'!
loadStrategy: anObject
	loadStrategy := anObject! !

!SqSQuery methodsFor: 'initialize-release' stamp: 'tkow 11/3/2008 16:14'!
newAliasSuffixForTableName: tableName ofClass: aClass 
	| timesTaken aliasedName |
	aliasedName := self 
		aliasSuffixForTableName: tableName
		ofClass: aClass.
	timesTaken := self queryLevel 
		at: aClass name
		ifAbsentPut: [ 0 ].
	timesTaken := timesTaken + 1.
	self queryLevel 
		at: aClass name
		put: timesTaken.
	^ aliasedName! !

!SqSQuery methodsFor: 'as yet unclassified' stamp: 'tkow 11/2/2008 21:59'!
newForType: aType
	self previousQueryObject: self currentQueryObject.
	^(self class classForType: aType) new 
		query: self;
		depictedClass: aType.! !

!SqSQuery methodsFor: 'initialize-release' stamp: 'tkow 11/5/2008 17:46'!
on: aClass 
	| |
	self queryClass: aClass.
! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 11/24/2008 11:15'!
orderBy
	^ orderBy! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 11/24/2008 11:15'!
orderBy: anObject
	orderBy := anObject! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:09'!
previousQueryObject
	^ previousQueryObject! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:09'!
previousQueryObject: anObject
	previousQueryObject := anObject! !

!SqSQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:36'!
queryClass
	^queryClass! !

!SqSQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:34'!
queryClass: aClass
	queryClass _ aClass.! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 11/3/2008 10:09'!
queryLevel
	^ queryLevel! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 11/3/2008 10:09'!
queryLevel: anObject
	queryLevel := anObject! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:06'!
queryTables
	^ queryTables! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:06'!
queryTables: anObject
	queryTables := anObject! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 10/20/2008 16:01'!
valueTables
	^ valueTables! !

!SqSQuery methodsFor: 'accessing' stamp: 'tkow 10/20/2008 16:01'!
valueTables: anObject
	valueTables := anObject! !

!SqSQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:41'!
whereBuffer
	^whereBuffer.! !

!SqSQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:42'!
whereBuffer: aString
	whereBuffer _ aString.! !

Object subclass: #SqSQueryTable
	instanceVariableNames: 'aliasSuffix field originalTable queryClass tableLinks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/3/2008 16:12'!
table: anSqsTable alias: anAliasName field: aFieldName 
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		yourself! !

!SqSQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/5/2008 16:03'!
table: anSqsTable alias: anAliasName field: aFieldName class: aClass
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		queryClass: aClass;
		yourself! !

!SqSQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/24/2008 14:44'!
table: anSqsTable alias: anAliasName field: aFieldName class: aClass ignoreValues: aBool
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		queryClass: aClass;
		ignoreValues: aBool;
		yourself! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:12'!
aliasSuffix
	^ aliasSuffix! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:12'!
aliasSuffix: anObject 
	aliasSuffix := anObject! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:25'!
aliasedName
	^self originalTable tableName, self aliasSuffix! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/4/2008 13:59'!
allAliasedNames
	| aliasedNames |
	aliasedNames := OrderedCollection new.
	aliasedNames add: self aliasedName.
	self originalTable allChildTables do: [:table |
		aliasedNames add: (table tableName, self aliasSuffix)
	].
	^aliasedNames! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'wh 8/15/2006 11:45'!
field
	^field.! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 10/13/2008 16:44'!
field: anObject
	field := anObject! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:35'!
ignoreValues
	^ ignoreValues! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:35'!
ignoreValues: anObject
	ignoreValues := anObject! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 16:11'!
initialize
	super initialize.
	self tableLinks: OrderedCollection new.! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:35'!
originalTable
	^ originalTable! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:35'!
originalTable: anObject
	originalTable := anObject! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/5/2008 16:03'!
queryClass
	^ queryClass! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/5/2008 16:03'!
queryClass: anObject
	queryClass := anObject! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 15:53'!
tableLinks
	^ tableLinks! !

!SqSQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 15:53'!
tableLinks: anObject 
	tableLinks := anObject! !

Object subclass: #SqSQueryValue
	instanceVariableNames: 'query whereBuffer depictedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

SqSQueryValue subclass: #SqSQueryBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSQueryBoolean methodsFor: 'logical operations' stamp: 'tkow 10/30/2008 16:25'!
& anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: 'AND'! !

!SqSQueryBoolean methodsFor: 'testing' stamp: 'tkow 10/30/2008 16:25'!
isFalse
	^ self 
		booleanCompair: 0
		with: '='! !

!SqSQueryBoolean methodsFor: 'testing' stamp: 'tkow 10/30/2008 16:25'!
isTrue
	^ self 
		booleanCompair: 1
		with: '='! !

!SqSQueryBoolean methodsFor: 'logical operations' stamp: 'tkow 10/30/2008 16:25'!
| anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: 'OR'! !

SqSQueryValue subclass: #SqSQueryDate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSQueryDate methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:12'!
day
	^self dayOfYear.! !

!SqSQueryDate methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:12'!
dayOfMonth
^(self newForType: Integer)  whereBuffer: 
			'DAY(',self encapsulatedWhere,')'.! !

!SqSQueryDate methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:11'!
dayOfWeek
^(self newForType: Integer)  whereBuffer: 
			'DAYOFWEEK(',self encapsulatedWhere,')'.! !

!SqSQueryDate methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:11'!
dayOfYear
^(self newForType: Integer)  whereBuffer: 
			'DAYOFYEAR(',self encapsulatedWhere,')'.! !

!SqSQueryDate methodsFor: 'smalltalk-80' stamp: 'wh 8/16/2006 20:11'!
monthIndex
^(self newForType: Integer)  whereBuffer: 
			'MONTH(',self encapsulatedWhere,')'.! !

!SqSQueryDate methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:10'!
monthName
^(self newForType: Integer)  whereBuffer: 
			'MONTHNAME(',self encapsulatedWhere,')'.! !

!SqSQueryDate methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:10'!
year
^(self newForType: Integer)  whereBuffer: 
			'YEAR(',self encapsulatedWhere,')'.! !

SqSQueryDate subclass: #SqSQueryDateTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSQueryDateTime methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:12'!
hour
^(self newForType: Integer)  whereBuffer: 
			'HOUR(',self encapsulatedWhere,')'.! !

!SqSQueryDateTime methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:12'!
hour24
	^self hour.! !

!SqSQueryDateTime methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:13'!
minute
^(self newForType: Integer)  whereBuffer: 
			'MINUTE(',self encapsulatedWhere,')'.! !

!SqSQueryDateTime methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:13'!
second
^(self newForType: Integer)  whereBuffer: 
			'SECOND(',self encapsulatedWhere,')'.! !

SqSQueryValue subclass: #SqSQueryNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:36'!
* aNumber
	^self mathWith: aNumber doOperator: '*'.! !

!SqSQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:35'!
+ aNumber
	^self mathWith: aNumber doOperator: '+'.! !

!SqSQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:35'!
- aNumber
	^self mathWith: aNumber doOperator: '-'.! !

!SqSQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:36'!
/ aNumber
	^self mathWith: aNumber doOperator: '/'.! !

!SqSQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:08'!
\\ anAttrib
	^self mathWith: anAttrib doOperator: '%'.! !

!SqSQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:05'!
abs
^(self newForType: Integer) whereBuffer: 
			'ABS(',self encapsulatedWhere,')'.! !

!SqSQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:05'!
arcCos
^(self newForType: Integer) whereBuffer: 
			'ACOS(',self encapsulatedWhere,')'.! !

!SqSQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:05'!
arcSin
^(self newForType: Integer)  whereBuffer: 
			'ASIN(',self encapsulatedWhere,')'.! !

!SqSQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:06'!
arcTan
^(self newForType: Integer)  whereBuffer: 
			'ATAN(',self encapsulatedWhere,')'.! !

!SqSQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:06'!
cos
^(self newForType: Integer)  whereBuffer: 
			'COS(',self encapsulatedWhere,')'.! !

!SqSQueryNumber methodsFor: 'as yet unclassified' stamp: 'wh 8/16/2006 20:29'!
mathWith: anAttrib doOperator: anOperator
	^self operator: anOperator returnType: Integer attribute: anAttrib! !

!SqSQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:06'!
sin
^(self newForType: Integer)  whereBuffer: 
			'SIN(',self encapsulatedWhere,')'.! !

!SqSQueryNumber methodsFor: 'mathematical functions' stamp: 'wh 8/16/2006 20:07'!
tan
^(self newForType: Integer ) new whereBuffer: 
			'TAN(',self encapsulatedWhere,')'.! !

SqSQueryValue subclass: #SqSQueryObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSQueryObject methodsFor: 'error handling' stamp: 'tkow 11/2/2008 21:58'!
doesNotUnderstand: aMessage 
	| col classTable |
	aMessage arguments size < 1 ifTrue: [ 
		classTable := (SqSClassInfo for: self depictedClass) classTable baseTable.
		col := self sqsFindColumnForMessage: aMessage.
		col ifNotNil: [^ self sqsNextQueryObject: col]
	].
	super doesNotUnderstand: aMessage! !

!SqSQueryObject methodsFor: 'as yet unclassified' stamp: 'tkow 11/27/2008 12:57'!
oid
	| tableName aliasSuffix aliasedTableName classInfo |
	"object id has to be overridden, because the objectID for the queryProxies surely
	won't be found anywhere in our caches'"
	classInfo := (SqSClassInfo for: self depictedClass) .
	tableName := classInfo classTable baseTable tableName.
	aliasSuffix := self query 
		aliasSuffixForTableName: tableName
		ofClass: self depictedClass.
	aliasedTableName := tableName, aliasSuffix.
	self whereBuffer: self whereBuffer , aliasedTableName , '.' , (classInfo configuration tableConfiguration idField)! !

!SqSQueryObject methodsFor: 'error handling' stamp: 'tkow 10/21/2008 18:44'!
sqsFindColumnFor: instVarName inTable: table
	| column |
	column := table columns detect: [:col |
		col linkedVariable = instVarName asString
	] ifNone: [nil].
	column ifNil: [
		table children do: [:childTable |
			column ifNil: [
				column := self sqsFindColumnFor: instVarName inTable: childTable. 	
			]	
		]	
	].
	^column
	
	! !

!SqSQueryObject methodsFor: 'error handling' stamp: 'tkow 11/3/2008 17:25'!
sqsFindColumnForMessage: aMessage
	| table column |
	table := (SqSClassInfo for: self depictedClass) classTable baseTable.
	column := self sqsFindColumnFor: aMessage selector inTable: table.
	^column
	
	
	! !

!SqSQueryObject methodsFor: 'error handling' stamp: 'tkow 11/25/2008 14:19'!
sqsJoin: tableName withSuffix: aSuffix onColumn: column 
	| curTableName oidField |
	curTableName := tableName, aSuffix.
	oidField := (SqSClassInfo for: self depictedClass) configuration tableConfiguration idField.
	"if we eprform operations on objects that return objects themselves, we first need to scope
	back to the table where that new value resides"
	self query previousQueryObject class = SqSQueryObject ifTrue: [ 
		self addToWhereBuffer: '= ' , curTableName , '.' , oidField.
		self whereBuffer: self encapsulatedWhere , ' AND '.
		"those tables simply have to added to the query tables, and need no links to other tables"
		self query queryTables add: (SqSQueryTable 
			table: (SqSClassInfo for: self depictedClass) cachedClassTable
			alias: aSuffix
			field: column columnName
			class: self depictedClass)
	].! !

!SqSQueryObject methodsFor: 'error handling' stamp: 'tkow 11/3/2008 16:18'!
sqsNextQueryObject: column 
	| nextType nextQueryClass curTableName nextQuery baseClass suffix |
	nextType := Smalltalk at: column objectClass.
	nextQueryClass := SqSQuery classForType: nextType.
	baseClass := (SqSClassInfo for: self depictedClass) baseClass.
	
	suffix := self query 
		newAliasSuffixForTableName: column tableName
		ofClass: baseClass.
	self sqsJoin: column tableName withSuffix: suffix onColumn: column.
	
	curTableName := column tableName,suffix.
	self whereBuffer: self whereBuffer , curTableName , '.' , column columnName.
	nextQuery := self query newForType: nextType.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery! !

SqSQueryValue subclass: #SqSQueryString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSQueryString methodsFor: 'copying' stamp: 'wh 8/16/2006 19:24'!
, aString
	" The standard is || yet MySQL used CONCAT 
		Impliment the standard here "
	^(self newForType: String) whereBuffer: 
			self encapsulatedWhere,' || ',aString asSqlValueString.! !

!SqSQueryString methodsFor: 'comparing' stamp: 'wh 9/14/2006 14:04'!
beginsWith: aString
	
	^(query newForType: Boolean) whereBuffer: 
			(self encapsulatedWhere),' LIKE "',aString asEscapedSql,'%"'.! !

!SqSQueryString methodsFor: 'comparing' stamp: 'wh 8/16/2006 19:21'!
endsWith: aString
	^(self newForType: Boolean) whereBuffer: 
			self whereBuffer,' LIKE ''%',aString asEscapedSql,''''.! !

!SqSQueryString methodsFor: 'accessing' stamp: 'wh 8/16/2006 19:22'!
size
	"Postgres and MySQL handle this the same way "
	^(self newForType: 'integer') whereBuffer: 
			'CHAR_LENGTH(',self whereBuffer,')'.! !

!SqSQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
< anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '<'! !

!SqSQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
<= anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '<='! !

!SqSQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
= anAttrib 
	anAttrib ifNil: 
		[ ^ self 
			booleanCompair: anAttrib
			with: 'IS' ].
	^ self 
		booleanCompair: anAttrib
		with: '='! !

!SqSQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
> anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '>'! !

!SqSQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
>= anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '>='! !

!SqSQueryValue methodsFor: 'as yet unclassified' stamp: 'wh 8/15/2006 09:59'!
addToWhereBuffer: aString
	
	self whereBuffer: (whereBuffer, ' ', aString).! !

!SqSQueryValue methodsFor: 'converting' stamp: 'wh 8/16/2006 20:52'!
asSqlValueString
	^self encapsulatedWhere.! !

!SqSQueryValue methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:50'!
asString
	^whereBuffer.! !

!SqSQueryValue methodsFor: 'as yet unclassified' stamp: 'tkow 10/30/2008 16:25'!
booleanCompair: anAttrib with: aDbOperator 
	^ self 
		operator: aDbOperator
		returnType: Boolean
		attribute: anAttrib! !

!SqSQueryValue methodsFor: 'accessing' stamp: 'tkow 11/2/2008 21:55'!
depictedClass
	^ depictedClass! !

!SqSQueryValue methodsFor: 'accessing' stamp: 'tkow 11/2/2008 21:55'!
depictedClass: anObject
	depictedClass := anObject! !

!SqSQueryValue methodsFor: 'as yet unclassified' stamp: 'wh 8/16/2006 20:32'!
encapsulatedWhere
	whereBuffer size > 0 ifTrue:[
		^'(',whereBuffer,')'.
	] ifFalse:[
		^''.
	].! !

!SqSQueryValue methodsFor: 'testing' stamp: 'wh 8/15/2006 10:38'!
isNil
	self addToWhereBuffer: 'IS NULL'.! !

!SqSQueryValue methodsFor: 'testing' stamp: 'wh 8/15/2006 10:38'!
notNil
	self addToWhereBuffer: 'IS NOT NULL'.! !

!SqSQueryValue methodsFor: 'as yet unclassified' stamp: 'tkow 10/13/2008 19:00'!
operator: aChar returnType: aType attribute: anAttrib

	| comp |
	comp := (anAttrib respondsTo: #asSqlValueString) ifTrue: [
		(anAttrib asSqlValueString)		
	] ifFalse: [
		anAttrib oid asSqlValueString
	].

	^(query newForType: aType) whereBuffer:
			whereBuffer,' ',aChar,' ',comp.
	! !

!SqSQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:41'!
query
	^query! !

!SqSQueryValue methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:12'!
query: aQuery
	query := aQuery.
	query currentQueryObject: self.
	self whereBuffer: ''.! !

!SqSQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:57'!
whereBuffer 
	^whereBuffer.
! !

!SqSQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:57'!
whereBuffer: aString
	whereBuffer _ aString.! !

!SqSQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
~= anAttrib 
	anAttrib ifNil: 
		[ ^ self 
			booleanCompair: anAttrib
			with: 'IS NOT' ].
	^ self 
		booleanCompair: anAttrib
		with: '<>'! !

Object subclass: #SqSSchemaImporter
	instanceVariableNames: 'conSpec classPrefix adapter mode tableNames tableColumns classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqSSchemaImporter subclass: #SqSActiveRecordSchemaImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:25'!
automaticMode
	^#auto! !

!SqSSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:04'!
loggingMethods
	^OrderedCollection with: (
		'acceptsLoggingOfCompilation',String cr, String tab, '^ false'
	) with: (
		'wantsChangeSetLogging', String cr, String tab,'^ false'
	)! !

!SqSSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:26'!
onConSpec: sqsConSpec withPrefix: aString
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: self safeMode;
		yourself! !

!SqSSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:26'!
onConSpec: sqsConSpec withPrefix: aString inMode: aMode
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: aMode;
		yourself! !

!SqSSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:41'!
onConSpec: sqsConSpec withPrefix: aString inMode: aMode withCategoryName: aString2
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: aMode;
		classCategory: aString2;
		yourself! !

!SqSSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:24'!
safeMode
	^#safe! !

!SqSSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:23'!
testMode
	^#test! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 14:59'!
adapter
	adapter ifNil: [
		adapter := SqSConnectionManager getInstance adapterForConnectionSpecification: self conSpec.	
	].
	^ adapter! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
adapter: anObject
	adapter := anObject! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/21/2008 09:50'!
classCategory
	^ classCategory ifNil: [
		self classPrefix, '-Models'
	]! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/21/2008 09:49'!
classCategory: anObject
	classCategory := anObject! !

!SqSSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:01'!
classNameForTable: tableName
	^(self classPrefix), ((tableName camelized allButLast: 1) capitalized)! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
classPrefix
	^ classPrefix! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
classPrefix: anObject
	classPrefix := anObject! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
conSpec
	^ conSpec! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
conSpec: anObject
	conSpec := anObject! !

!SqSSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:15'!
createClass: className withInstVars: instVars
	"That's basically it - just create the class if it does not exist"
	
	Transcript show: ((instVars join: ' '), String cr).
	
	Smalltalk at: className asSymbol ifAbsent: [
		Object subclass: className asSymbol
			instanceVariableNames: (instVars join: ' ')
			classVariableNames: ''
			poolDictionaries: ''
			category: self classCategory	
	].
	self specialClassMethods: self class loggingMethods for: className asSymbol.
	! !

!SqSSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:19'!
createClassForTable: tableName
	| instVars className curColumns |
	curColumns := self adapter showFieldsOfTable: tableName.
	instVars := self instVarsFromColumns: curColumns.
	className := self classNameForTable: tableName.
	self createClass: className withInstVars: instVars.! !

!SqSSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:37'!
disableClassLogging
	^self mode = self class testMode
	
	
	! !

!SqSSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:15'!
import
	| |
	self tableNames: self adapter allTableNames.
	Transcript show: ('Found ',tableNames size asString, 'tables', String cr).
	self tableNames doWithIndex: [:tableName :index | 
		self createClassForTable: tableName.
		Transcript show: 'Created class no. ', index asString, 'for table ', tableName, String cr.
	].
	"self createDescriptions."! !

!SqSSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:42'!
instVarsFromColumns: curColumns
	| colName type isPrimary defaultValue instVars |
	
	instVars := Set new.
	
	curColumns do: [:row | 
		colName := row at: self adapter class fieldNameColumn.
		type := (row at: self adapter class typeColumn) asString.
		isPrimary := row at: self adapter class keyColumn.
		defaultValue := row at: self adapter class defaultColumn.
		(self isIdField: colName) ifTrue: [
			
		].
		instVars add: colName camelized.
	].

	^ instVars! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:25'!
mode
	^ mode! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:25'!
mode: anObject
	mode := anObject! !

!SqSSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:18'!
specialClassMethods: anArrayOfMethodBodies for: className
	| klass |
	self disableClassLogging ifTrue: [
		klass := Smalltalk at: className.
		(anArrayOfMethodBodies ifNil: [self class loggingMethods]) do: [:methodBody |
			klass compile: methodBody classified: 'auto-generated'
		]		
	].
	
	
	! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:45'!
tableColumns
	^ tableColumns! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:45'!
tableColumns: anObject
	tableColumns := anObject! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:46'!
tableNames
	^ tableNames! !

!SqSSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:46'!
tableNames: anObject
	tableNames := anObject! !

Object subclass: #SqSSearch
	instanceVariableNames: 'searchClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSSearch class methodsFor: 'error handling' stamp: 'tkow 12/4/2008 10:19'!
doesNotUnderstand: aMessage
	| attributes limit |
	attributes := self findAttributesInSelector: aMessage selector.
	attributes ifNil: [
		^super doesNotUnderstand: aMessage.
	] ifNotNil: [
		limit := self findLimitInSelector: aMessage selector.
		^(SqSSearch for: self) searchBy: attributes withValues: (aMessage arguments) limit: limit.
	].
	
	! !

!SqSSearch class methodsFor: 'error handling' stamp: 'tkow 12/4/2008 10:11'!
findAttributesInSelector: aSelector
	| finderMethod all startWord attributes |
	
	finderMethod := aSelector prefixMatchesRegex: 'find[[:alpha:]]*By'.
	finderMethod ifTrue: [
		all := aSelector prefixMatchesRegex: 'findAllBy[[:upper:]]+'.
		startWord := all ifTrue:['findAllBy'] ifFalse: [	startWord := 'findBy'].
		attributes := self findAttributesInSelector: aSelector beginWith: startWord.
	].
	^ attributes! !

!SqSSearch class methodsFor: 'searching' stamp: 'tkow 10/6/2008 11:01'!
findAttributesInSelector: aSelector beginWith: aString
	| elements searchedAttributes attrName |
	elements := aSelector subStrings: ':'.
	searchedAttributes := OrderedCollection new.
	elements at: 1 put: ((elements first) allButFirst: (aString size)).
	elements do:[ :el |
		attrName := el.
		(el beginsWith: 'and') ifTrue:[attrName := el allButFirst: 3].
		attrName := attrName withFirstCharacterDownshifted.
		((self allInstVarNames includes: attrName) or: [attrName = self searchForIdField]) ifTrue: [
			searchedAttributes add: attrName.	
		] ifFalse: [			
			^nil
		]
	].
	^searchedAttributes! !

!SqSSearch class methodsFor: 'error handling' stamp: 'tkow 12/4/2008 10:14'!
findLimitInSelector: aSelector
	| limit |
	limit := nil.
	(aSelector prefixMatchesRegex: 'findAllBy[[:upper:]]+') ifFalse: [
		limit := 1.	
	].
	^ limit
	
	! !

!SqSSearch class methodsFor: 'access to cache' stamp: 'tkow 9/24/2008 13:49'!
for: aClass
	^(self new)
		searchClass: aClass;
		yourself! !

!SqSSearch class methodsFor: 'constants' stamp: 'tkow 11/4/2008 17:50'!
searchForIdField
	^'oid'! !

!SqSSearch methodsFor: 'block-searching' stamp: 'tkow 10/13/2008 16:48'!
anySatisfy: aBlock
	self detect: aBlock ifNone: [^false].
	^true! !

!SqSSearch methodsFor: 'value-searching' stamp: 'tkow 10/14/2008 11:12'!
detect: aBlock 
	| |
	^self detect: aBlock ifNone: [self error: 'no results found']
	
	
	
! !

!SqSSearch methodsFor: 'value-searching' stamp: 'tkow 11/3/2008 10:22'!
detect: aBlock ifNone: errorBlock
	| query results |
	"we could somehow rty to leave out the objects we already have locally
	 but for now we'll query them anyway because they won't be instantiated 
	 again anyways"
	query := (SqSQuery on: self searchClass) analyze: aBlock.
	results := self connection performSearch: query withLimit: 1.
	^results ifEmpty: [errorBlock value].

	
	
	
! !

!SqSSearch methodsFor: 'as yet unclassified' stamp: 'tkow 12/4/2008 10:37'!
doesNotUnderstand: aMessage
	| attributes limit |
	attributes := self class findAttributesInSelector: aMessage selector.
	attributes ifNil: [
		^super doesNotUnderstand: aMessage.
	] ifNotNil: [
		limit := self class findLimitInSelector: aMessage selector.
		^self searchBy: attributes withValues: (aMessage arguments) limit: limit.
	].! !

!SqSSearch methodsFor: 'value-searching' stamp: 'tkow 9/24/2008 14:21'!
findAllBy: attributeName withValues: anObject
	| |
	^self 
		searchBy: (OrderedCollection with: attributeName) 
		withValues: (OrderedCollection with: anObject)
		limit: nil

	! !

!SqSSearch methodsFor: 'value-searching' stamp: 'tkow 11/11/2008 13:32'!
findBy: attributeName withValues: anObject
	| results |

	results := self 
		searchBy: (OrderedCollection with: attributeName) 
		withValues: (OrderedCollection with: anObject)
		limit: 1.
	^results isCollection ifTrue: [
		results at: 1 ifAbsent: [nil]	
	] ifFalse: [
		results
	]! !

!SqSSearch methodsFor: 'value-searching' stamp: 'tkow 11/11/2008 13:26'!
searchBy: attributes withValues: values limit: anInteger 
	| base query result |
	base := SqSStorage for: self searchClass new.
	^ base tableForClassExists 
		ifTrue: [ 
			query := (SqSQuery new on: self searchClass) analyze: [:anObject | (anObject perform: attributes first asSymbol) = values first].
			result := base sqSaveDbAdapter performSearch: query.
			anInteger ifNil: [
				result	
			] ifNotNil: [
				(anInteger = 1) ifTrue: [
					result at: 1 ifAbsent: [nil]
				] ifFalse: [
					(anInteger < result size) ifTrue: [
						result copyFrom: 1 to: anInteger	
					] ifFalse: [
						result
					]
				]
			]
		]
		ifFalse: 
			[ #() ]! !

!SqSSearch methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:07'!
searchClass
	^ searchClass! !

!SqSSearch methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:07'!
searchClass: anObject
	searchClass := anObject! !

!SqSSearch methodsFor: 'value-searching' stamp: 'tkow 11/3/2008 10:26'!
select: aBlock
	| query results |
	"we could somehow rty to leave out the objects we already have locally
	 but for now we'll query them anyway because they won't be instantiated 
	 again anyways"
	query := (SqSQuery on: self searchClass) analyze: aBlock.
	results := self connection performSearch: query.
	^results
	
	
	
! !

SqSSearch subclass: #SqSaveTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething testBool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveTestObject class methodsFor: 'compiling' stamp: 'tk 8/25/2008 12:03'!
acceptsLoggingOfCompilation
	^false! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
sqsConfiguration
	^ SqSConfiguration new descriptionHandlerClass: SqSStandardExternDescriptionHandler;
		 collectionConfiguration: (SqSCollectionConfiguration new valueField: 'value';
			 orderedCollections: true;
			 orderField: 'sqs_order_number';
			 nilValue: 0;
			 yourself);
		 tableConfiguration: (SqSTableConfiguration new inheritanceMode: #classTableInheritance;
			 typeField: 'type';
			 idField: 'id';
			 yourself);
		 mode: #development;
		 useInstVarAccessors: true;
		 objectCaching: #global;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
tableInheritance
	^ #classTableInheritance! !

!SqSaveTestObject class methodsFor: 'compiling' stamp: ''!
wantsChangeSetLogging
	^ false! !

!SqSaveTestObject methodsFor: 'comparing' stamp: ''!
= t1 
	self class instVarNames
		do: [:t2 | (self instVarNamed: t2)
					= (t1 instVarNamed: t2)
				ifFalse: [^ false]].
	^ true! !

!SqSaveTestObject methodsFor: 'accessing' stamp: ''!
testBool
	^ testBool! !

!SqSaveTestObject methodsFor: 'accessing' stamp: ''!
testBool: t1 
	testBool := t1! !

!SqSaveTestObject methodsFor: 'accessing' stamp: ''!
testDate
	<type: #dateTime>
	<linkTo: #SqSaveTestObject>
	^ testDate! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate: anObject
	testDate := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger
	^ testInteger! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger: anObject
	testInteger := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething
	^ testSomething! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething: anObject
	testSomething := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString
	^ testString! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString: anObject
	testString := anObject! !

SqSaveTestObject subclass: #SqSaveTestObjectChild
	instanceVariableNames: 'testSubString testUnstoredVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveTestObjectChild class methodsFor: 'magritte-description' stamp: ''!
sqSaveUnpersistedInstVars
	^ #('testUnstoredVariable' )! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString
	^ testSubString! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString: anObject
	testSubString := anObject! !

SqSaveTestObjectChild subclass: #SqSaveTestObjectEvenDeeperChild
	instanceVariableNames: 'testExtremelyDeepSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString
	^ testExtremelyDeepSubString! !

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString: anObject
	testExtremelyDeepSubString := anObject! !

Object subclass: #SqSStorage
	instanceVariableNames: 'storedObject oid classInfo tableStructureHandler descriptionHandler stored adapter'
	classVariableNames: 'InstanceCache ObjectIdCache ObjectCache TableCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSStorage class methodsFor: 'object-caching' stamp: 'tkow 12/4/2008 17:13'!
cacheObject: anObject withOid: oid
	self objectCache cacheObject: anObject withOid: oid.
! !

!SqSStorage class methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:18'!
cachedObjectOfClass: aClass withOid: oid 
	^self objectCache cachedObjectOfClass: aClass withOid: oid! !

!SqSStorage class methodsFor: 'proxy-creation' stamp: 'tkow 12/1/2008 17:17'!
createCollectionProxyFor: ivarName with: anObject in: proxyHolder description: description
	^(anObject class includesBehavior: SqSProxy) 
		ifTrue: [ anObject ]
		ifFalse: 
			[ SqSCollectionProxy 
				for: anObject 
				ofInstVar: ivarName 
				in: proxyHolder
				simpleValues: description simpleValues
			]! !

!SqSStorage class methodsFor: 'proxy-creation' stamp: 'tkow 12/1/2008 17:18'!
createProxyFor: ivarName with: anObject in: proxyHolder
	^(anObject class includesBehavior: SqSProxy) 
		ifTrue: [ anObject ]
		ifFalse: 
			[ SqSProxy 
				for: anObject
				ofInstVar: ivarName
				in: proxyHolder]! !

!SqSStorage class methodsFor: 'cache-flushing' stamp: 'tkow 10/10/2008 14:59'!
flushInstanceCache
	InstanceCache := nil! !

!SqSStorage class methodsFor: 'cache-flushing' stamp: 'tkow 12/4/2008 17:11'!
flushObjectCache
	self objectCache clear.! !

!SqSStorage class methodsFor: 'cache-flushing' stamp: 'tkow 9/24/2008 15:30'!
flushTableCache
	TableCache := nil.! !

!SqSStorage class methodsFor: 'cache-flushing' stamp: 'tkow 9/24/2008 15:10'!
flushTableCacheForConnection: connectionIdentityString 
	self tableCache 
		at: connectionIdentityString
		put: Dictionary new! !

!SqSStorage class methodsFor: 'access to cache' stamp: 'tkow 9/30/2008 16:59'!
for: anObject 
	^(self instanceCacheFor: anObject class)
		at: anObject
		ifAbsentPut: [
			self new
				storedObject: anObject;
				classInfo: (SqSClassInfo for: anObject class);
				yourself
		]	
	! !

!SqSStorage class methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:08'!
instanceCacheFor: aClass
	InstanceCache ifNil: [
		InstanceCache := Dictionary new	
	].
	^ InstanceCache at: aClass name ifAbsentPut: [WeakIdentityKeyDictionary new]! !

!SqSStorage class methodsFor: 'cache-flushing' stamp: 'tkow 12/4/2008 17:22'!
objectCache
	ObjectCache ifNil: [
		ObjectCache := SqSObjectCache new.	
	].
	^ ObjectCache! !

!SqSStorage class methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:22'!
oidFor: anObject
	^ self objectCache oidFor: anObject! !

!SqSStorage class methodsFor: 'cache' stamp: 'tkow 9/18/2008 15:15'!
tableCache
	TableCache ifNil: [
		TableCache := Dictionary new.	
	].
	^TableCache
	! !

!SqSStorage class methodsFor: 'access to cache' stamp: 'tkow 9/30/2008 17:06'!
tableCacheForConnection: connectionIdentityString
	^self tableCache at: connectionIdentityString ifAbsentPut: [Dictionary new].
	! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:35'!
baseClass
	^self classInfo baseClass! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:28'!
classInfo
	^classInfo ! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:26'!
classInfo: anObject
	classInfo := anObject! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 11/21/2008 22:11'!
configuration
	^self classInfo configuration! !

!SqSStorage methodsFor: 'object-persistence' stamp: 'tkow 10/10/2008 11:07'!
createClassDescription
	self descriptionHandler createDescriptions! !

!SqSStorage methodsFor: 'object-persistence' stamp: 'tk 8/28/2008 18:23'!
createRecord
	self tableStructureHandler insertObject.! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:10'!
descriptionHandler
	descriptionHandler ifNil: [
		descriptionHandler := self classInfo descriptionHandlerClass forObject: self
	].
	^descriptionHandler
	! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:17'!
descriptionHandler: anObject
	descriptionHandler := anObject! !

!SqSStorage methodsFor: 'object-persistence' stamp: 'tkow 9/30/2008 14:48'!
destroy
	self oid ifNotNil: [ 
		(SqSTableStructureHandler forObject: self) deleteObject 
	].
	! !

!SqSStorage methodsFor: 'object-information' stamp: 'tkow 9/29/2008 15:29'!
directlyReferencedObjects
	^self descriptionHandler directlyReferencedObjects! !

!SqSStorage methodsFor: 'iterating' stamp: 'tkow 9/30/2008 14:21'!
doForAllSuperclasses: aBlock
	self classInfo doForAllSuperclasses: aBlock! !

!SqSStorage methodsFor: 'object-access' stamp: 'tkow 10/9/2008 16:43'!
escapedValueForInstVar: instVarName 
	| ivarValue objectId |
	" get the current value of the instance variable"
	ivarValue := self valueOfInstVar: instVarName.

	" if an object has an asSqlValueString method, fine - use this
	 the other objects are treated as complex ones and we should already have an oid for them"
	^ (ivarValue respondsTo: #asSqlValueString) 
		ifTrue: [ ivarValue asSqlValueString ]
		ifFalse: 
			[ objectId := self class oidFor: ivarValue.
			objectId 
				ifNil: [ nil asSqlValueString ]
				ifNotNil: [ objectId ] ]! !

!SqSStorage methodsFor: 'object-information' stamp: 'tkow 9/29/2008 15:30'!
indirectlyReferencedObjects
	^self descriptionHandler indirectlyReferencedObjects! !

!SqSStorage methodsFor: 'accessing' stamp: 'tk 6/16/2008 13:35'!
isDirty
	"TODO: enhance me with some sort of check to determine whether an object needs restoring"
	^self newRecord! !

!SqSStorage methodsFor: 'object-information' stamp: 'tk 6/11/2008 15:16'!
lazilyInitializedVariables
	^#()! !

!SqSStorage methodsFor: 'object-access' stamp: 'tkow 9/30/2008 18:06'!
loadProxiedCollectionFor: ivarName
	^self tableStructureHandler loadProxiedCollectionFor: ivarName
	! !

!SqSStorage methodsFor: 'object-access' stamp: 'tkow 9/30/2008 18:03'!
loadProxiedObjectFor: ivarName withOid: anObjectId
	^self tableStructureHandler loadProxiedObjectFor: ivarName withOid: anObjectId
	! !

!SqSStorage methodsFor: 'accessing' stamp: 'tk 5/26/2008 15:18'!
newRecord
	^self oid isNil.! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:29'!
oid
	oid ifNil: [
		oid := self class oidFor: self storedObject.
	].
	^oid! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:30'!
oid: anInteger
	oid := anInteger.
	self class cacheObject: self storedObject withOid: oid.! !

!SqSStorage methodsFor: 'object-persistence' stamp: 'tkow 11/11/2008 13:32'!
save
	"just to avoid circular calls of the save function"
	self stored ifFalse: [
		self stored: true.
		self createClassDescription.
		self classInfo tableForClassExists
			ifTrue: [self tableStructureHandler updateTableStructure]
			ifFalse: [self tableStructureHandler createTableStructure].
		self newRecord
			ifTrue: [self createRecord]
			ifFalse: [self updateRecord].
		self stored: false
	].
! !

!SqSStorage methodsFor: 'object-access' stamp: 'tkow 12/4/2008 16:19'!
setInstVarNamed: ivarName withValue: anObject 
	"only set instvars of ourselves and ignore those of subclasses"
	| object lazy |
	(self storedObject class allInstVarNames includes: ivarName) ifTrue: 
		[ lazy := false.
		"self lazilyInitializedVariables includes: ivarName."
		object := self descriptionHandler 
			adaptObject: anObject
			toSpecificationOfInstVar: ivarName.
		self descriptionHandler useInstVarAccessors 
			ifTrue: 
				[ self storedObject 
					perform: (ivarName , ':') asSymbol
					with: object ]
			ifFalse: 
				[ self storedObject 
					instVarNamed: ivarName
					put: object ] ]! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:00'!
sqSaveDbAdapter
	adapter ifNil: 
		[ adapter := SqSConnectionManager getInstance adapterForClass: self storedObject class ].
	^ adapter! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 10/9/2008 18:46'!
sqSaveDbAdapter: aConnection 
	adapter := aConnection! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 16:35'!
stored
	stored ifNil: [stored := false].
	^stored! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 16:26'!
stored: anObject
	stored := anObject! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:33'!
storedObject
	^ storedObject! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:33'!
storedObject: anObject
	storedObject := anObject! !

!SqSStorage methodsFor: 'object-persistence' stamp: 'tkow 9/30/2008 14:44'!
tableForClassExists
	^self classInfo tableForClassExists! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:19'!
tableStructureHandler
	tableStructureHandler ifNil: [
		tableStructureHandler := SqSTableStructureHandler forObject: self.
	].
	^tableStructureHandler! !

!SqSStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:17'!
tableStructureHandler: anObject
	tableStructureHandler := anObject! !

!SqSStorage methodsFor: 'object-persistence' stamp: 'tk 7/17/2008 15:46'!
updateRecord
	self tableStructureHandler updateObject
	! !

!SqSStorage methodsFor: 'object-access' stamp: 'tkow 10/7/2008 18:46'!
valueOfInstVar: instVarName 
	^(self storedObject class allInstVarNames includes: instVarName) ifTrue: [
		self descriptionHandler useInstVarAccessors 
			ifTrue: [ self storedObject perform: instVarName asSymbol ]
			ifFalse: [ self storedObject instVarNamed: instVarName asSymbol ].
	] ifFalse: [
		nil
	]! !

Object subclass: #SqSTableCache
	instanceVariableNames: 'tableCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:48'!
cacheForClass: aClassName
	^ self tableCache at: aClassName ifAbsentPut: [Dictionary new]! !

!SqSTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/5/2008 21:06'!
classIndex
	^ #classTable! !

!SqSTableCache methodsFor: 'accessing' stamp: 'tkow 12/6/2008 11:16'!
initialize
	super initialize.
	self tableCache: Dictionary new. ! !

!SqSTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:47'!
insertJoinTable: joinTable forClass: aClassName
	| tCache jtCache |
	tCache := self cacheForClass: aClassName.
	jtCache := tCache at: (self joinTableIndex) ifAbsentPut: [Dictionary new].
	jtCache at: joinTable tableName ifAbsentPut: joinTable. ! !

!SqSTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:48'!
insertTable: classTable forClass: aClassName
	| tCache |
	tCache := self cacheForClass: aClassName.
	tCache at: (self classIndex) put: classTable.! !

!SqSTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 11:20'!
joinTableIndex
	^ #joinTables! !

!SqSTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:48'!
joinTableNamed: aName forClass: aClassName
	| tCache jCache |
	tCache := self cacheForClass: aClassName.
	jCache := tCache at: (self joinTableIndex) ifAbsentPut: [Dictionary new].
	^ jCache at: aName ifAbsent: [nil]! !

!SqSTableCache methodsFor: 'accessing' stamp: 'tkow 12/5/2008 21:01'!
tableCache
	^ tableCache! !

!SqSTableCache methodsFor: 'accessing' stamp: 'tkow 12/5/2008 21:01'!
tableCache: anObject
	tableCache := anObject! !

!SqSTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:48'!
tableForClass: aClassName
	^(self cacheForClass: aClassName) 
		at: (self classIndex)
		ifAbsent: [nil]! !

Object subclass: #SqSTableChanges
	instanceVariableNames: 'oldTable newTable addedColumns removedColumns alteredColumns renamedColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSTableChanges class methodsFor: 'as yet unclassified' stamp: 'tkow 10/9/2008 11:29'!
oldTable: anSqSTable newTable: anotherSqSTable
	^self new
		oldTable: anSqSTable;
		newTable: anotherSqSTable;
		yourself! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
addedColumns
	^ addedColumns! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
addedColumns: anObject
	addedColumns := anObject! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
alteredColumns
	^ alteredColumns! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
alteredColumns: anObject
	alteredColumns := anObject! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:53'!
calculateChanges
	| oldColumns newColumns |
	oldColumns := self oldTable columns.
	newColumns := self newTable columns.
	oldColumns do: [ :oldColumn | 
		| curColumn |
		curColumn := newColumns detect: [:col | col linkedVariable = oldColumn linkedVariable] ifNone: [nil].
		curColumn ifNil: [ 
			self removedColumns add: oldColumn
		] ifNotNil: [ 
			curColumn columnName ~= oldColumn columnName ifTrue: [ 
				self renamedColumns add: (OrderedCollection 
					with: oldColumn
					with: curColumn) 
			].
			(curColumn sqlType ~= oldColumn sqlType and: [ curColumn sqlType isNil not ]) ifTrue: [ 
				self alteredColumns add: curColumn 
			] 
		] 
	].
	self addedColumns addAll: (newColumns select: [ :newColumn | 
		(oldColumns anySatisfy: [:oldColumn | oldColumn linkedVariable = newColumn linkedVariable]) not 
	]).! !

!SqSTableChanges methodsFor: 'initialization' stamp: 'tkow 10/9/2008 11:21'!
initialize
	super initialize.
	addedColumns := OrderedCollection new.
	alteredColumns := OrderedCollection new.
	removedColumns := OrderedCollection new.
	renamedColumns := OrderedCollection new.! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
newTable
	^ newTable! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
newTable: anObject
	newTable := anObject! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 14:46'!
newTableName
	^(self oldTable tableName ~= self newTable tableName) ifTrue: [
		self newTable tableName
	] ifFalse: [
		nil
	]! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
oldTable
	^ oldTable! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
oldTable: anObject
	oldTable := anObject! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
removedColumns
	^ removedColumns! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
removedColumns: anObject
	removedColumns := anObject! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
renamedColumns
	^ renamedColumns! !

!SqSTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
renamedColumns: anObject
	renamedColumns := anObject! !

Object subclass: #SqSTableConfiguration
	instanceVariableNames: 'inheritanceMode typeField idField tableName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqSTableConfiguration class methodsFor: 'presets' stamp: 'tkow 11/7/2008 15:16'!
activeRecordStyle
	^self new
		typeField: 'type';
		idField: 'id';
		inheritanceMode: SqSTableStructureHandler singleTableInheritance;
		yourself! !

!SqSTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:09'!
standardIdField
	^'sqs_oid'! !

!SqSTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:10'!
standardInheritanceMode
	^ SqSTableStructureHandler singleTableInheritance! !

!SqSTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:09'!
standardTypeField
	^'sqs_type_field'! !

!SqSTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
idField
	^ idField! !

!SqSTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
idField: anObject
	idField := anObject! !

!SqSTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
inheritanceMode
	^ inheritanceMode! !

!SqSTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
inheritanceMode: anObject
	inheritanceMode := anObject! !

!SqSTableConfiguration methodsFor: 'as yet unclassified' stamp: 'tkow 11/7/2008 15:06'!
initialize
	super initialize.
	self idField: self class standardIdField.
	self inheritanceMode: self class standardInheritanceMode.
	self typeField: self class standardTypeField.! !

!SqSTableConfiguration methodsFor: 'as yet unclassified' stamp: 'tkow 11/7/2008 17:02'!
storeOn: aStream
	aStream nextPutAll: self sqsCodeForObjectCreation! !

!SqSTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:07'!
tableName
	^ tableName! !

!SqSTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:07'!
tableName: anObject
	tableName := anObject! !

!SqSTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
typeField
	^ typeField! !

!SqSTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
typeField: anObject
	typeField := anObject! !

Object subclass: #SqSTableLink
	instanceVariableNames: 'joinDirection fromFields toFields toTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqSTableLink class methodsFor: 'as yet unclassified' stamp: 'tkow 11/25/2008 13:12'!
table: aTable fromField: aString toField: anotherString direction: joinSql
	| instance |
	instance := self new
		toTable: aTable;
		joinDirection: joinSql;
		yourself.
		
	instance fromFields add: aString.
	instance toFields add: anotherString.
	^ instance! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
fromFields
	^ fromFields! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
fromFields: anObject
	fromFields := anObject! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:23'!
initialize
	super initialize.
	self fromFields: OrderedCollection new.
	self toFields: OrderedCollection new.! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
joinDirection
	^ joinDirection! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
joinDirection: anObject
	joinDirection := anObject! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
toFields
	^ toFields! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
toFields: anObject
	toFields := anObject! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
toTable
	^ toTable! !

!SqSTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
toTable: anObject
	toTable := anObject! !

Object subclass: #SqSTableStructureHandler
	instanceVariableNames: 'currentObject classInfo'
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqSTableStructureHandler subclass: #SqSClassTableInheritanceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 10/21/2008 17:42'!
classTable
	| table |
	table := self tableForClassInfo: self classInfo.
	self createParentsForTable: table ofClass: self classInfo.
	self createChildrenForTable: table ofClass: self classInfo.
	^table
! !

!SqSClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 10/21/2008 17:17'!
createChildrenForTable: table ofClass: baseInfo
	| childInfo childTable |
	baseInfo currentClass subclasses do: [ :subClass |
		childInfo := SqSClassInfo for: subClass.
		childTable := self tableForClassInfo: childInfo.
		childTable parent: table.
		self createChildrenForTable: childTable ofClass: childInfo.
	].! !

!SqSClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 10/21/2008 17:46'!
createParentsForTable: table ofClass: classInf
	| parentInfo parentTable |
	(classInf currentClass ~= classInf baseClass) ifTrue: [
		parentInfo := (SqSClassInfo for: classInf currentClass superclass).
		parentTable := self tableForClassInfo: parentInfo.
		table parent: parentTable.
		self createParentsForTable: parentTable ofClass: parentInfo
	].! !

SqSTableStructureHandler subclass: #SqSSingleTableInheritanceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqSSingleTableInheritanceHandler methodsFor: 'table-operations' stamp: 'test 12/4/2008 10:35'!
classTable
	| table baseClassInfo newColumns |
	baseClassInfo := SqSClassInfo for: self classInfo baseClass.
	table := self tableForClassInfo: baseClassInfo.
	baseClassInfo currentClass allSubclasses do: [:subClass |
		newColumns := (SqSClassInfo for: subClass) classTableColumns.
		table columns addAll: newColumns
	].
	table columns do: [:column | column tableName: table tableName].
	^ table! !

!SqSSingleTableInheritanceHandler methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:14'!
tableName
	^self classInfo baseClass name asSqSaveTableName! !

!SqSTableStructureHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 15:56'!
classTableInheritance
	^#classTableInheritance! !

!SqSTableStructureHandler class methodsFor: 'cache-access' stamp: 'tkow 12/4/2008 18:11'!
clearTableCache
	TableCache := nil.! !

!SqSTableStructureHandler class methodsFor: 'cache-access' stamp: 'tkow 12/4/2008 18:13'!
clearTableCacheFor: aClass
	TableCache at: aClass name put: [Dictionary new]! !

!SqSTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 10/6/2008 18:25'!
forClassInfo: aClassInfo
	| targetClass |
	targetClass := self targetClassForClassInfo: aClassInfo.
	"initialize the table cache (if not already done...)"
	TableCache ifNil: [TableCache := Dictionary new].
	^ targetClass new 
		classInfo: aClassInfo;
		yourself! !

!SqSTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 9/30/2008 11:47'!
forObject: anSqSStorageObject 
	| targetClass |
	targetClass := self targetClassForClassInfo: anSqSStorageObject classInfo.
	TableCache ifNil: [TableCache := Dictionary new].
	^ targetClass new 
		currentObject: anSqSStorageObject;
		classInfo: anSqSStorageObject  classInfo;
		yourself! !

!SqSTableStructureHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 15:56'!
singleTableInheritance
	^#singleTableInheritance! !

!SqSTableStructureHandler class methodsFor: 'cache-access' stamp: 'tkow 12/6/2008 15:20'!
tableCache
	^TableCache! !

!SqSTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 10/16/2008 08:03'!
targetClassForClassInfo: classInfo 
	| targetClass |
	targetClass := SqSSingleTableInheritanceHandler.
	classInfo inheritanceMode = self classTableInheritance ifTrue: [ targetClass := SqSClassTableInheritanceHandler ].
	^ targetClass! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 15:51'!
buildJoinTableObjectFromDescription: collectionDescription 
	| table orderColumn |
	table := SqSTable new
		tableName: collectionDescription joinTableName;
		associatedClass: self currentObject baseClass name.
	
	collectionDescription ownerColumn isPrimaryKey: true.
	table columns add: collectionDescription ownerColumn.
	collectionDescription referenceColumn isPrimaryKey: true.
	table columns add: collectionDescription referenceColumn.
	
	collectionDescription maintainOrder ifTrue: [ 
		orderColumn := SqSColumn new
		columnName: collectionDescription configuration orderField;
		sqlType: collectionDescription indexType;
		isPrimaryKey: true.
		table columns add: orderColumn
	].

	table columns do: [:col |
		col tableName: table tableName
	].
	^ table! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 15:43'!
changesOfClassTable: anSqSTable 
	| oldTable changes |
	oldTable := self tableCache tableForClass: anSqSTable associatedClass.

	oldTable ifNil: [ 
		self createTable: anSqSTable.
	] ifNotNil: [ 
		changes := (SqSTableChanges 
			oldTable: oldTable
			newTable: anSqSTable) calculateChanges 
	].
	^ changes! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 16:56'!
changesOfJoinTable: joinTable 
	| oldTable changes |
	oldTable := self tableCache 
		joinTableNamed: joinTable tableName 
		forClass: self classInfo baseClass name.
	
	oldTable ifNil: [
		self createTable: joinTable.
	] ifNotNil: [
		changes := (SqSTableChanges oldTable: oldTable newTable: joinTable) calculateChanges.
	].
	^changes! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 17:30'!
classInfo
	^classInfo! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 17:26'!
classInfo: anObject 
	classInfo := anObject! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 10/6/2008 17:40'!
classTable
	^self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 10/29/2008 13:12'!
columnValueDictionaryFor: classTable
	| columnValueDictionary |
	columnValueDictionary := Dictionary new.
	classTable columns do: [:column |
		| value |
		value := self currentObject escapedValueForInstVar: column linkedVariable.
		columnValueDictionary at: column columnName put: value.
	].
	^columnValueDictionary! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 15:39'!
createClassTable: anSqSTable
	self createTable: anSqSTable.
	self insertClassTableToCache: anSqSTable.
	anSqSTable children do: [ :childTable | self createClassTable: childTable ].! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/4/2008 18:13'!
createJoinTableFromDescription: collectionDescription 
	| joinTable adapter |
	joinTable := self buildJoinTableObjectFromDescription: collectionDescription.
	adapter := self currentObject sqSaveDbAdapter.
	adapter createTable: joinTable.
	self insertJoinTableToCache: joinTable! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 16:44'!
createTable: anSqSTable 
	| adapter |
	adapter := self currentObject sqSaveDbAdapter.
	adapter createTable: anSqSTable 
! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 15:38'!
createTableStructure
	| table |
	table := self classTable baseTable.
	self createClassTable: table.
	
	self currentObject indirectlyReferencedObjects do: [ :collectionInfo | 
		self createJoinTableFromDescription: (collectionInfo collectionDescription) 
	]! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:05'!
currentObject
	^ currentObject! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:04'!
currentObject: anObject 
	currentObject := anObject! !

!SqSTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 10/9/2008 18:46'!
deleteObject
	^ self currentObject sqSaveDbAdapter 
		removeObjectWithId: self currentObject oid
		fromTable: self classInfo classTable! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 15:35'!
getTableChanges
	| allChanges classTable curChanges |
	allChanges := OrderedCollection new.

	"first collect the change objects for all class tables"
	classTable := self classTable.
	[ curChanges := self changesOfClassTable: classTable.
	curChanges ifNotNil: [ allChanges add: curChanges ].
	self insertClassTableToCache: classTable.
	classTable := classTable parent ] doWhileTrue: [ classTable isNil not ].

	"but also the join tables can change, so we have to take this into account, too"
	self currentObject indirectlyReferencedObjects do: [ :collectionInfo | 
		| joinTable |
		joinTable := self buildJoinTableObjectFromDescription: (collectionInfo collectionDescription).
		curChanges := self changesOfJoinTable: joinTable.
		curChanges ifNotNil: [ allChanges add: curChanges ].
		self insertJoinTableToCache: joinTable ].
	^ allChanges! !

!SqSTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 12/6/2008 15:40'!
insertClassTableToCache: classTable
	| |
	self tableCache insertTable: classTable forClass: classTable associatedClass! !

!SqSTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 11/10/2008 14:58'!
insertCurrentObject
	| baseTable classTable adapter columnDictionary oid |
	classTable := self classInfo classTable.
	baseTable := classTable baseTable.
	adapter := self currentObject sqSaveDbAdapter.
	"first store the data that belongs into the base table along with the type field"
	columnDictionary := self columnValueDictionaryFor: baseTable.
	columnDictionary 
		at: baseTable typeColumn columnName
		put: self currentObject storedObject class name asSqlValueString.
	oid := adapter 
		storeColumns: columnDictionary
		inTable: baseTable tableName
		andReturnOId: true.
	"then walk the inheritance chain up from the real class table and insert those values, too"
	[ classTable = baseTable ] whileFalse: 
		[ columnDictionary := self columnValueDictionaryFor: classTable.
		columnDictionary 
			at: classTable oidColumn columnName
			put: oid asSqlValueString.
		adapter 
			storeColumns: columnDictionary
			inTable: classTable tableName.
		classTable := classTable parent ].
	^ oid! !

!SqSTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 11/21/2008 21:50'!
insertIndirectlyReferencedObject: collectionInformation
	| connection columnDict collectionDescription counter collection |
	connection := self currentObject sqSaveDbAdapter.
	columnDict := Dictionary new.
	collectionDescription := collectionInformation collectionDescription.
	counter := 1.
	collection := collectionInformation collection ifNil: [OrderedCollection new].
	collection do: 
		[ :obj | 
		| index |
		collection isDictionary 
			ifTrue: [ index := collection keyAtValue: obj ]
			ifFalse: [ index := counter ].
		columnDict := Dictionary new.
		columnDict 
			at: collectionDescription referenceColumn columnName
			put: (self 
					valueForObject: obj
					ofCollectionDescribedBy: collectionDescription).
		columnDict 
			at: collectionDescription ownerColumn columnName
			put: self currentObject oid.
		collectionDescription maintainOrder ifTrue: 
			[ columnDict 
				at: collectionDescription configuration orderField
				put: index asSqlValueString ].
		counter := counter + 1.
		connection 
			storeColumns: columnDict
			inTable: collectionDescription joinTableName ]! !

!SqSTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 12/6/2008 15:47'!
insertJoinTableToCache: anSqSTable
	| |
	self tableCache insertJoinTable: anSqSTable forClass: self classInfo baseClass name.! !

!SqSTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 12/6/2008 10:53'!
insertObject
	"first store all objects that are directly referenced by the main object - i.e.
	one-to-one relations"
	| oid adapter |
	adapter := self currentObject sqSaveDbAdapter.
	self currentObject directlyReferencedObjects
		do: [:obj | obj save: adapter].
	"next store the object itself"
	oid := self insertCurrentObject.
	self currentObject oid: oid.
	"store all objects the sample object holds within one-to-many associations"
	self insertOwnedCollections! !

!SqSTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 12/1/2008 17:31'!
insertOwnedCollections
	| |
	self currentObject indirectlyReferencedObjects do: [ :collectionInfo | 
		self insertIndirectlyReferencedObject: collectionInfo.
		self currentObject 
			setInstVarNamed: collectionInfo collectionDescription linkedVariable 
			withValue: (SqSStorage 
				createCollectionProxyFor: collectionInfo collectionDescription linkedVariable 
				with: collectionInfo collection
				in: self currentObject storedObject
				description: collectionInfo collectionDescription)
	].! !

!SqSTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 12/6/2008 15:35'!
insertToCacheTable: classTable forClass: aClass
	| |
	self tableCache insertTable: classTable forClass: aClass! !

!SqSTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 10/9/2008 18:46'!
loadProxiedCollectionFor: ivarName 
	| descr connection collectionElements |
	descr := self currentObject descriptionHandler sqSaveDescriptionForInstVar: ivarName.
	connection := self currentObject sqSaveDbAdapter.
	collectionElements := connection 
		getCollectionDescribedBy: descr
		forObject: self currentObject.
	^ descr collectionClass withAll: collectionElements! !

!SqSTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 11/4/2008 17:51'!
loadProxiedObjectFor: ivarName withOid: objectId
	| descr |
	descr := self currentObject descriptionHandler sqSaveDescriptionForInstVar: ivarName.
	^(Smalltalk at: descr associatedClass) perform: #findByOid with: objectId! !

!SqSTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 10/10/2008 11:29'!
storeCollectionChanges: collectionChanges withDescription: aDescription 
	| connection oid |
	connection := self currentObject sqSaveDbAdapter.
	oid := self currentObject oid.
	(collectionChanges deletedObjects) ifNotEmpty: 
		[ connection 
			removeEntries: collectionChanges deletedObjects
			fromJoinTable: aDescription
			forOwnerId: oid ].

	"only move the Entries if the order is important"
	(collectionChanges movedObjects isEmpty not and: [ aDescription maintainOrder ]) ifTrue: 
		[ connection 
			moveEntries: collectionChanges movedObjects
			inJoinTable: aDescription
			forOwnerId: oid ].
	collectionChanges addedObjects ifNotEmpty: 
		[ connection 
			addEntries: collectionChanges addedObjects
			inJoinTable: aDescription
			forOwnerId: oid ]! !

!SqSTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 12/6/2008 11:00'!
tableCache
	TableCache ifNil: [
		TableCache := Dictionary new.	
	].
	^ TableCache at: (self classInfo sqSaveDbAdapter connectionIdentityString) ifAbsentPut: [SqSTableCache new]! !

!SqSTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 10/7/2008 17:05'!
tableCacheForClass: aClass
	^TableCache at: aClass name ifAbsentPut: [Dictionary new].
! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 11/10/2008 15:17'!
tableForClassInfo: classInf 
	| table baseTableName oidColumnName typeColumnName adapterClass |
	
	table := classInf cachedClassTable ifNil: [ SqSTable new ].
	table tableName: classInf tableName.
	table structure: self class classTableInheritance.
	table columns: classInf classTableColumns.
	
	oidColumnName := self classInfo configuration tableConfiguration idField.
	typeColumnName := self classInfo configuration tableConfiguration typeField.
	adapterClass := self classInfo sqSaveDbAdapter class.
	
	table columns do: [ :col | col tableName: table tableName ].
	table associatedClass: classInf currentClass name.
	classInf baseClass = classInf currentClass ifTrue: [ 
		table addTypeColumnNamed: typeColumnName.
		table addOidColumnNamed: oidColumnName. 
	] ifFalse: [ 
		baseTableName := (SqSClassInfo for: classInf baseClass) tableName.
		table addLightOidColumnNamed: oidColumnName linkedTo: baseTableName
	].
	classInf cachedClassTable: table.
	^ table! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:14'!
tableName
	^self classInfo currentClass name asSqSaveTableName ! !

!SqSTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 12/1/2008 15:54'!
updateObject
	"store all directly associated objects right now"
	| adapter classTable columnValueDictionary typeField oidField |
	adapter := self currentObject sqSaveDbAdapter.
	oidField := self classInfo configuration tableConfiguration idField.
	typeField := self classInfo configuration tableConfiguration typeField.
	self currentObject directlyReferencedObjects do: [ :obj | obj save: adapter ].
	"the go along for each class table and insert the values into the table"
	classTable := self classInfo classTable.
	
	[ 
	columnValueDictionary := self columnValueDictionaryFor: classTable.
	columnValueDictionary removeKey: typeField ifAbsent: [].
	columnValueDictionary removeKey: oidField ifAbsent: [].
	adapter 
		updateFields: columnValueDictionary
		ofObjectWithId: self currentObject oid
		inTable: classTable.
	classTable := classTable parent ] doWhileTrue: [ classTable isNil not ].
	self updateOwnedCollections! !

!SqSTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 12/1/2008 16:00'!
updateOwnedCollections
	| proxy colChanges descr |
	self currentObject indirectlyReferencedObjects do: 
		[ :collectionInfo | 
		"this object should always be an SqSaveCollectionProxy that 
		knows how the object looked like at the last save"
		proxy := collectionInfo collection ifNil: [ OrderedCollection new ].
		descr := collectionInfo collectionDescription.
		descr simpleValues ifFalse: 
			[ proxy do: [ :collectionObj | collectionObj ifNotNil: [ collectionObj save ] ] ].
		proxy class = SqSCollectionProxy 
			ifTrue: 
				[ colChanges := proxy sqsGetCollectionChanges.
				self 
					storeCollectionChanges: colChanges
					withDescription: descr ]
			ifFalse: 
				[ "some removed the proxy ... bastard ... well, then. 
				drop all objects and insert the collection once again"
				self currentObject sqSaveDbAdapter log: 'proxy removed from object'.
				self currentObject sqSaveDbAdapter 
					deleteEntriesFromJoinTable: descr
					forObjectId: self currentObject oid.
				self insertIndirectlyReferencedObject: collectionInfo ] ]! !

!SqSTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/6/2008 10:51'!
updateTableStructure
	| tableChanges adapter |
	tableChanges := self getTableChanges.
	adapter := self currentObject sqSaveDbAdapter.
	tableChanges do: 
		[ :tableChange | 
		tableChange newTableName ifNotNil: 
			[ adapter 
				renameTable: tableChange oldTable tableName
				to: tableChange newTableName ].
		adapter renameColumns: tableChange renamedColumns.
		adapter alterColumns: tableChange alteredColumns.
		adapter removeColumns: tableChange removedColumns.
		adapter addColumns: tableChange addedColumns ]! !

!SqSTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 12/4/2008 17:25'!
valueForObject: anObject ofCollectionDescribedBy: collectionDescription 
	| connection objectValue |
	connection := self currentObject sqSaveDbAdapter.
	"return the object itself if it is a simple one
	or the oid on complex objects"
	collectionDescription simpleValues 
		ifTrue: [ 
			objectValue := anObject ]
		ifFalse: 
			[ anObject 
				ifNil: [ 
					objectValue := collectionDescription configuration nilValue ]
				ifNotNil: 
					[ anObject save: connection.
					objectValue := anObject oid ] ].
	^ objectValue asSqlValueString! !

Object subclass: #SqSUsageAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #SqSUsageOptimizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #SqSUsageStatistic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #SqSaveTestObjectPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqSaveTestObjectPersistenceDescriptor subclass: #SqSaveTestObjectChildPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveTestObjectChildPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestSubString
	^ SqSColumn new manuallyMaintained: false;
		 columnName: 'test_sub_string';
		 sqlType: #string;
		 objectClass: #ByteString;
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testSubString';
		 yourself! !

!SqSaveTestObjectChildPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestSubString
	^ SqSColumn new manuallyMaintained: false;
		 columnName: 'test_sub_string';
		 sqlType: #string;
		 objectClass: #ByteString;
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testSubString';
		 yourself! !

SqSaveTestObjectChildPersistenceDescriptor subclass: #SqSaveTestObjectEvenDeeperChildPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqSaveTestObjectEvenDeeperChildPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestExtremelyDeepSubString
	^ SqSColumn new manuallyMaintained: false;
		 columnName: 'test_extremely_deep_sub_string';
		 sqlType: #string;
		 objectClass: #ByteString;
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testExtremelyDeepSubString';
		 yourself! !

!SqSaveTestObjectEvenDeeperChildPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestExtremelyDeepSubString
	^ SqSColumn new manuallyMaintained: false;
		 columnName: 'test_extremely_deep_sub_string';
		 sqlType: #string;
		 objectClass: #ByteString;
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testExtremelyDeepSubString';
		 yourself! !

!SqSaveTestObjectPersistenceDescriptor class methodsFor: 'compiling' stamp: 'tkow 10/10/2008 14:17'!
acceptsLoggingOfCompilation
	^false! !

!SqSaveTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestDate
	^ SqSColumn new manuallyMaintained: false;
		 columnName: 'test_date';
		 sqlType: #date;
		 objectClass: #Date;
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testDate';
		 yourself! !

!SqSaveTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestInteger
	^ SqSColumn new manuallyMaintained: false;
		 columnName: 'test_integer';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testInteger';
		 yourself! !

!SqSaveTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestSomething
	^ SqSCollectionDescription new manuallyMaintained: false;
		 collectionClass: OrderedCollection;
		 joinTableName: 'sq_save_test_objects_test_something';
		 ownerColumn: (SqSColumn new manuallyMaintained: false;
			 columnName: 'sq_save_test_object_id';
			 sqlType: #integer;
			 foreignKey: (SqSForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (OrderedCollection new add: 'id';
					 yourself);
				 referencedTable: 'sq_save_test_object_even_deeper_childs';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqSColumn new manuallyMaintained: false;
			 columnName: 'value';
			 sqlType: #integer;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 referenceTableName: 'sq_save_test_objects';
		 configuration: (SqSCollectionConfiguration new valueField: 'value';
			 orderedCollections: true;
			 orderField: 'sqs_order_number';
			 nilValue: 0;
			 yourself);
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #SqSaveTestObject;
		 linkedVariable: 'testSomething';
		 yourself! !

!SqSaveTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestString
	^ SqSColumn new manuallyMaintained: false;
		 columnName: 'test_string';
		 sqlType: #string;
		 objectClass: #ByteString;
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testString';
		 yourself! !

!SqSaveTestObjectPersistenceDescriptor class methodsFor: 'compiling' stamp: ''!
wantsChangeSetLogging
	^ false! !

Object subclass: #StSqueakSaveDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-UsageExamples'!

!StSqueakSaveDatabase commentStamp: 'tkow 9/24/2008 16:51' prior: 0!
A StSqueakSaveDatabase is another database variation for the SWA Seaside Tutorial application.

Instance Variables
!

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 11/11/2008 13:42'!
addTask: aTask toUser: aUser
	aUser addTask: aTask.
	aTask save.
	aUser save.
	^aTask! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 9/24/2008 15:00'!
addUser: aUser
	aUser save.
	^aUser! !

!StSqueakSaveDatabase methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:06'!
connectionFailed
	^ false! !

!StSqueakSaveDatabase methodsFor: 'connection' stamp: 'tkow 9/24/2008 16:05'!
disconnect
	^true! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 9/24/2008 14:37'!
findUserByEmail: anEmail
	^(SqSSearch for: StUser) findBy: #email withValues: anEmail! !

!StSqueakSaveDatabase methodsFor: 'initialization' stamp: 'tkow 11/10/2008 16:49'!
initialize
	| conSpec |
	super initialize.
	conSpec := SqSConnectionSpecification 
		user: 'thomas'
		password: 'test'
		database: 'ToDoApp'.
	SqSConnectionManager getInstance 
		setupConnectionSpecification: conSpec
		for: 'STTutTodoApp'! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 9/24/2008 13:58'!
save: anObject
	anObject save! !

!UndefinedObject methodsFor: '*sqsave' stamp: 'wh 8/10/2006 11:38'!
asSqlValueString
	^'NULL'.! !

!Dictionary methodsFor: '*sqsave' stamp: 'tkow 9/12/2008 17:10'!
keysSelect: aBlock
	| newCollection |

	newCollection := self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each key) ifTrue: [newCollection add: each]].
	^newCollection! !

!Dictionary methodsFor: '*sqsave' stamp: 'tk 8/15/2008 14:55'!
valueJoin: anotherDictionary
	"really joins two dictionaries with collections as values"
	| ownValue mergeValue |
	anotherDictionary associationsDo: [ :assoc |
		(self includesKey: assoc key) ifTrue: [
			ownValue := (self at: assoc key) isCollection ifTrue:[
				self at: assoc key
			] ifFalse: [
				OrderedCollection with: (self at: assoc key)
			].
			mergeValue := (assoc value) isCollection ifTrue:[
				assoc value
			] ifFalse: [
				OrderedCollection with: (assoc value).
			].
			self at: assoc key put: (ownValue union: mergeValue).
		] ifFalse: [
			self at: assoc key put: assoc value
		]
	].
	^self! !

!Date class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:24'!
sqsType
	^#date! !

!Date methodsFor: '*sqsave' stamp: 'wh 3/2/2006 15:23'!
asSqlValueString
	^'''', self yyyymmdd,''''. ! !

!Integer class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:28'!
sqsType
	^#integer ! !

!Integer methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:44'!
asSqlValueString
	^self asString.! !

!Collection methodsFor: '*sqsave' stamp: 'tk 7/14/2008 19:02'!
join: joinString
	| joiner |
	joiner := joinString ifNil:[''] ifNotNil: [joinString].
	^String streamContents: [:s | self asStringOn: s delimiter: joiner]! !

!Boolean class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:27'!
sqsType
	^#boolean! !

!Boolean methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:57'!
asSqlValueString
	self ifTrue:[
		^'TRUE'.
	] ifFalse:[
		^'FALSE'.
	].! !

!Float class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:26'!
sqsType
	^#float! !

!Float methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:46'!
asSqlValueString
	^self asString.! !
